/* exportable.c generated by valac 0.56.18, the Vala compiler
 * generated from exportable.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004,2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 * Copyright (C) 2023 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

static GType seahorse_exportable_get_type_once (void);

/** Helper to know if a given object is exportable */
gboolean
seahorse_exportable_can_export (GObject* object)
{
	gboolean result;
#line 35 "../common/exportable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 36 "../common/exportable.vala"
	if (SEAHORSE_IS_EXPORTABLE (object)) {
#line 55 "exportable.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 37 "../common/exportable.vala"
		_tmp0_ = seahorse_exportable_get_exportable (G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_EXPORTABLE, SeahorseExportable));
#line 37 "../common/exportable.vala"
		_tmp1_ = _tmp0_;
#line 37 "../common/exportable.vala"
		result = _tmp1_;
#line 37 "../common/exportable.vala"
		return result;
#line 66 "exportable.c"
	}
#line 38 "../common/exportable.vala"
	result = FALSE;
#line 38 "../common/exportable.vala"
	return result;
#line 72 "exportable.c"
}

/**
     * Creates a {@link ExportOperation} that will do the actual export of this
     * file.
     */
SeahorseExportOperation*
seahorse_exportable_create_export_operation (SeahorseExportable* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SeahorseExportableIface* _iface_;
#line 45 "../common/exportable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../common/exportable.vala"
	_tmp0_ = seahorse_exportable_get_exportable (self);
#line 45 "../common/exportable.vala"
	_tmp1_ = _tmp0_;
#line 45 "../common/exportable.vala"
	_vala_return_val_if_fail (_tmp1_, "this.exportable", NULL);
#line 45 "../common/exportable.vala"
	_iface_ = SEAHORSE_EXPORTABLE_GET_INTERFACE (self);
#line 45 "../common/exportable.vala"
	if (_iface_->create_export_operation) {
#line 45 "../common/exportable.vala"
		return _iface_->create_export_operation (self);
#line 99 "exportable.c"
	}
#line 45 "../common/exportable.vala"
	return NULL;
#line 103 "exportable.c"
}

gboolean
seahorse_exportable_get_exportable (SeahorseExportable* self)
{
	SeahorseExportableIface* _iface_;
#line 32 "../common/exportable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../common/exportable.vala"
	_iface_ = SEAHORSE_EXPORTABLE_GET_INTERFACE (self);
#line 32 "../common/exportable.vala"
	if (_iface_->get_exportable) {
#line 32 "../common/exportable.vala"
		return _iface_->get_exportable (self);
#line 118 "exportable.c"
	}
#line 32 "../common/exportable.vala"
	return FALSE;
#line 122 "exportable.c"
}

static void
seahorse_exportable_default_init (SeahorseExportableIface * iface,
                                  gpointer iface_data)
{
	/** Returns whether this object is actually exportable */
#line 29 "../common/exportable.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("exportable", "exportable", "exportable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 132 "exportable.c"
}

/**
 * An interface for items that can be exported.
 *
 * To actually export the object, you'll have to call create_export_operation()
 * which can then take care of it (possibly exporting it with other items at
 * the same time).
 */
 G_GNUC_NO_INLINE static GType
seahorse_exportable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseExportableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_exportable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType seahorse_exportable_type_id;
	seahorse_exportable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SeahorseExportable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (seahorse_exportable_type_id, G_TYPE_OBJECT);
	return seahorse_exportable_type_id;
}

GType
seahorse_exportable_get_type (void)
{
	static gsize seahorse_exportable_type_id__once = 0;
	if (g_once_init_enter (&seahorse_exportable_type_id__once)) {
		GType seahorse_exportable_type_id;
		seahorse_exportable_type_id = seahorse_exportable_get_type_once ();
		g_once_init_leave (&seahorse_exportable_type_id__once, seahorse_exportable_type_id);
	}
	return seahorse_exportable_type_id__once;
}

