/* panel-window.c generated by valac 0.56.18, the Vala compiler
 * generated from panel-window.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2023 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Niels De Graef <nielsdegraef@gmail.com>
 */

#include "seahorse-common.h"
#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_PANEL_WINDOW_0_PROPERTY,
	SEAHORSE_PANEL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* seahorse_panel_window_properties[SEAHORSE_PANEL_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SeahorsePanelWindowPrivate {
	AdwHeaderBar* header;
	AdwWindowTitle* window_title;
	AdwToastOverlay* toast_overlay;
	AdwClamp* clamp;
};

static gint SeahorsePanelWindow_private_offset;
static gpointer seahorse_panel_window_parent_class = NULL;

static void seahorse_panel_window_on_panel_notification (SeahorsePanelWindow* self,
                                                  SeahorsePanel* panel,
                                                  AdwToast* toast);
static void _seahorse_panel_window_on_panel_notification_seahorse_panel_notification (SeahorsePanel* _sender,
                                                                               AdwToast* toast,
                                                                               gpointer self);
static void seahorse_panel_window_finalize (GObject * obj);
static GType seahorse_panel_window_get_type_once (void);

static inline gpointer
seahorse_panel_window_get_instance_private (SeahorsePanelWindow* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorsePanelWindow_private_offset);
}

static void
_seahorse_panel_window_on_panel_notification_seahorse_panel_notification (SeahorsePanel* _sender,
                                                                          AdwToast* toast,
                                                                          gpointer self)
{
#line 56 "../common/panel-window.vala"
	seahorse_panel_window_on_panel_notification ((SeahorsePanelWindow*) self, _sender, toast);
#line 80 "panel-window.c"
}

SeahorsePanelWindow*
seahorse_panel_window_construct (GType object_type,
                                 SeahorsePanel* panel,
                                 GtkWindow* parent)
{
	SeahorsePanelWindow * self = NULL;
	AdwClamp* _tmp0_;
	AdwWindowTitle* _tmp1_;
	AdwWindowTitle* _tmp2_;
	GMenuModel* _tmp3_;
	GMenuModel* _tmp4_;
	GSimpleActionGroup* _tmp12_;
	GSimpleActionGroup* _tmp13_;
#line 33 "../common/panel-window.vala"
	g_return_val_if_fail (panel != NULL, NULL);
#line 35 "../common/panel-window.vala"
	self = (SeahorsePanelWindow*) g_object_new (object_type, "transient-for", parent, NULL);
#line 37 "../common/panel-window.vala"
	_tmp0_ = self->priv->clamp;
#line 37 "../common/panel-window.vala"
	adw_clamp_set_child (_tmp0_, (GtkWidget*) panel);
#line 40 "../common/panel-window.vala"
	_tmp1_ = self->priv->window_title;
#line 40 "../common/panel-window.vala"
	g_object_bind_property_with_closures ((GObject*) panel, "title", (GObject*) _tmp1_, "title", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 43 "../common/panel-window.vala"
	_tmp2_ = self->priv->window_title;
#line 43 "../common/panel-window.vala"
	g_object_bind_property_with_closures ((GObject*) panel, "subtitle", (GObject*) _tmp2_, "subtitle", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 47 "../common/panel-window.vala"
	_tmp3_ = seahorse_panel_get_menu (panel);
#line 47 "../common/panel-window.vala"
	_tmp4_ = _tmp3_;
#line 47 "../common/panel-window.vala"
	if (_tmp4_ != NULL) {
#line 118 "panel-window.c"
		GtkMenuButton* menu_button = NULL;
		GtkMenuButton* _tmp5_;
		GtkMenuButton* _tmp6_;
		GtkMenuButton* _tmp7_;
		GMenuModel* _tmp8_;
		GMenuModel* _tmp9_;
		AdwHeaderBar* _tmp10_;
		GtkMenuButton* _tmp11_;
#line 48 "../common/panel-window.vala"
		_tmp5_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 48 "../common/panel-window.vala"
		g_object_ref_sink (_tmp5_);
#line 48 "../common/panel-window.vala"
		menu_button = _tmp5_;
#line 49 "../common/panel-window.vala"
		_tmp6_ = menu_button;
#line 49 "../common/panel-window.vala"
		gtk_menu_button_set_icon_name (_tmp6_, "open-menu-symbolic");
#line 50 "../common/panel-window.vala"
		_tmp7_ = menu_button;
#line 50 "../common/panel-window.vala"
		_tmp8_ = seahorse_panel_get_menu (panel);
#line 50 "../common/panel-window.vala"
		_tmp9_ = _tmp8_;
#line 50 "../common/panel-window.vala"
		gtk_menu_button_set_menu_model (_tmp7_, _tmp9_);
#line 51 "../common/panel-window.vala"
		_tmp10_ = self->priv->header;
#line 51 "../common/panel-window.vala"
		_tmp11_ = menu_button;
#line 51 "../common/panel-window.vala"
		adw_header_bar_pack_start (_tmp10_, (GtkWidget*) _tmp11_);
#line 47 "../common/panel-window.vala"
		_g_object_unref0 (menu_button);
#line 153 "panel-window.c"
	}
#line 54 "../common/panel-window.vala"
	_tmp12_ = seahorse_panel_get_actions (panel);
#line 54 "../common/panel-window.vala"
	_tmp13_ = _tmp12_;
#line 54 "../common/panel-window.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "panel", (GActionGroup*) _tmp13_);
#line 56 "../common/panel-window.vala"
	g_signal_connect_object (panel, "notification", (GCallback) _seahorse_panel_window_on_panel_notification_seahorse_panel_notification, self, 0);
#line 33 "../common/panel-window.vala"
	return self;
#line 165 "panel-window.c"
}

SeahorsePanelWindow*
seahorse_panel_window_new (SeahorsePanel* panel,
                           GtkWindow* parent)
{
#line 33 "../common/panel-window.vala"
	return seahorse_panel_window_construct (SEAHORSE_TYPE_PANEL_WINDOW, panel, parent);
#line 174 "panel-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 60 "../common/panel-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 182 "panel-window.c"
}

static void
seahorse_panel_window_on_panel_notification (SeahorsePanelWindow* self,
                                             SeahorsePanel* panel,
                                             AdwToast* toast)
{
	AdwToastOverlay* _tmp0_;
	AdwToast* _tmp1_;
#line 59 "../common/panel-window.vala"
	g_return_if_fail (self != NULL);
#line 59 "../common/panel-window.vala"
	g_return_if_fail (panel != NULL);
#line 59 "../common/panel-window.vala"
	g_return_if_fail (toast != NULL);
#line 60 "../common/panel-window.vala"
	_tmp0_ = self->priv->toast_overlay;
#line 60 "../common/panel-window.vala"
	_tmp1_ = _g_object_ref0 (toast);
#line 60 "../common/panel-window.vala"
	adw_toast_overlay_add_toast (_tmp0_, _tmp1_);
#line 204 "panel-window.c"
}

static void
seahorse_panel_window_class_init (SeahorsePanelWindowClass * klass,
                                  gpointer klass_data)
{
#line 25 "../common/panel-window.vala"
	seahorse_panel_window_parent_class = g_type_class_peek_parent (klass);
#line 25 "../common/panel-window.vala"
	g_type_class_adjust_private_offset (klass, &SeahorsePanelWindow_private_offset);
#line 25 "../common/panel-window.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_panel_window_finalize;
#line 25 "../common/panel-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/panel-window.ui");
#line 25 "../common/panel-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "header", FALSE, SeahorsePanelWindow_private_offset + G_STRUCT_OFFSET (SeahorsePanelWindowPrivate, header));
#line 25 "../common/panel-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "window_title", FALSE, SeahorsePanelWindow_private_offset + G_STRUCT_OFFSET (SeahorsePanelWindowPrivate, window_title));
#line 25 "../common/panel-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toast_overlay", FALSE, SeahorsePanelWindow_private_offset + G_STRUCT_OFFSET (SeahorsePanelWindowPrivate, toast_overlay));
#line 25 "../common/panel-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clamp", FALSE, SeahorsePanelWindow_private_offset + G_STRUCT_OFFSET (SeahorsePanelWindowPrivate, clamp));
#line 227 "panel-window.c"
}

static void
seahorse_panel_window_instance_init (SeahorsePanelWindow * self,
                                     gpointer klass)
{
#line 25 "../common/panel-window.vala"
	self->priv = seahorse_panel_window_get_instance_private (self);
#line 25 "../common/panel-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 238 "panel-window.c"
}

static void
seahorse_panel_window_finalize (GObject * obj)
{
	SeahorsePanelWindow * self;
#line 25 "../common/panel-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_PANEL_WINDOW, SeahorsePanelWindow);
#line 25 "../common/panel-window.vala"
	G_OBJECT_CLASS (seahorse_panel_window_parent_class)->finalize (obj);
#line 249 "panel-window.c"
}

/**
 * Basically a window that wraps a {@link Seahorse.Panel}
 */
 G_GNUC_NO_INLINE static GType
seahorse_panel_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePanelWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_panel_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePanelWindow), 0, (GInstanceInitFunc) seahorse_panel_window_instance_init, NULL };
	GType seahorse_panel_window_type_id;
	seahorse_panel_window_type_id = g_type_register_static (adw_window_get_type (), "SeahorsePanelWindow", &g_define_type_info, 0);
	SeahorsePanelWindow_private_offset = g_type_add_instance_private (seahorse_panel_window_type_id, sizeof (SeahorsePanelWindowPrivate));
	return seahorse_panel_window_type_id;
}

GType
seahorse_panel_window_get_type (void)
{
	static gsize seahorse_panel_window_type_id__once = 0;
	if (g_once_init_enter (&seahorse_panel_window_type_id__once)) {
		GType seahorse_panel_window_type_id;
		seahorse_panel_window_type_id = seahorse_panel_window_get_type_once ();
		g_once_init_leave (&seahorse_panel_window_type_id__once, seahorse_panel_window_type_id);
	}
	return seahorse_panel_window_type_id__once;
}

