/* panel.c generated by valac 0.56.18, the Vala compiler
 * generated from panel.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2023 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Niels De Graef <nielsdegraef@gmail.com>
 */

#include "seahorse-common.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_PANEL_0_PROPERTY,
	SEAHORSE_PANEL_TITLE_PROPERTY,
	SEAHORSE_PANEL_SUBTITLE_PROPERTY,
	SEAHORSE_PANEL_MENU_PROPERTY,
	SEAHORSE_PANEL_ACTIONS_PROPERTY,
	SEAHORSE_PANEL_NUM_PROPERTIES
};
static GParamSpec* seahorse_panel_properties[SEAHORSE_PANEL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SEAHORSE_PANEL_NOTIFICATION_SIGNAL,
	SEAHORSE_PANEL_NUM_SIGNALS
};
static guint seahorse_panel_signals[SEAHORSE_PANEL_NUM_SIGNALS] = {0};

struct _SeahorsePanelPrivate {
	gchar* _title;
	gchar* _subtitle;
	GMenuModel* _menu;
	GSimpleActionGroup* _actions;
};

static gint SeahorsePanel_private_offset;
static gpointer seahorse_panel_parent_class = NULL;

static GObject * seahorse_panel_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void seahorse_panel_finalize (GObject * obj);
static GType seahorse_panel_get_type_once (void);
static void _vala_seahorse_panel_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_seahorse_panel_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
seahorse_panel_get_instance_private (SeahorsePanel* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorsePanel_private_offset);
}

/** Little helper method */
void
seahorse_panel_simple_notification (SeahorsePanel* self,
                                    const gchar* message)
{
	AdwToast* toast = NULL;
	AdwToast* _tmp0_;
#line 59 "../common/panel.vala"
	g_return_if_fail (self != NULL);
#line 59 "../common/panel.vala"
	g_return_if_fail (message != NULL);
#line 60 "../common/panel.vala"
	_tmp0_ = adw_toast_new (message);
#line 60 "../common/panel.vala"
	toast = _tmp0_;
#line 61 "../common/panel.vala"
	g_signal_emit (self, seahorse_panel_signals[SEAHORSE_PANEL_NOTIFICATION_SIGNAL], 0, toast);
#line 59 "../common/panel.vala"
	_g_object_unref0 (toast);
#line 109 "panel.c"
}

SeahorsePanel*
seahorse_panel_construct (GType object_type)
{
	SeahorsePanel * self = NULL;
#line 26 "../common/panel.vala"
	self = (SeahorsePanel*) g_object_new (object_type, NULL);
#line 26 "../common/panel.vala"
	return self;
#line 120 "panel.c"
}

const gchar*
seahorse_panel_get_title (SeahorsePanel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../common/panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../common/panel.vala"
	_tmp0_ = self->priv->_title;
#line 31 "../common/panel.vala"
	result = _tmp0_;
#line 31 "../common/panel.vala"
	return result;
#line 136 "panel.c"
}

void
seahorse_panel_set_title (SeahorsePanel* self,
                          const gchar* value)
{
	gchar* old_value;
#line 31 "../common/panel.vala"
	g_return_if_fail (self != NULL);
#line 31 "../common/panel.vala"
	old_value = seahorse_panel_get_title (self);
#line 31 "../common/panel.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 150 "panel.c"
		gchar* _tmp0_;
#line 31 "../common/panel.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../common/panel.vala"
		_g_free0 (self->priv->_title);
#line 31 "../common/panel.vala"
		self->priv->_title = _tmp0_;
#line 31 "../common/panel.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_panel_properties[SEAHORSE_PANEL_TITLE_PROPERTY]);
#line 160 "panel.c"
	}
}

const gchar*
seahorse_panel_get_subtitle (SeahorsePanel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../common/panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../common/panel.vala"
	_tmp0_ = self->priv->_subtitle;
#line 36 "../common/panel.vala"
	result = _tmp0_;
#line 36 "../common/panel.vala"
	return result;
#line 177 "panel.c"
}

void
seahorse_panel_set_subtitle (SeahorsePanel* self,
                             const gchar* value)
{
	gchar* old_value;
#line 36 "../common/panel.vala"
	g_return_if_fail (self != NULL);
#line 36 "../common/panel.vala"
	old_value = seahorse_panel_get_subtitle (self);
#line 36 "../common/panel.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 191 "panel.c"
		gchar* _tmp0_;
#line 36 "../common/panel.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../common/panel.vala"
		_g_free0 (self->priv->_subtitle);
#line 36 "../common/panel.vala"
		self->priv->_subtitle = _tmp0_;
#line 36 "../common/panel.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_panel_properties[SEAHORSE_PANEL_SUBTITLE_PROPERTY]);
#line 201 "panel.c"
	}
}

GMenuModel*
seahorse_panel_get_menu (SeahorsePanel* self)
{
	GMenuModel* result;
	GMenuModel* _tmp0_;
#line 43 "../common/panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../common/panel.vala"
	_tmp0_ = self->priv->_menu;
#line 43 "../common/panel.vala"
	result = _tmp0_;
#line 43 "../common/panel.vala"
	return result;
#line 218 "panel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../common/panel.vala"
	return self ? g_object_ref (self) : NULL;
#line 226 "panel.c"
}

void
seahorse_panel_set_menu (SeahorsePanel* self,
                         GMenuModel* value)
{
	GMenuModel* old_value;
#line 43 "../common/panel.vala"
	g_return_if_fail (self != NULL);
#line 43 "../common/panel.vala"
	old_value = seahorse_panel_get_menu (self);
#line 43 "../common/panel.vala"
	if (old_value != value) {
#line 240 "panel.c"
		GMenuModel* _tmp0_;
#line 43 "../common/panel.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 43 "../common/panel.vala"
		_g_object_unref0 (self->priv->_menu);
#line 43 "../common/panel.vala"
		self->priv->_menu = _tmp0_;
#line 43 "../common/panel.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_panel_properties[SEAHORSE_PANEL_MENU_PROPERTY]);
#line 250 "panel.c"
	}
}

GSimpleActionGroup*
seahorse_panel_get_actions (SeahorsePanel* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
#line 50 "../common/panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../common/panel.vala"
	_tmp0_ = self->priv->_actions;
#line 50 "../common/panel.vala"
	result = _tmp0_;
#line 50 "../common/panel.vala"
	return result;
#line 267 "panel.c"
}

void
seahorse_panel_set_actions (SeahorsePanel* self,
                            GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
#line 50 "../common/panel.vala"
	g_return_if_fail (self != NULL);
#line 50 "../common/panel.vala"
	old_value = seahorse_panel_get_actions (self);
#line 50 "../common/panel.vala"
	if (old_value != value) {
#line 281 "panel.c"
		GSimpleActionGroup* _tmp0_;
#line 50 "../common/panel.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../common/panel.vala"
		_g_object_unref0 (self->priv->_actions);
#line 50 "../common/panel.vala"
		self->priv->_actions = _tmp0_;
#line 50 "../common/panel.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_panel_properties[SEAHORSE_PANEL_ACTIONS_PROPERTY]);
#line 291 "panel.c"
	}
}

static GObject *
seahorse_panel_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorsePanel * self;
#line 64 "../common/panel.vala"
	parent_class = G_OBJECT_CLASS (seahorse_panel_parent_class);
#line 64 "../common/panel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../common/panel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_PANEL, SeahorsePanel);
#line 65 "../common/panel.vala"
	gtk_widget_class_set_css_name (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "seahorse-panel");
#line 64 "../common/panel.vala"
	return obj;
#line 313 "panel.c"
}

static void
seahorse_panel_class_init (SeahorsePanelClass * klass,
                           gpointer klass_data)
{
#line 26 "../common/panel.vala"
	seahorse_panel_parent_class = g_type_class_peek_parent (klass);
#line 26 "../common/panel.vala"
	g_type_class_adjust_private_offset (klass, &SeahorsePanel_private_offset);
#line 26 "../common/panel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_panel_get_property;
#line 26 "../common/panel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_panel_set_property;
#line 26 "../common/panel.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_panel_constructor;
#line 26 "../common/panel.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_panel_finalize;
#line 332 "panel.c"
	/**
	     * The title for this panel, usually the label of the item being shown
	     */
#line 26 "../common/panel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PANEL_TITLE_PROPERTY, seahorse_panel_properties[SEAHORSE_PANEL_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 338 "panel.c"
	/**
	     * The optional subtitle for this panel, for example a longer description
	     */
#line 26 "../common/panel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PANEL_SUBTITLE_PROPERTY, seahorse_panel_properties[SEAHORSE_PANEL_SUBTITLE_PROPERTY] = g_param_spec_string ("subtitle", "subtitle", "subtitle", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 344 "panel.c"
	/**
	     * An optional menu model that can be exposed to the user (for example as a
	     * menu button in a header bar). Note that by convention, we'll use the
	     * "panel" prefix for actions.
	     */
#line 26 "../common/panel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PANEL_MENU_PROPERTY, seahorse_panel_properties[SEAHORSE_PANEL_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 352 "panel.c"
	/**
	     * An action group that is exported by the panel so it can be used for
	     * example in the menu model expose by the menu property.
	     */
#line 26 "../common/panel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PANEL_ACTIONS_PROPERTY, seahorse_panel_properties[SEAHORSE_PANEL_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 359 "panel.c"
	/**
	     * Fired if the parent wrapper should show a notification
	     */
#line 26 "../common/panel.vala"
	seahorse_panel_signals[SEAHORSE_PANEL_NOTIFICATION_SIGNAL] = g_signal_new ("notification", SEAHORSE_TYPE_PANEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, adw_toast_get_type ());
#line 365 "panel.c"
}

static void
seahorse_panel_instance_init (SeahorsePanel * self,
                              gpointer klass)
{
	gchar* _tmp0_;
	GSimpleActionGroup* _tmp1_;
#line 26 "../common/panel.vala"
	self->priv = seahorse_panel_get_instance_private (self);
#line 31 "../common/panel.vala"
	_tmp0_ = g_strdup ("");
#line 31 "../common/panel.vala"
	self->priv->_title = _tmp0_;
#line 36 "../common/panel.vala"
	self->priv->_subtitle = NULL;
#line 43 "../common/panel.vala"
	self->priv->_menu = NULL;
#line 49 "../common/panel.vala"
	_tmp1_ = g_simple_action_group_new ();
#line 49 "../common/panel.vala"
	self->priv->_actions = _tmp1_;
#line 388 "panel.c"
}

static void
seahorse_panel_finalize (GObject * obj)
{
	SeahorsePanel * self;
#line 26 "../common/panel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_PANEL, SeahorsePanel);
#line 31 "../common/panel.vala"
	_g_free0 (self->priv->_title);
#line 36 "../common/panel.vala"
	_g_free0 (self->priv->_subtitle);
#line 43 "../common/panel.vala"
	_g_object_unref0 (self->priv->_menu);
#line 49 "../common/panel.vala"
	_g_object_unref0 (self->priv->_actions);
#line 26 "../common/panel.vala"
	G_OBJECT_CLASS (seahorse_panel_parent_class)->finalize (obj);
#line 407 "panel.c"
}

/**
 * A Panel is the basic widget that is meant to be used for showing information
 * of a specific item in Seahorse. It can then be either integrated in some
 * component, or wrapped around with a simple window.
 */
 G_GNUC_NO_INLINE static GType
seahorse_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePanel), 0, (GInstanceInitFunc) seahorse_panel_instance_init, NULL };
	GType seahorse_panel_type_id;
	seahorse_panel_type_id = g_type_register_static (gtk_widget_get_type (), "SeahorsePanel", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	SeahorsePanel_private_offset = g_type_add_instance_private (seahorse_panel_type_id, sizeof (SeahorsePanelPrivate));
	return seahorse_panel_type_id;
}

GType
seahorse_panel_get_type (void)
{
	static gsize seahorse_panel_type_id__once = 0;
	if (g_once_init_enter (&seahorse_panel_type_id__once)) {
		GType seahorse_panel_type_id;
		seahorse_panel_type_id = seahorse_panel_get_type_once ();
		g_once_init_leave (&seahorse_panel_type_id__once, seahorse_panel_type_id);
	}
	return seahorse_panel_type_id__once;
}

static void
_vala_seahorse_panel_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	SeahorsePanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_PANEL, SeahorsePanel);
#line 26 "../common/panel.vala"
	switch (property_id) {
#line 26 "../common/panel.vala"
		case SEAHORSE_PANEL_TITLE_PROPERTY:
#line 26 "../common/panel.vala"
		g_value_set_string (value, seahorse_panel_get_title (self));
#line 26 "../common/panel.vala"
		break;
#line 26 "../common/panel.vala"
		case SEAHORSE_PANEL_SUBTITLE_PROPERTY:
#line 26 "../common/panel.vala"
		g_value_set_string (value, seahorse_panel_get_subtitle (self));
#line 26 "../common/panel.vala"
		break;
#line 26 "../common/panel.vala"
		case SEAHORSE_PANEL_MENU_PROPERTY:
#line 26 "../common/panel.vala"
		g_value_set_object (value, seahorse_panel_get_menu (self));
#line 26 "../common/panel.vala"
		break;
#line 26 "../common/panel.vala"
		case SEAHORSE_PANEL_ACTIONS_PROPERTY:
#line 26 "../common/panel.vala"
		g_value_set_object (value, seahorse_panel_get_actions (self));
#line 26 "../common/panel.vala"
		break;
#line 471 "panel.c"
		default:
#line 26 "../common/panel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../common/panel.vala"
		break;
#line 477 "panel.c"
	}
}

static void
_vala_seahorse_panel_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	SeahorsePanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_PANEL, SeahorsePanel);
#line 26 "../common/panel.vala"
	switch (property_id) {
#line 26 "../common/panel.vala"
		case SEAHORSE_PANEL_TITLE_PROPERTY:
#line 26 "../common/panel.vala"
		seahorse_panel_set_title (self, g_value_get_string (value));
#line 26 "../common/panel.vala"
		break;
#line 26 "../common/panel.vala"
		case SEAHORSE_PANEL_SUBTITLE_PROPERTY:
#line 26 "../common/panel.vala"
		seahorse_panel_set_subtitle (self, g_value_get_string (value));
#line 26 "../common/panel.vala"
		break;
#line 26 "../common/panel.vala"
		case SEAHORSE_PANEL_MENU_PROPERTY:
#line 26 "../common/panel.vala"
		seahorse_panel_set_menu (self, g_value_get_object (value));
#line 26 "../common/panel.vala"
		break;
#line 26 "../common/panel.vala"
		case SEAHORSE_PANEL_ACTIONS_PROPERTY:
#line 26 "../common/panel.vala"
		seahorse_panel_set_actions (self, g_value_get_object (value));
#line 26 "../common/panel.vala"
		break;
#line 515 "panel.c"
		default:
#line 26 "../common/panel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../common/panel.vala"
		break;
#line 521 "panel.c"
	}
}

