/* passphrase-prompt.c generated by valac 0.56.18, the Vala compiler
 * generated from passphrase-prompt.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2004 - 2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */
/* TODO move these into a namespace or class*/

#include "seahorse-common.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <adwaita.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_PASSPHRASE_PROMPT_0_PROPERTY,
	SEAHORSE_PASSPHRASE_PROMPT_CONFIRM_PROPERTY,
	SEAHORSE_PASSPHRASE_PROMPT_NUM_PROPERTIES
};
static GParamSpec* seahorse_passphrase_prompt_properties[SEAHORSE_PASSPHRASE_PROMPT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _SeahorsePassphrasePromptPromptData SeahorsePassphrasePromptPromptData;

struct _SeahorsePassphrasePromptPrivate {
	gboolean _confirm;
	GtkPasswordEntry* pass_entry;
	GtkPasswordEntry* confirm_entry;
	GtkLabel* confirm_label;
	GtkCheckButton* check_option;
	GtkLabel* error_label;
};

struct _SeahorsePassphrasePromptPromptData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorsePassphrasePrompt* self;
	GtkWidget* parent;
	GCancellable* cancellable;
	gchar* result;
	gchar* response;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkPasswordEntry* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
};

static gint SeahorsePassphrasePrompt_private_offset;
static gpointer seahorse_passphrase_prompt_parent_class = NULL;

static gchar* seahorse_passphrase_prompt_utf8_validate (const gchar* text);
static void seahorse_passphrase_prompt_prompt_data_free (gpointer _data);
static gboolean seahorse_passphrase_prompt_prompt_co (SeahorsePassphrasePromptPromptData* _data_);
static void seahorse_passphrase_prompt_prompt_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void seahorse_passphrase_prompt_on_pass_entry_activate (SeahorsePassphrasePrompt* self,
                                                        GtkWidget* widget);
static void seahorse_passphrase_prompt_try_submit (SeahorsePassphrasePrompt* self);
static void _seahorse_passphrase_prompt_on_pass_entry_activate_gtk_password_entry_activate (GtkPasswordEntry* _sender,
                                                                                     gpointer self);
static void seahorse_passphrase_prompt_on_confirm_entry_activate (SeahorsePassphrasePrompt* self,
                                                           GtkWidget* widget);
static void _seahorse_passphrase_prompt_on_confirm_entry_activate_gtk_password_entry_activate (GtkPasswordEntry* _sender,
                                                                                        gpointer self);
static gboolean seahorse_passphrase_prompt_ok (SeahorsePassphrasePrompt* self);
static void seahorse_passphrase_prompt_on_entry_changed (SeahorsePassphrasePrompt* self,
                                                  GtkEditable* editable);
static void _seahorse_passphrase_prompt_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                        gpointer self);
static void seahorse_passphrase_prompt_finalize (GObject * obj);
static GType seahorse_passphrase_prompt_get_type_once (void);
static void _vala_seahorse_passphrase_prompt_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_seahorse_passphrase_prompt_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static inline gpointer
seahorse_passphrase_prompt_get_instance_private (SeahorsePassphrasePrompt* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorsePassphrasePrompt_private_offset);
}

SeahorsePassphrasePrompt*
seahorse_passphrase_prompt_construct (GType object_type,
                                      const gchar* title,
                                      const gchar* description,
                                      const gchar* prompt,
                                      const gchar* check,
                                      gboolean confirm)
{
	SeahorsePassphrasePrompt * self = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GtkPasswordEntry* _tmp6_;
#line 41 "../common/passphrase-prompt.vala"
	_tmp1_ = seahorse_passphrase_prompt_utf8_validate (title);
#line 41 "../common/passphrase-prompt.vala"
	_tmp0_ = _tmp1_;
#line 41 "../common/passphrase-prompt.vala"
	if (_tmp0_ == NULL) {
#line 145 "passphrase-prompt.c"
		gchar* _tmp2_;
#line 41 "../common/passphrase-prompt.vala"
		_tmp2_ = g_strdup (_ ("Enter Password"));
#line 41 "../common/passphrase-prompt.vala"
		_g_free0 (_tmp0_);
#line 41 "../common/passphrase-prompt.vala"
		_tmp0_ = _tmp2_;
#line 153 "passphrase-prompt.c"
	}
#line 42 "../common/passphrase-prompt.vala"
	_tmp4_ = seahorse_passphrase_prompt_utf8_validate (description);
#line 42 "../common/passphrase-prompt.vala"
	_tmp3_ = _tmp4_;
#line 42 "../common/passphrase-prompt.vala"
	if (_tmp3_ == NULL) {
#line 161 "passphrase-prompt.c"
		gchar* _tmp5_;
#line 42 "../common/passphrase-prompt.vala"
		_tmp5_ = g_strdup (_ ("Please enter your password"));
#line 42 "../common/passphrase-prompt.vala"
		_g_free0 (_tmp3_);
#line 42 "../common/passphrase-prompt.vala"
		_tmp3_ = _tmp5_;
#line 169 "passphrase-prompt.c"
	}
#line 40 "../common/passphrase-prompt.vala"
	self = (SeahorsePassphrasePrompt*) g_object_new (object_type, "heading", _tmp0_, "body", _tmp3_, "confirm", confirm, NULL);
#line 46 "../common/passphrase-prompt.vala"
	_tmp6_ = self->priv->pass_entry;
#line 46 "../common/passphrase-prompt.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 48 "../common/passphrase-prompt.vala"
	if (!confirm) {
#line 179 "passphrase-prompt.c"
		GtkLabel* _tmp7_;
		GtkPasswordEntry* _tmp8_;
#line 49 "../common/passphrase-prompt.vala"
		_tmp7_ = self->priv->confirm_label;
#line 49 "../common/passphrase-prompt.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 50 "../common/passphrase-prompt.vala"
		_tmp8_ = self->priv->confirm_entry;
#line 50 "../common/passphrase-prompt.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
#line 190 "passphrase-prompt.c"
	}
#line 53 "../common/passphrase-prompt.vala"
	if (check != NULL) {
#line 194 "passphrase-prompt.c"
		GtkCheckButton* _tmp9_;
#line 54 "../common/passphrase-prompt.vala"
		_tmp9_ = self->priv->check_option;
#line 54 "../common/passphrase-prompt.vala"
		gtk_check_button_set_label (_tmp9_, check);
#line 200 "passphrase-prompt.c"
	} else {
		GtkCheckButton* _tmp10_;
#line 56 "../common/passphrase-prompt.vala"
		_tmp10_ = self->priv->check_option;
#line 56 "../common/passphrase-prompt.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 207 "passphrase-prompt.c"
	}
#line 39 "../common/passphrase-prompt.vala"
	_g_free0 (_tmp3_);
#line 39 "../common/passphrase-prompt.vala"
	_g_free0 (_tmp0_);
#line 39 "../common/passphrase-prompt.vala"
	return self;
#line 215 "passphrase-prompt.c"
}

SeahorsePassphrasePrompt*
seahorse_passphrase_prompt_new (const gchar* title,
                                const gchar* description,
                                const gchar* prompt,
                                const gchar* check,
                                gboolean confirm)
{
#line 39 "../common/passphrase-prompt.vala"
	return seahorse_passphrase_prompt_construct (SEAHORSE_TYPE_PASSPHRASE_PROMPT, title, description, prompt, check, confirm);
#line 227 "passphrase-prompt.c"
}

SeahorsePassphrasePrompt*
seahorse_passphrase_prompt_show_dialog (const gchar* title,
                                        const gchar* description,
                                        const gchar* prompt,
                                        const gchar* check,
                                        gboolean confirm)
{
	const gchar* _tmp0_ = NULL;
	SeahorsePassphrasePrompt* _tmp1_;
	SeahorsePassphrasePrompt* result;
#line 63 "../common/passphrase-prompt.vala"
	_tmp0_ = prompt;
#line 63 "../common/passphrase-prompt.vala"
	if (_tmp0_ == NULL) {
#line 63 "../common/passphrase-prompt.vala"
		_tmp0_ = _ ("Password:");
#line 246 "passphrase-prompt.c"
	}
#line 63 "../common/passphrase-prompt.vala"
	_tmp1_ = seahorse_passphrase_prompt_new (title, description, _tmp0_, check, confirm);
#line 63 "../common/passphrase-prompt.vala"
	g_object_ref_sink (_tmp1_);
#line 63 "../common/passphrase-prompt.vala"
	result = _tmp1_;
#line 63 "../common/passphrase-prompt.vala"
	return result;
#line 256 "passphrase-prompt.c"
}

static void
seahorse_passphrase_prompt_prompt_data_free (gpointer _data)
{
	SeahorsePassphrasePromptPromptData* _data_;
	_data_ = _data;
#line 28 "../common/passphrase-prompt.vala"
	_g_object_unref0 (_data_->parent);
#line 28 "../common/passphrase-prompt.vala"
	_g_object_unref0 (_data_->cancellable);
#line 28 "../common/passphrase-prompt.vala"
	_g_free0 (_data_->result);
#line 28 "../common/passphrase-prompt.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../common/passphrase-prompt.vala"
	g_slice_free (SeahorsePassphrasePromptPromptData, _data_);
#line 274 "passphrase-prompt.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../common/passphrase-prompt.vala"
	return self ? g_object_ref (self) : NULL;
#line 282 "passphrase-prompt.c"
}

void
seahorse_passphrase_prompt_prompt (SeahorsePassphrasePrompt* self,
                                   GtkWidget* parent,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	SeahorsePassphrasePromptPromptData* _data_;
	SeahorsePassphrasePrompt* _tmp0_;
	GtkWidget* _tmp1_;
	GCancellable* _tmp2_;
#line 28 "../common/passphrase-prompt.vala"
	g_return_if_fail (self != NULL);
#line 28 "../common/passphrase-prompt.vala"
	_data_ = g_slice_new0 (SeahorsePassphrasePromptPromptData);
#line 28 "../common/passphrase-prompt.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 28 "../common/passphrase-prompt.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_passphrase_prompt_prompt_data_free);
#line 28 "../common/passphrase-prompt.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../common/passphrase-prompt.vala"
	_data_->self = _tmp0_;
#line 28 "../common/passphrase-prompt.vala"
	_tmp1_ = _g_object_ref0 (parent);
#line 28 "../common/passphrase-prompt.vala"
	_g_object_unref0 (_data_->parent);
#line 28 "../common/passphrase-prompt.vala"
	_data_->parent = _tmp1_;
#line 28 "../common/passphrase-prompt.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 28 "../common/passphrase-prompt.vala"
	_g_object_unref0 (_data_->cancellable);
#line 28 "../common/passphrase-prompt.vala"
	_data_->cancellable = _tmp2_;
#line 28 "../common/passphrase-prompt.vala"
	seahorse_passphrase_prompt_prompt_co (_data_);
#line 322 "passphrase-prompt.c"
}

gchar*
seahorse_passphrase_prompt_prompt_finish (SeahorsePassphrasePrompt* self,
                                          GAsyncResult* _res_)
{
	gchar* result;
	SeahorsePassphrasePromptPromptData* _data_;
#line 28 "../common/passphrase-prompt.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 28 "../common/passphrase-prompt.vala"
	if (NULL == _data_) {
#line 28 "../common/passphrase-prompt.vala"
		return NULL;
#line 337 "passphrase-prompt.c"
	}
#line 28 "../common/passphrase-prompt.vala"
	result = _data_->result;
#line 28 "../common/passphrase-prompt.vala"
	_data_->result = NULL;
#line 28 "../common/passphrase-prompt.vala"
	return result;
#line 345 "passphrase-prompt.c"
}

/**
     * Prompts the user for a password. Returns null if cancelled
     */
static void
seahorse_passphrase_prompt_prompt_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	SeahorsePassphrasePromptPromptData* _data_;
#line 70 "../common/passphrase-prompt.vala"
	_data_ = _user_data_;
#line 70 "../common/passphrase-prompt.vala"
	_data_->_source_object_ = source_object;
#line 70 "../common/passphrase-prompt.vala"
	_data_->_res_ = _res_;
#line 70 "../common/passphrase-prompt.vala"
	seahorse_passphrase_prompt_prompt_co (_data_);
#line 365 "passphrase-prompt.c"
}

static gboolean
seahorse_passphrase_prompt_prompt_co (SeahorsePassphrasePromptPromptData* _data_)
{
#line 69 "../common/passphrase-prompt.vala"
	switch (_data_->_state_) {
#line 69 "../common/passphrase-prompt.vala"
		case 0:
#line 375 "passphrase-prompt.c"
		goto _state_0;
#line 69 "../common/passphrase-prompt.vala"
		case 1:
#line 379 "passphrase-prompt.c"
		goto _state_1;
		default:
#line 69 "../common/passphrase-prompt.vala"
		g_assert_not_reached ();
#line 384 "passphrase-prompt.c"
	}
	_state_0:
#line 70 "../common/passphrase-prompt.vala"
	_data_->_state_ = 1;
#line 70 "../common/passphrase-prompt.vala"
	adw_alert_dialog_choose ((AdwAlertDialog*) _data_->self, _data_->parent, _data_->cancellable, seahorse_passphrase_prompt_prompt_ready, _data_);
#line 70 "../common/passphrase-prompt.vala"
	return FALSE;
#line 393 "passphrase-prompt.c"
	_state_1:
#line 70 "../common/passphrase-prompt.vala"
	_data_->_tmp0_ = adw_alert_dialog_choose_finish ((AdwAlertDialog*) _data_->self, _data_->_res_);
#line 70 "../common/passphrase-prompt.vala"
	_data_->_tmp1_ = g_strdup (_data_->_tmp0_);
#line 70 "../common/passphrase-prompt.vala"
	_data_->response = _data_->_tmp1_;
#line 71 "../common/passphrase-prompt.vala"
	_data_->_tmp2_ = _data_->response;
#line 71 "../common/passphrase-prompt.vala"
	if (g_strcmp0 (_data_->_tmp2_, "submit") == 0) {
#line 72 "../common/passphrase-prompt.vala"
		_data_->_tmp3_ = _data_->self->priv->pass_entry;
#line 72 "../common/passphrase-prompt.vala"
		_data_->_tmp4_ = gtk_editable_get_text ((GtkEditable*) _data_->_tmp3_);
#line 72 "../common/passphrase-prompt.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 72 "../common/passphrase-prompt.vala"
		_data_->_tmp6_ = g_strdup (_data_->_tmp5_);
#line 72 "../common/passphrase-prompt.vala"
		_data_->result = _data_->_tmp6_;
#line 72 "../common/passphrase-prompt.vala"
		_g_free0 (_data_->response);
#line 72 "../common/passphrase-prompt.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 72 "../common/passphrase-prompt.vala"
		if (_data_->_state_ != 0) {
#line 72 "../common/passphrase-prompt.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 72 "../common/passphrase-prompt.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 425 "passphrase-prompt.c"
			}
		}
#line 72 "../common/passphrase-prompt.vala"
		g_object_unref (_data_->_async_result);
#line 72 "../common/passphrase-prompt.vala"
		return FALSE;
#line 432 "passphrase-prompt.c"
	}
#line 73 "../common/passphrase-prompt.vala"
	_data_->result = NULL;
#line 73 "../common/passphrase-prompt.vala"
	_g_free0 (_data_->response);
#line 73 "../common/passphrase-prompt.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 73 "../common/passphrase-prompt.vala"
	if (_data_->_state_ != 0) {
#line 73 "../common/passphrase-prompt.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 73 "../common/passphrase-prompt.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 446 "passphrase-prompt.c"
		}
	}
#line 73 "../common/passphrase-prompt.vala"
	g_object_unref (_data_->_async_result);
#line 73 "../common/passphrase-prompt.vala"
	return FALSE;
#line 453 "passphrase-prompt.c"
}

gchar*
seahorse_passphrase_prompt_get_text (SeahorsePassphrasePrompt* self)
{
	GtkPasswordEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 76 "../common/passphrase-prompt.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../common/passphrase-prompt.vala"
	_tmp0_ = self->priv->pass_entry;
#line 77 "../common/passphrase-prompt.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 77 "../common/passphrase-prompt.vala"
	_tmp2_ = _tmp1_;
#line 77 "../common/passphrase-prompt.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 77 "../common/passphrase-prompt.vala"
	result = _tmp3_;
#line 77 "../common/passphrase-prompt.vala"
	return result;
#line 478 "passphrase-prompt.c"
}

gboolean
seahorse_passphrase_prompt_checked (SeahorsePassphrasePrompt* self)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 80 "../common/passphrase-prompt.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "../common/passphrase-prompt.vala"
	_tmp0_ = self->priv->check_option;
#line 81 "../common/passphrase-prompt.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 81 "../common/passphrase-prompt.vala"
	_tmp2_ = _tmp1_;
#line 81 "../common/passphrase-prompt.vala"
	result = _tmp2_;
#line 81 "../common/passphrase-prompt.vala"
	return result;
#line 500 "passphrase-prompt.c"
}

static gchar*
seahorse_passphrase_prompt_utf8_validate (const gchar* text)
{
	gchar* _result_ = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* result;
#line 86 "../common/passphrase-prompt.vala"
	if (text == NULL) {
#line 87 "../common/passphrase-prompt.vala"
		result = NULL;
#line 87 "../common/passphrase-prompt.vala"
		return result;
#line 516 "passphrase-prompt.c"
	}
#line 89 "../common/passphrase-prompt.vala"
	if (g_utf8_validate (text, (gssize) -1, NULL)) {
#line 520 "passphrase-prompt.c"
		gchar* _tmp0_;
#line 90 "../common/passphrase-prompt.vala"
		_tmp0_ = g_strdup (text);
#line 90 "../common/passphrase-prompt.vala"
		result = _tmp0_;
#line 90 "../common/passphrase-prompt.vala"
		return result;
#line 528 "passphrase-prompt.c"
	}
#line 92 "../common/passphrase-prompt.vala"
	_tmp1_ = g_locale_to_utf8 (text, (gssize) -1, NULL, NULL, NULL);
#line 92 "../common/passphrase-prompt.vala"
	_result_ = _tmp1_;
#line 93 "../common/passphrase-prompt.vala"
	_tmp2_ = _result_;
#line 93 "../common/passphrase-prompt.vala"
	if (_tmp2_ == NULL) {
#line 538 "passphrase-prompt.c"
		gchar* p = NULL;
		gchar* _tmp7_;
#line 95 "../common/passphrase-prompt.vala"
		p = (gchar*) text;
#line 97 "../common/passphrase-prompt.vala"
		while (TRUE) {
#line 545 "passphrase-prompt.c"
			gchar* _tmp3_;
			gchar* _tmp4_ = NULL;
			gboolean _tmp5_;
			gchar* _tmp6_;
#line 97 "../common/passphrase-prompt.vala"
			_tmp3_ = p;
#line 97 "../common/passphrase-prompt.vala"
			_tmp5_ = g_utf8_validate ((const gchar*) _tmp3_, (gssize) -1, &_tmp4_);
#line 97 "../common/passphrase-prompt.vala"
			p = _tmp4_;
#line 97 "../common/passphrase-prompt.vala"
			if (!(!_tmp5_)) {
#line 97 "../common/passphrase-prompt.vala"
				break;
#line 560 "passphrase-prompt.c"
			}
#line 98 "../common/passphrase-prompt.vala"
			_tmp6_ = p;
#line 98 "../common/passphrase-prompt.vala"
			*_tmp6_ = '?';
#line 566 "passphrase-prompt.c"
		}
#line 100 "../common/passphrase-prompt.vala"
		_tmp7_ = g_strdup (text);
#line 100 "../common/passphrase-prompt.vala"
		_g_free0 (_result_);
#line 100 "../common/passphrase-prompt.vala"
		_result_ = _tmp7_;
#line 574 "passphrase-prompt.c"
	}
#line 102 "../common/passphrase-prompt.vala"
	result = _result_;
#line 102 "../common/passphrase-prompt.vala"
	return result;
#line 580 "passphrase-prompt.c"
}

static void
seahorse_passphrase_prompt_on_pass_entry_activate (SeahorsePassphrasePrompt* self,
                                                   GtkWidget* widget)
{
	gboolean _tmp0_;
#line 106 "../common/passphrase-prompt.vala"
	g_return_if_fail (self != NULL);
#line 106 "../common/passphrase-prompt.vala"
	g_return_if_fail (widget != NULL);
#line 107 "../common/passphrase-prompt.vala"
	_tmp0_ = self->priv->_confirm;
#line 107 "../common/passphrase-prompt.vala"
	if (_tmp0_) {
#line 596 "passphrase-prompt.c"
		GtkPasswordEntry* _tmp1_;
#line 108 "../common/passphrase-prompt.vala"
		_tmp1_ = self->priv->confirm_entry;
#line 108 "../common/passphrase-prompt.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp1_);
#line 602 "passphrase-prompt.c"
	} else {
#line 110 "../common/passphrase-prompt.vala"
		seahorse_passphrase_prompt_try_submit (self);
#line 606 "passphrase-prompt.c"
	}
}

static void
_seahorse_passphrase_prompt_on_pass_entry_activate_gtk_password_entry_activate (GtkPasswordEntry* _sender,
                                                                                gpointer self)
{
#line 28 "../common/passphrase-prompt.vala"
	seahorse_passphrase_prompt_on_pass_entry_activate ((SeahorsePassphrasePrompt*) self, _sender);
#line 616 "passphrase-prompt.c"
}

static void
seahorse_passphrase_prompt_on_confirm_entry_activate (SeahorsePassphrasePrompt* self,
                                                      GtkWidget* widget)
{
#line 114 "../common/passphrase-prompt.vala"
	g_return_if_fail (self != NULL);
#line 114 "../common/passphrase-prompt.vala"
	g_return_if_fail (widget != NULL);
#line 115 "../common/passphrase-prompt.vala"
	seahorse_passphrase_prompt_try_submit (self);
#line 629 "passphrase-prompt.c"
}

static void
_seahorse_passphrase_prompt_on_confirm_entry_activate_gtk_password_entry_activate (GtkPasswordEntry* _sender,
                                                                                   gpointer self)
{
#line 28 "../common/passphrase-prompt.vala"
	seahorse_passphrase_prompt_on_confirm_entry_activate ((SeahorsePassphrasePrompt*) self, _sender);
#line 638 "passphrase-prompt.c"
}

static void
seahorse_passphrase_prompt_try_submit (SeahorsePassphrasePrompt* self)
{
#line 118 "../common/passphrase-prompt.vala"
	g_return_if_fail (self != NULL);
#line 119 "../common/passphrase-prompt.vala"
	if (seahorse_passphrase_prompt_ok (self)) {
#line 120 "../common/passphrase-prompt.vala"
		g_signal_emit_by_name ((AdwAlertDialog*) self, "response", "submit");
#line 650 "passphrase-prompt.c"
	} else {
		GtkLabel* _tmp0_;
#line 122 "../common/passphrase-prompt.vala"
		_tmp0_ = self->priv->error_label;
#line 122 "../common/passphrase-prompt.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 657 "passphrase-prompt.c"
	}
}

static gboolean
seahorse_passphrase_prompt_ok (SeahorsePassphrasePrompt* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean result;
#line 126 "../common/passphrase-prompt.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../common/passphrase-prompt.vala"
	_tmp1_ = self->priv->_confirm;
#line 127 "../common/passphrase-prompt.vala"
	if (!_tmp1_) {
#line 127 "../common/passphrase-prompt.vala"
		_tmp0_ = TRUE;
#line 675 "passphrase-prompt.c"
	} else {
		GtkPasswordEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GtkPasswordEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 127 "../common/passphrase-prompt.vala"
		_tmp2_ = self->priv->pass_entry;
#line 127 "../common/passphrase-prompt.vala"
		_tmp3_ = gtk_editable_get_text ((GtkEditable*) _tmp2_);
#line 127 "../common/passphrase-prompt.vala"
		_tmp4_ = _tmp3_;
#line 127 "../common/passphrase-prompt.vala"
		_tmp5_ = self->priv->confirm_entry;
#line 127 "../common/passphrase-prompt.vala"
		_tmp6_ = gtk_editable_get_text ((GtkEditable*) _tmp5_);
#line 127 "../common/passphrase-prompt.vala"
		_tmp7_ = _tmp6_;
#line 127 "../common/passphrase-prompt.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, _tmp7_) == 0;
#line 697 "passphrase-prompt.c"
	}
#line 127 "../common/passphrase-prompt.vala"
	result = _tmp0_;
#line 127 "../common/passphrase-prompt.vala"
	return result;
#line 703 "passphrase-prompt.c"
}

static void
seahorse_passphrase_prompt_on_entry_changed (SeahorsePassphrasePrompt* self,
                                             GtkEditable* editable)
{
#line 131 "../common/passphrase-prompt.vala"
	g_return_if_fail (self != NULL);
#line 132 "../common/passphrase-prompt.vala"
	adw_alert_dialog_set_response_enabled ((AdwAlertDialog*) self, "submit", seahorse_passphrase_prompt_ok (self));
#line 714 "passphrase-prompt.c"
}

static void
_seahorse_passphrase_prompt_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                   gpointer self)
{
#line 28 "../common/passphrase-prompt.vala"
	seahorse_passphrase_prompt_on_entry_changed ((SeahorsePassphrasePrompt*) self, _sender);
#line 723 "passphrase-prompt.c"
}

gboolean
seahorse_passphrase_prompt_get_confirm (SeahorsePassphrasePrompt* self)
{
	gboolean result;
#line 31 "../common/passphrase-prompt.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../common/passphrase-prompt.vala"
	result = self->priv->_confirm;
#line 31 "../common/passphrase-prompt.vala"
	return result;
#line 736 "passphrase-prompt.c"
}

void
seahorse_passphrase_prompt_set_confirm (SeahorsePassphrasePrompt* self,
                                        gboolean value)
{
	gboolean old_value;
#line 31 "../common/passphrase-prompt.vala"
	g_return_if_fail (self != NULL);
#line 31 "../common/passphrase-prompt.vala"
	old_value = seahorse_passphrase_prompt_get_confirm (self);
#line 31 "../common/passphrase-prompt.vala"
	if (old_value != value) {
#line 31 "../common/passphrase-prompt.vala"
		self->priv->_confirm = value;
#line 31 "../common/passphrase-prompt.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_passphrase_prompt_properties[SEAHORSE_PASSPHRASE_PROMPT_CONFIRM_PROPERTY]);
#line 754 "passphrase-prompt.c"
	}
}

static void
seahorse_passphrase_prompt_class_init (SeahorsePassphrasePromptClass * klass,
                                       gpointer klass_data)
{
#line 28 "../common/passphrase-prompt.vala"
	seahorse_passphrase_prompt_parent_class = g_type_class_peek_parent (klass);
#line 28 "../common/passphrase-prompt.vala"
	g_type_class_adjust_private_offset (klass, &SeahorsePassphrasePrompt_private_offset);
#line 28 "../common/passphrase-prompt.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_passphrase_prompt_get_property;
#line 28 "../common/passphrase-prompt.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_passphrase_prompt_set_property;
#line 28 "../common/passphrase-prompt.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_passphrase_prompt_finalize;
#line 772 "passphrase-prompt.c"
	/** Whether the user needs to confirm their password */
#line 28 "../common/passphrase-prompt.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PASSPHRASE_PROMPT_CONFIRM_PROPERTY, seahorse_passphrase_prompt_properties[SEAHORSE_PASSPHRASE_PROMPT_CONFIRM_PROPERTY] = g_param_spec_boolean ("confirm", "confirm", "confirm", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/passphrase-prompt.ui");
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pass_entry", FALSE, SeahorsePassphrasePrompt_private_offset + G_STRUCT_OFFSET (SeahorsePassphrasePromptPrivate, pass_entry));
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "confirm_entry", FALSE, SeahorsePassphrasePrompt_private_offset + G_STRUCT_OFFSET (SeahorsePassphrasePromptPrivate, confirm_entry));
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "confirm_label", FALSE, SeahorsePassphrasePrompt_private_offset + G_STRUCT_OFFSET (SeahorsePassphrasePromptPrivate, confirm_label));
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "check_option", FALSE, SeahorsePassphrasePrompt_private_offset + G_STRUCT_OFFSET (SeahorsePassphrasePromptPrivate, check_option));
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "error_label", FALSE, SeahorsePassphrasePrompt_private_offset + G_STRUCT_OFFSET (SeahorsePassphrasePromptPrivate, error_label));
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_pass_entry_activate", G_CALLBACK(_seahorse_passphrase_prompt_on_pass_entry_activate_gtk_password_entry_activate));
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_confirm_entry_activate", G_CALLBACK(_seahorse_passphrase_prompt_on_confirm_entry_activate_gtk_password_entry_activate));
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_entry_changed", G_CALLBACK(_seahorse_passphrase_prompt_on_entry_changed_gtk_editable_changed));
#line 794 "passphrase-prompt.c"
}

static void
seahorse_passphrase_prompt_instance_init (SeahorsePassphrasePrompt * self,
                                          gpointer klass)
{
#line 28 "../common/passphrase-prompt.vala"
	self->priv = seahorse_passphrase_prompt_get_instance_private (self);
#line 31 "../common/passphrase-prompt.vala"
	self->priv->_confirm = TRUE;
#line 28 "../common/passphrase-prompt.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 807 "passphrase-prompt.c"
}

static void
seahorse_passphrase_prompt_finalize (GObject * obj)
{
	SeahorsePassphrasePrompt * self;
#line 28 "../common/passphrase-prompt.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_PASSPHRASE_PROMPT, SeahorsePassphrasePrompt);
#line 28 "../common/passphrase-prompt.vala"
	G_OBJECT_CLASS (seahorse_passphrase_prompt_parent_class)->finalize (obj);
#line 818 "passphrase-prompt.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_passphrase_prompt_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePassphrasePromptClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_passphrase_prompt_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePassphrasePrompt), 0, (GInstanceInitFunc) seahorse_passphrase_prompt_instance_init, NULL };
	GType seahorse_passphrase_prompt_type_id;
	seahorse_passphrase_prompt_type_id = g_type_register_static (adw_alert_dialog_get_type (), "SeahorsePassphrasePrompt", &g_define_type_info, 0);
	SeahorsePassphrasePrompt_private_offset = g_type_add_instance_private (seahorse_passphrase_prompt_type_id, sizeof (SeahorsePassphrasePromptPrivate));
	return seahorse_passphrase_prompt_type_id;
}

GType
seahorse_passphrase_prompt_get_type (void)
{
	static gsize seahorse_passphrase_prompt_type_id__once = 0;
	if (g_once_init_enter (&seahorse_passphrase_prompt_type_id__once)) {
		GType seahorse_passphrase_prompt_type_id;
		seahorse_passphrase_prompt_type_id = seahorse_passphrase_prompt_get_type_once ();
		g_once_init_leave (&seahorse_passphrase_prompt_type_id__once, seahorse_passphrase_prompt_type_id);
	}
	return seahorse_passphrase_prompt_type_id__once;
}

static void
_vala_seahorse_passphrase_prompt_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	SeahorsePassphrasePrompt * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_PASSPHRASE_PROMPT, SeahorsePassphrasePrompt);
#line 28 "../common/passphrase-prompt.vala"
	switch (property_id) {
#line 28 "../common/passphrase-prompt.vala"
		case SEAHORSE_PASSPHRASE_PROMPT_CONFIRM_PROPERTY:
#line 28 "../common/passphrase-prompt.vala"
		g_value_set_boolean (value, seahorse_passphrase_prompt_get_confirm (self));
#line 28 "../common/passphrase-prompt.vala"
		break;
#line 859 "passphrase-prompt.c"
		default:
#line 28 "../common/passphrase-prompt.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../common/passphrase-prompt.vala"
		break;
#line 865 "passphrase-prompt.c"
	}
}

static void
_vala_seahorse_passphrase_prompt_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	SeahorsePassphrasePrompt * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_PASSPHRASE_PROMPT, SeahorsePassphrasePrompt);
#line 28 "../common/passphrase-prompt.vala"
	switch (property_id) {
#line 28 "../common/passphrase-prompt.vala"
		case SEAHORSE_PASSPHRASE_PROMPT_CONFIRM_PROPERTY:
#line 28 "../common/passphrase-prompt.vala"
		seahorse_passphrase_prompt_set_confirm (self, g_value_get_boolean (value));
#line 28 "../common/passphrase-prompt.vala"
		break;
#line 885 "passphrase-prompt.c"
		default:
#line 28 "../common/passphrase-prompt.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../common/passphrase-prompt.vala"
		break;
#line 891 "passphrase-prompt.c"
	}
}

