/* viewable.c generated by valac 0.56.18, the Vala compiler
 * generated from viewable.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Stef Walter <stefw@collabora.co.uk>
 */

#include "seahorse-common.h"
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _Block2Data {
	int _ref_count_;
	GObject* object;
};

static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ___lambda5_ (Block2Data* _data2_);
static gboolean ____lambda5__gtk_window_close_request (GtkWindow* _sender,
                                                gpointer self);
static GType seahorse_viewable_get_type_once (void);

gboolean
seahorse_viewable_can_view (GObject* object)
{
	gboolean result;
#line 24 "../common/viewable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 25 "../common/viewable.vala"
	result = SEAHORSE_IS_VIEWABLE (object);
#line 25 "../common/viewable.vala"
	return result;
#line 65 "viewable.c"
}

SeahorsePanel*
seahorse_viewable_create_panel (SeahorseViewable* self)
{
	SeahorseViewableIface* _iface_;
#line 28 "../common/viewable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../common/viewable.vala"
	_iface_ = SEAHORSE_VIEWABLE_GET_INTERFACE (self);
#line 28 "../common/viewable.vala"
	if (_iface_->create_panel) {
#line 28 "../common/viewable.vala"
		return _iface_->create_panel (self);
#line 80 "viewable.c"
	}
#line 28 "../common/viewable.vala"
	return NULL;
#line 84 "viewable.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../common/viewable.vala"
	return self ? g_object_ref (self) : NULL;
#line 92 "viewable.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 30 "../common/viewable.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 30 "../common/viewable.vala"
	return _data2_;
#line 102 "viewable.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 30 "../common/viewable.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 30 "../common/viewable.vala"
		_g_object_unref0 (_data2_->object);
#line 30 "../common/viewable.vala"
		g_slice_free (Block2Data, _data2_);
#line 116 "viewable.c"
	}
}

static gboolean
___lambda5_ (Block2Data* _data2_)
{
	gboolean result;
#line 45 "../common/viewable.vala"
	g_object_set_data_full (_data2_->object, "viewable-window", NULL, NULL);
#line 46 "../common/viewable.vala"
	result = FALSE;
#line 46 "../common/viewable.vala"
	return result;
#line 130 "viewable.c"
}

static gboolean
____lambda5__gtk_window_close_request (GtkWindow* _sender,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda5_ (self);
#line 44 "../common/viewable.vala"
	return result;
#line 141 "viewable.c"
}

gboolean
seahorse_viewable_view (GObject* object,
                        GtkWindow* parent)
{
	Block2Data* _data2_;
	GObject* _tmp0_;
	GtkWindow* window = NULL;
	gconstpointer _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp3_;
	GtkWindow* _tmp11_;
	gboolean result;
#line 30 "../common/viewable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 30 "../common/viewable.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 30 "../common/viewable.vala"
	_data2_->_ref_count_ = 1;
#line 30 "../common/viewable.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 30 "../common/viewable.vala"
	_g_object_unref0 (_data2_->object);
#line 30 "../common/viewable.vala"
	_data2_->object = _tmp0_;
#line 32 "../common/viewable.vala"
	if (!seahorse_viewable_can_view (_data2_->object)) {
#line 33 "../common/viewable.vala"
		result = FALSE;
#line 33 "../common/viewable.vala"
		block2_data_unref (_data2_);
#line 33 "../common/viewable.vala"
		_data2_ = NULL;
#line 33 "../common/viewable.vala"
		return result;
#line 178 "viewable.c"
	}
#line 35 "../common/viewable.vala"
	window = NULL;
#line 37 "../common/viewable.vala"
	_tmp1_ = g_object_get_data (_data2_->object, "viewable-window");
#line 37 "../common/viewable.vala"
	_tmp2_ = _g_object_ref0 ((GtkWindow*) _tmp1_);
#line 37 "../common/viewable.vala"
	_g_object_unref0 (window);
#line 37 "../common/viewable.vala"
	window = _tmp2_;
#line 38 "../common/viewable.vala"
	_tmp3_ = window;
#line 38 "../common/viewable.vala"
	if (_tmp3_ == NULL) {
#line 194 "viewable.c"
		SeahorseViewable* viewable = NULL;
		SeahorsePanel* panel = NULL;
		SeahorseViewable* _tmp4_;
		SeahorsePanel* _tmp5_;
		SeahorsePanel* _tmp6_;
		SeahorsePanelWindow* _tmp7_;
		GtkWindow* _tmp8_;
		GtkWindow* _tmp9_;
		GtkWindow* _tmp10_;
#line 39 "../common/viewable.vala"
		viewable = G_TYPE_CHECK_INSTANCE_CAST (_data2_->object, SEAHORSE_TYPE_VIEWABLE, SeahorseViewable);
#line 40 "../common/viewable.vala"
		_tmp4_ = viewable;
#line 40 "../common/viewable.vala"
		_tmp5_ = seahorse_viewable_create_panel (_tmp4_);
#line 40 "../common/viewable.vala"
		panel = _tmp5_;
#line 41 "../common/viewable.vala"
		_tmp6_ = panel;
#line 41 "../common/viewable.vala"
		_tmp7_ = seahorse_panel_window_new (_tmp6_, parent);
#line 41 "../common/viewable.vala"
		g_object_ref_sink (_tmp7_);
#line 41 "../common/viewable.vala"
		_g_object_unref0 (window);
#line 41 "../common/viewable.vala"
		window = (GtkWindow*) _tmp7_;
#line 43 "../common/viewable.vala"
		_tmp8_ = window;
#line 43 "../common/viewable.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 43 "../common/viewable.vala"
		g_object_set_data_full (_data2_->object, "viewable-window", _tmp9_, g_object_unref);
#line 44 "../common/viewable.vala"
		_tmp10_ = window;
#line 44 "../common/viewable.vala"
		g_signal_connect_data (_tmp10_, "close-request", (GCallback) ____lambda5__gtk_window_close_request, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 38 "../common/viewable.vala"
		_g_object_unref0 (panel);
#line 234 "viewable.c"
	}
#line 50 "../common/viewable.vala"
	_tmp11_ = window;
#line 50 "../common/viewable.vala"
	gtk_window_present (_tmp11_);
#line 51 "../common/viewable.vala"
	result = TRUE;
#line 51 "../common/viewable.vala"
	_g_object_unref0 (window);
#line 51 "../common/viewable.vala"
	block2_data_unref (_data2_);
#line 51 "../common/viewable.vala"
	_data2_ = NULL;
#line 51 "../common/viewable.vala"
	return result;
#line 250 "viewable.c"
}

static void
seahorse_viewable_default_init (SeahorseViewableIface * iface,
                                gpointer iface_data)
{
}

 G_GNUC_NO_INLINE static GType
seahorse_viewable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseViewableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_viewable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType seahorse_viewable_type_id;
	seahorse_viewable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SeahorseViewable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (seahorse_viewable_type_id, G_TYPE_OBJECT);
	return seahorse_viewable_type_id;
}

GType
seahorse_viewable_get_type (void)
{
	static gsize seahorse_viewable_type_id__once = 0;
	if (g_once_init_enter (&seahorse_viewable_type_id__once)) {
		GType seahorse_viewable_type_id;
		seahorse_viewable_type_id = seahorse_viewable_get_type_once ();
		g_once_init_leave (&seahorse_viewable_type_id__once, seahorse_viewable_type_id);
	}
	return seahorse_viewable_type_id__once;
}

