/* gkr-item-delete-operation.c generated by valac 0.56.18, the Vala compiler
 * generated from gkr-item-delete-operation.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2020 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-gkr.h"
#include "seahorse-common.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <libsecret/secret.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_GKR_ITEM_DELETE_OPERATION_0_PROPERTY,
	SEAHORSE_GKR_ITEM_DELETE_OPERATION_NUM_PROPERTIES
};
static GParamSpec* seahorse_gkr_item_delete_operation_properties[SEAHORSE_GKR_ITEM_DELETE_OPERATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _SeahorseGkrItemDeleteOperationExecuteData SeahorseGkrItemDeleteOperationExecuteData;

struct _SeahorseGkrItemDeleteOperationExecuteData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseGkrItemDeleteOperation* self;
	GCancellable* cancellable;
	gboolean result;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GPtrArray* _tmp3_;
	GPtrArray* deletable_collection;
	guint deletable_index;
	SeahorseDeletable* deletable;
	SeahorseGkrItem* item;
	SeahorseDeletable* _tmp4_;
	SeahorseGkrItem* _tmp5_;
	SeahorseGkrItem* _tmp6_;
	GError* _inner_error0_;
};

static gpointer seahorse_gkr_item_delete_operation_parent_class = NULL;

static void seahorse_gkr_item_delete_operation_real_execute_data_free (gpointer _data);
static void seahorse_gkr_item_delete_operation_real_execute (SeahorseDeleteOperation* base,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static gboolean seahorse_gkr_item_delete_operation_real_execute_co (SeahorseGkrItemDeleteOperationExecuteData* _data_);
static void seahorse_gkr_item_delete_operation_execute_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static GType seahorse_gkr_item_delete_operation_get_type_once (void);

SeahorseGkrItemDeleteOperation*
seahorse_gkr_item_delete_operation_construct (GType object_type,
                                              SeahorseGkrItem* item)
{
	SeahorseGkrItemDeleteOperation * self = NULL;
#line 23 "../gkr/gkr-item-delete-operation.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 23 "../gkr/gkr-item-delete-operation.vala"
	self = (SeahorseGkrItemDeleteOperation*) seahorse_delete_operation_construct (object_type);
#line 24 "../gkr/gkr-item-delete-operation.vala"
	seahorse_gkr_item_delete_operation_add_item (self, item);
#line 23 "../gkr/gkr-item-delete-operation.vala"
	return self;
#line 97 "gkr-item-delete-operation.c"
}

SeahorseGkrItemDeleteOperation*
seahorse_gkr_item_delete_operation_new (SeahorseGkrItem* item)
{
#line 23 "../gkr/gkr-item-delete-operation.vala"
	return seahorse_gkr_item_delete_operation_construct (SEAHORSE_GKR_TYPE_ITEM_DELETE_OPERATION, item);
#line 105 "gkr-item-delete-operation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../gkr/gkr-item-delete-operation.vala"
	return self ? g_object_ref (self) : NULL;
#line 113 "gkr-item-delete-operation.c"
}

void
seahorse_gkr_item_delete_operation_add_item (SeahorseGkrItemDeleteOperation* self,
                                             SeahorseGkrItem* item)
{
	GPtrArray* _tmp0_;
	SeahorseDeletable* _tmp1_;
#line 27 "../gkr/gkr-item-delete-operation.vala"
	g_return_if_fail (self != NULL);
#line 27 "../gkr/gkr-item-delete-operation.vala"
	g_return_if_fail (item != NULL);
#line 28 "../gkr/gkr-item-delete-operation.vala"
	if (seahorse_delete_operation_contains ((SeahorseDeleteOperation*) self, (SeahorseDeletable*) item)) {
#line 29 "../gkr/gkr-item-delete-operation.vala"
		return;
#line 130 "gkr-item-delete-operation.c"
	}
#line 30 "../gkr/gkr-item-delete-operation.vala"
	_tmp0_ = ((SeahorseDeleteOperation*) self)->items;
#line 30 "../gkr/gkr-item-delete-operation.vala"
	_tmp1_ = _g_object_ref0 ((SeahorseDeletable*) item);
#line 30 "../gkr/gkr-item-delete-operation.vala"
	g_ptr_array_add (_tmp0_, _tmp1_);
#line 138 "gkr-item-delete-operation.c"
}

static void
seahorse_gkr_item_delete_operation_real_execute_data_free (gpointer _data)
{
	SeahorseGkrItemDeleteOperationExecuteData* _data_;
	_data_ = _data;
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_g_object_unref0 (_data_->cancellable);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_g_object_unref0 (_data_->self);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	g_slice_free (SeahorseGkrItemDeleteOperationExecuteData, _data_);
#line 152 "gkr-item-delete-operation.c"
}

static void
seahorse_gkr_item_delete_operation_real_execute (SeahorseDeleteOperation* base,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	SeahorseGkrItemDeleteOperation * self;
	SeahorseGkrItemDeleteOperationExecuteData* _data_;
	SeahorseGkrItemDeleteOperation* _tmp0_;
	GCancellable* _tmp1_;
#line 21 "../gkr/gkr-item-delete-operation.vala"
	self = (SeahorseGkrItemDeleteOperation*) base;
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_data_ = g_slice_new0 (SeahorseGkrItemDeleteOperationExecuteData);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_gkr_item_delete_operation_real_execute_data_free);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_data_->self = _tmp0_;
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_g_object_unref0 (_data_->cancellable);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_data_->cancellable = _tmp1_;
#line 21 "../gkr/gkr-item-delete-operation.vala"
	seahorse_gkr_item_delete_operation_real_execute_co (_data_);
#line 185 "gkr-item-delete-operation.c"
}

static gboolean
seahorse_gkr_item_delete_operation_execute_finish (SeahorseDeleteOperation* base,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	gboolean result;
	SeahorseGkrItemDeleteOperationExecuteData* _data_;
#line 21 "../gkr/gkr-item-delete-operation.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	if (NULL == _data_) {
#line 199 "gkr-item-delete-operation.c"
		gboolean _tmp0_ = FALSE;
#line 21 "../gkr/gkr-item-delete-operation.vala"
		return _tmp0_;
#line 203 "gkr-item-delete-operation.c"
	}
#line 21 "../gkr/gkr-item-delete-operation.vala"
	result = _data_->result;
#line 21 "../gkr/gkr-item-delete-operation.vala"
	return result;
#line 209 "gkr-item-delete-operation.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5954 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5955 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5955 "glib-2.0.vapi"
	return result;
#line 222 "gkr-item-delete-operation.c"
}

static void
seahorse_gkr_item_delete_operation_execute_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	SeahorseGkrItemDeleteOperationExecuteData* _data_;
#line 37 "../gkr/gkr-item-delete-operation.vala"
	_data_ = _user_data_;
#line 37 "../gkr/gkr-item-delete-operation.vala"
	_data_->_source_object_ = source_object;
#line 37 "../gkr/gkr-item-delete-operation.vala"
	_data_->_res_ = _res_;
#line 37 "../gkr/gkr-item-delete-operation.vala"
	seahorse_gkr_item_delete_operation_real_execute_co (_data_);
#line 239 "gkr-item-delete-operation.c"
}

static gboolean
seahorse_gkr_item_delete_operation_real_execute_co (SeahorseGkrItemDeleteOperationExecuteData* _data_)
{
#line 33 "../gkr/gkr-item-delete-operation.vala"
	switch (_data_->_state_) {
#line 33 "../gkr/gkr-item-delete-operation.vala"
		case 0:
#line 249 "gkr-item-delete-operation.c"
		goto _state_0;
#line 33 "../gkr/gkr-item-delete-operation.vala"
		case 1:
#line 253 "gkr-item-delete-operation.c"
		goto _state_1;
		default:
#line 33 "../gkr/gkr-item-delete-operation.vala"
		g_assert_not_reached ();
#line 258 "gkr-item-delete-operation.c"
	}
	_state_0:
#line 34 "../gkr/gkr-item-delete-operation.vala"
	_data_->_tmp0_ = ((SeahorseDeleteOperation*) _data_->self)->items;
#line 34 "../gkr/gkr-item-delete-operation.vala"
	_data_->_tmp1_ = vala_g_ptr_array_get_length (_data_->_tmp0_);
#line 34 "../gkr/gkr-item-delete-operation.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 34 "../gkr/gkr-item-delete-operation.vala"
	g_debug ("gkr-item-delete-operation.vala:34: Deleting %u passwords", (guint) _data_->_tmp2_);
#line 35 "../gkr/gkr-item-delete-operation.vala"
	_data_->_tmp3_ = ((SeahorseDeleteOperation*) _data_->self)->items;
#line 271 "gkr-item-delete-operation.c"
	{
#line 35 "../gkr/gkr-item-delete-operation.vala"
		_data_->deletable_collection = _data_->_tmp3_;
#line 35 "../gkr/gkr-item-delete-operation.vala"
		for (_data_->deletable_index = 0; _data_->deletable_index < _data_->deletable_collection->len; _data_->deletable_index = _data_->deletable_index + 1) {
#line 35 "../gkr/gkr-item-delete-operation.vala"
			_data_->deletable = (SeahorseDeletable*) g_ptr_array_index (_data_->deletable_collection, _data_->deletable_index);
#line 279 "gkr-item-delete-operation.c"
			{
#line 36 "../gkr/gkr-item-delete-operation.vala"
				_data_->_tmp4_ = _data_->deletable;
#line 36 "../gkr/gkr-item-delete-operation.vala"
				_data_->_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, SEAHORSE_GKR_TYPE_ITEM, SeahorseGkrItem));
#line 36 "../gkr/gkr-item-delete-operation.vala"
				_data_->item = _data_->_tmp5_;
#line 37 "../gkr/gkr-item-delete-operation.vala"
				_data_->_tmp6_ = _data_->item;
#line 37 "../gkr/gkr-item-delete-operation.vala"
				_data_->_state_ = 1;
#line 37 "../gkr/gkr-item-delete-operation.vala"
				secret_item_delete ((SecretItem*) _data_->_tmp6_, _data_->cancellable, seahorse_gkr_item_delete_operation_execute_ready, _data_);
#line 37 "../gkr/gkr-item-delete-operation.vala"
				return FALSE;
#line 295 "gkr-item-delete-operation.c"
				_state_1:
#line 37 "../gkr/gkr-item-delete-operation.vala"
				secret_item_delete_finish ((SecretItem*) _data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 37 "../gkr/gkr-item-delete-operation.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 37 "../gkr/gkr-item-delete-operation.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 37 "../gkr/gkr-item-delete-operation.vala"
					_g_object_unref0 (_data_->item);
#line 37 "../gkr/gkr-item-delete-operation.vala"
					g_object_unref (_data_->_async_result);
#line 37 "../gkr/gkr-item-delete-operation.vala"
					return FALSE;
#line 309 "gkr-item-delete-operation.c"
				}
#line 35 "../gkr/gkr-item-delete-operation.vala"
				_g_object_unref0 (_data_->item);
#line 313 "gkr-item-delete-operation.c"
			}
		}
	}
#line 39 "../gkr/gkr-item-delete-operation.vala"
	_data_->result = TRUE;
#line 39 "../gkr/gkr-item-delete-operation.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 39 "../gkr/gkr-item-delete-operation.vala"
	if (_data_->_state_ != 0) {
#line 39 "../gkr/gkr-item-delete-operation.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 39 "../gkr/gkr-item-delete-operation.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 327 "gkr-item-delete-operation.c"
		}
	}
#line 39 "../gkr/gkr-item-delete-operation.vala"
	g_object_unref (_data_->_async_result);
#line 39 "../gkr/gkr-item-delete-operation.vala"
	return FALSE;
#line 334 "gkr-item-delete-operation.c"
}

static void
seahorse_gkr_item_delete_operation_class_init (SeahorseGkrItemDeleteOperationClass * klass,
                                               gpointer klass_data)
{
#line 21 "../gkr/gkr-item-delete-operation.vala"
	seahorse_gkr_item_delete_operation_parent_class = g_type_class_peek_parent (klass);
#line 21 "../gkr/gkr-item-delete-operation.vala"
	((SeahorseDeleteOperationClass *) klass)->execute = (void (*) (SeahorseDeleteOperation*, GCancellable*, GAsyncReadyCallback, gpointer)) seahorse_gkr_item_delete_operation_real_execute;
#line 21 "../gkr/gkr-item-delete-operation.vala"
	((SeahorseDeleteOperationClass *) klass)->execute_finish = (gboolean (*) (SeahorseDeleteOperation*, GAsyncResult*, GError**)) seahorse_gkr_item_delete_operation_execute_finish;
#line 347 "gkr-item-delete-operation.c"
}

static void
seahorse_gkr_item_delete_operation_instance_init (SeahorseGkrItemDeleteOperation * self,
                                                  gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
seahorse_gkr_item_delete_operation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseGkrItemDeleteOperationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_gkr_item_delete_operation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseGkrItemDeleteOperation), 0, (GInstanceInitFunc) seahorse_gkr_item_delete_operation_instance_init, NULL };
	GType seahorse_gkr_item_delete_operation_type_id;
	seahorse_gkr_item_delete_operation_type_id = g_type_register_static (SEAHORSE_TYPE_DELETE_OPERATION, "SeahorseGkrItemDeleteOperation", &g_define_type_info, 0);
	return seahorse_gkr_item_delete_operation_type_id;
}

GType
seahorse_gkr_item_delete_operation_get_type (void)
{
	static gsize seahorse_gkr_item_delete_operation_type_id__once = 0;
	if (g_once_init_enter (&seahorse_gkr_item_delete_operation_type_id__once)) {
		GType seahorse_gkr_item_delete_operation_type_id;
		seahorse_gkr_item_delete_operation_type_id = seahorse_gkr_item_delete_operation_get_type_once ();
		g_once_init_leave (&seahorse_gkr_item_delete_operation_type_id__once, seahorse_gkr_item_delete_operation_type_id);
	}
	return seahorse_gkr_item_delete_operation_type_id__once;
}

