/* pkcs11-certificate-widget.c generated by valac 0.56.18, the Vala compiler
 * generated from pkcs11-certificate-widget.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2013 Red Hat Inc.
 * Copyright (C) 2020 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * Author: Stef Walter <stefw@redhat.com>
 */

#include "seahorse-pkcs11.h"
#include <gcr/gcr.h>
#include <gtk/gtk.h>
#include <adwaita.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_PKCS11_CERTIFICATE_WIDGET_0_PROPERTY,
	SEAHORSE_PKCS11_CERTIFICATE_WIDGET_CERTIFICATE_PROPERTY,
	SEAHORSE_PKCS11_CERTIFICATE_WIDGET_NUM_PROPERTIES
};
static GParamSpec* seahorse_pkcs11_certificate_widget_properties[SEAHORSE_PKCS11_CERTIFICATE_WIDGET_NUM_PROPERTIES];

#define SEAHORSE_PKCS11_CERTIFICATE_WIDGET_TYPE_RDN (seahorse_pkcs11_certificate_widget_rdn_get_type ())
typedef struct _SeahorsePkcs11CertificateWidgetRdn SeahorsePkcs11CertificateWidgetRdn;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	SEAHORSE_PKCS11_CERTIFICATE_WIDGET_NOTIFICATION_SIGNAL,
	SEAHORSE_PKCS11_CERTIFICATE_WIDGET_NUM_SIGNALS
};
static guint seahorse_pkcs11_certificate_widget_signals[SEAHORSE_PKCS11_CERTIFICATE_WIDGET_NUM_SIGNALS] = {0};

struct _SeahorsePkcs11CertificateWidgetPrivate {
	GcrCertificate* _certificate;
	GtkLabel* name_label;
	GtkLabel* issuer_short_label;
	GtkLabel* expires_short_label;
	AdwExpanderRow* subject_row;
	AdwExpanderRow* issuer_row;
	AdwActionRow* issued_date_row;
	AdwActionRow* expires_row;
	AdwActionRow* version_row;
	AdwActionRow* serial_nr_row;
	AdwActionRow* sha256_fingerprint_row;
	AdwActionRow* md5_fingerprint_row;
	AdwActionRow* public_key_algo_row;
	AdwActionRow* public_key_size_row;
	AdwActionRow* public_key_algo_params_row;
	GtkLabel* public_key_label;
};

struct _SeahorsePkcs11CertificateWidgetRdn {
	const gchar* id;
	const gchar* display;
};

static gint SeahorsePkcs11CertificateWidget_private_offset;
static gpointer seahorse_pkcs11_certificate_widget_parent_class = NULL;

static GType seahorse_pkcs11_certificate_widget_rdn_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SeahorsePkcs11CertificateWidgetRdn* seahorse_pkcs11_certificate_widget_rdn_dup (const SeahorsePkcs11CertificateWidgetRdn* self);
static void seahorse_pkcs11_certificate_widget_rdn_free (SeahorsePkcs11CertificateWidgetRdn* self);
static void seahorse_pkcs11_certificate_widget_fill_in_certificate_details (SeahorsePkcs11CertificateWidget* self,
                                                                     GcrCertificate* cert);
static void seahorse_pkcs11_certificate_widget_fill_in_rdn (SeahorsePkcs11CertificateWidget* self,
                                                     AdwExpanderRow* expander_row,
                                                     SeahorsePkcs11CertificateWidgetRdn* rdn,
                                                     const gchar* val);
static void seahorse_pkcs11_certificate_widget_set_row_value (SeahorsePkcs11CertificateWidget* self,
                                                       AdwActionRow* row,
                                                       const gchar* value,
                                                       const gchar* fallback);
static gchar* seahorse_pkcs11_certificate_widget_bytes_to_hex (SeahorsePkcs11CertificateWidget* self,
                                                        GBytes* bytes,
                                                        const gchar* sep2char);
static void seahorse_pkcs11_certificate_widget_set_label_value (SeahorsePkcs11CertificateWidget* self,
                                                         GtkLabel* label,
                                                         const gchar* value,
                                                         const gchar* fallback);
static void seahorse_pkcs11_certificate_widget_add_basic_constraints (SeahorsePkcs11CertificateWidget* self,
                                                               AdwPreferencesGroup* group,
                                                               GcrCertificateExtensionBasicConstraints* ext);
static void seahorse_pkcs11_certificate_widget_add_key_usage (SeahorsePkcs11CertificateWidget* self,
                                                       AdwPreferencesGroup* group,
                                                       GcrCertificateExtensionKeyUsage* ext);
static void seahorse_pkcs11_certificate_widget_add_ext_key_usage (SeahorsePkcs11CertificateWidget* self,
                                                           AdwPreferencesGroup* group,
                                                           GcrCertificateExtensionExtendedKeyUsage* ext);
static void seahorse_pkcs11_certificate_widget_add_ski (SeahorsePkcs11CertificateWidget* self,
                                                 AdwPreferencesGroup* group,
                                                 GcrCertificateExtensionSubjectKeyIdentifier* ext);
static void seahorse_pkcs11_certificate_widget_add_san (SeahorsePkcs11CertificateWidget* self,
                                                 AdwPreferencesGroup* group,
                                                 GcrCertificateExtensionSubjectAltName* ext);
static void seahorse_pkcs11_certificate_widget_add_generic_extension (SeahorsePkcs11CertificateWidget* self,
                                                               AdwPreferencesGroup* group,
                                                               GcrCertificateExtension* ext);
static AdwActionRow* seahorse_pkcs11_certificate_widget_create_property_row (SeahorsePkcs11CertificateWidget* self,
                                                                      const gchar* title,
                                                                      const gchar* value,
                                                                      const gchar* fallback);
static void seahorse_pkcs11_certificate_widget_action_copy_public_key (SeahorsePkcs11CertificateWidget* self,
                                                                const gchar* action_name,
                                                                GVariant* param);
static GObject * seahorse_pkcs11_certificate_widget_constructor (GType type,
                                                          guint n_construct_properties,
                                                          GObjectConstructParam * construct_properties);
static void seahorse_pkcs11_certificate_widget_finalize (GObject * obj);
static GType seahorse_pkcs11_certificate_widget_get_type_once (void);
static void _vala_seahorse_pkcs11_certificate_widget_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_seahorse_pkcs11_certificate_widget_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const SeahorsePkcs11CertificateWidgetRdn SEAHORSE_PKCS11_CERTIFICATE_WIDGET_RDNS[4] = {{"cn", N_ ("Common name")}, {"ou", N_ ("Organizational unit")}, {"o", N_ ("Organization")}, {"c", N_ ("Country")}};

static inline gpointer
seahorse_pkcs11_certificate_widget_get_instance_private (SeahorsePkcs11CertificateWidget* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorsePkcs11CertificateWidget_private_offset);
}

SeahorsePkcs11CertificateWidget*
seahorse_pkcs11_certificate_widget_construct (GType object_type,
                                              GcrCertificate* certificate)
{
	SeahorsePkcs11CertificateWidget * self = NULL;
#line 73 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_val_if_fail (certificate != NULL, NULL);
#line 74 "../pkcs11/pkcs11-certificate-widget.vala"
	self = (SeahorsePkcs11CertificateWidget*) g_object_new (object_type, "certificate", certificate, NULL);
#line 73 "../pkcs11/pkcs11-certificate-widget.vala"
	return self;
#line 182 "pkcs11-certificate-widget.c"
}

SeahorsePkcs11CertificateWidget*
seahorse_pkcs11_certificate_widget_new (GcrCertificate* certificate)
{
#line 73 "../pkcs11/pkcs11-certificate-widget.vala"
	return seahorse_pkcs11_certificate_widget_construct (SEAHORSE_PKCS11_TYPE_CERTIFICATE_WIDGET, certificate);
#line 190 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_fill_in_certificate_details (SeahorsePkcs11CertificateWidget* self,
                                                                GcrCertificate* cert)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GtkLabel* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GtkLabel* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GDateTime* expiry_date = NULL;
	GDateTime* _tmp10_;
	GDateTime* _tmp11_;
	AdwExpanderRow* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	AdwExpanderRow* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GDateTime* _tmp37_;
	GDateTime* _tmp43_;
	GDateTime* _tmp44_;
	gboolean _tmp45_;
	AdwActionRow* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	AdwActionRow* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	guint8* der_data = NULL;
	gsize _tmp58_ = 0;
	guint8* _tmp59_;
	gint der_data_length1;
	gint _der_data_size_;
	AdwActionRow* _tmp60_;
	guint8* _tmp61_;
	gint _tmp61__length1;
	gchar* _tmp62_;
	gchar* _tmp63_;
	AdwActionRow* _tmp64_;
	guint8* _tmp65_;
	gint _tmp65__length1;
	gchar* _tmp66_;
	gchar* _tmp67_;
	GcrSubjectPublicKeyInfo* public_key_info = NULL;
	GcrSubjectPublicKeyInfo* _tmp68_;
	AdwActionRow* _tmp69_;
	GcrSubjectPublicKeyInfo* _tmp70_;
	const gchar* _tmp71_;
	AdwActionRow* _tmp72_;
	GcrSubjectPublicKeyInfo* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	AdwActionRow* _tmp76_;
	GcrSubjectPublicKeyInfo* _tmp77_;
	GBytes* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	GtkLabel* _tmp81_;
	GcrSubjectPublicKeyInfo* _tmp82_;
	GBytes* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	GcrCertificateExtensionList* extension_list = NULL;
	GcrCertificateExtensionList* _tmp86_;
#line 77 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 77 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (cert != NULL);
#line 79 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp1_ = gcr_certificate_get_subject_name (cert);
#line 79 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp0_ = _tmp1_;
#line 79 "../pkcs11/pkcs11-certificate-widget.vala"
	if (_tmp0_ == NULL) {
#line 270 "pkcs11-certificate-widget.c"
		gchar* _tmp2_;
#line 79 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp2_ = g_strdup (_ ("Nameless certificate"));
#line 79 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_free0 (_tmp0_);
#line 79 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = _tmp2_;
#line 278 "pkcs11-certificate-widget.c"
	}
#line 79 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp3_ = self->priv->name_label;
#line 79 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_label_set_label (_tmp3_, _tmp0_);
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp5_ = gcr_certificate_get_issuer_name (cert);
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp4_ = _tmp5_;
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
	if (_tmp4_ == NULL) {
#line 290 "pkcs11-certificate-widget.c"
		gchar* _tmp6_;
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp6_ = g_strdup (_ ("Unknown"));
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_free0 (_tmp4_);
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp4_ = _tmp6_;
#line 298 "pkcs11-certificate-widget.c"
	}
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp7_ = self->priv->issuer_short_label;
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp8_ = g_strdup_printf (_ ("Issued by: %s"), _tmp4_);
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp9_ = _tmp8_;
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_label_set_label (_tmp7_, _tmp9_);
#line 80 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp9_);
#line 81 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp10_ = gcr_certificate_get_expiry_date (cert);
#line 81 "../pkcs11/pkcs11-certificate-widget.vala"
	expiry_date = _tmp10_;
#line 82 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp11_ = expiry_date;
#line 82 "../pkcs11/pkcs11-certificate-widget.vala"
	if (_tmp11_ != NULL) {
#line 318 "pkcs11-certificate-widget.c"
		GtkLabel* _tmp12_;
		GDateTime* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp12_ = self->priv->expires_short_label;
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp13_ = expiry_date;
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp14_ = g_date_time_format (_tmp13_, "%F");
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp15_ = _tmp14_;
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp16_ = g_strdup_printf (_ ("Expires at %s"), _tmp15_);
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp17_ = _tmp16_;
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_label_set_label (_tmp12_, _tmp17_);
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_free0 (_tmp17_);
#line 83 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_free0 (_tmp15_);
#line 343 "pkcs11-certificate-widget.c"
	} else {
		GtkLabel* _tmp18_;
#line 85 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp18_ = self->priv->expires_short_label;
#line 85 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_label_set_label (_tmp18_, _ ("Never expires"));
#line 350 "pkcs11-certificate-widget.c"
	}
#line 88 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp19_ = self->priv->subject_row;
#line 88 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp20_ = gcr_certificate_get_subject_part (cert, "cn");
#line 88 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp21_ = _tmp20_;
#line 88 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp19_, _tmp21_);
#line 88 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp21_);
#line 362 "pkcs11-certificate-widget.c"
	{
		SeahorsePkcs11CertificateWidgetRdn* rdn_collection = NULL;
		gint rdn_collection_length1 = 0;
		gint _rdn_collection_size_ = 0;
		gint rdn_it = 0;
#line 89 "../pkcs11/pkcs11-certificate-widget.vala"
		rdn_collection = SEAHORSE_PKCS11_CERTIFICATE_WIDGET_RDNS;
#line 89 "../pkcs11/pkcs11-certificate-widget.vala"
		rdn_collection_length1 = G_N_ELEMENTS (SEAHORSE_PKCS11_CERTIFICATE_WIDGET_RDNS);
#line 89 "../pkcs11/pkcs11-certificate-widget.vala"
		for (rdn_it = 0; rdn_it < rdn_collection_length1; rdn_it = rdn_it + 1) {
#line 374 "pkcs11-certificate-widget.c"
			SeahorsePkcs11CertificateWidgetRdn rdn = {0};
#line 89 "../pkcs11/pkcs11-certificate-widget.vala"
			rdn = rdn_collection[rdn_it];
#line 378 "pkcs11-certificate-widget.c"
			{
				AdwExpanderRow* _tmp22_;
				SeahorsePkcs11CertificateWidgetRdn _tmp23_;
				SeahorsePkcs11CertificateWidgetRdn _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
#line 90 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp22_ = self->priv->subject_row;
#line 90 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp23_ = rdn;
#line 90 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp24_ = rdn;
#line 90 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp25_ = _tmp24_.id;
#line 90 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp26_ = gcr_certificate_get_subject_part (cert, _tmp25_);
#line 90 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp27_ = _tmp26_;
#line 90 "../pkcs11/pkcs11-certificate-widget.vala"
				seahorse_pkcs11_certificate_widget_fill_in_rdn (self, _tmp22_, &_tmp23_, _tmp27_);
#line 90 "../pkcs11/pkcs11-certificate-widget.vala"
				_g_free0 (_tmp27_);
#line 402 "pkcs11-certificate-widget.c"
			}
		}
	}
#line 93 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp28_ = self->priv->issuer_row;
#line 93 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp29_ = gcr_certificate_get_subject_part (cert, "cn");
#line 93 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp30_ = _tmp29_;
#line 93 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp28_, _tmp30_);
#line 93 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp30_);
#line 416 "pkcs11-certificate-widget.c"
	{
		SeahorsePkcs11CertificateWidgetRdn* rdn_collection = NULL;
		gint rdn_collection_length1 = 0;
		gint _rdn_collection_size_ = 0;
		gint rdn_it = 0;
#line 94 "../pkcs11/pkcs11-certificate-widget.vala"
		rdn_collection = SEAHORSE_PKCS11_CERTIFICATE_WIDGET_RDNS;
#line 94 "../pkcs11/pkcs11-certificate-widget.vala"
		rdn_collection_length1 = G_N_ELEMENTS (SEAHORSE_PKCS11_CERTIFICATE_WIDGET_RDNS);
#line 94 "../pkcs11/pkcs11-certificate-widget.vala"
		for (rdn_it = 0; rdn_it < rdn_collection_length1; rdn_it = rdn_it + 1) {
#line 428 "pkcs11-certificate-widget.c"
			SeahorsePkcs11CertificateWidgetRdn rdn = {0};
#line 94 "../pkcs11/pkcs11-certificate-widget.vala"
			rdn = rdn_collection[rdn_it];
#line 432 "pkcs11-certificate-widget.c"
			{
				AdwExpanderRow* _tmp31_;
				SeahorsePkcs11CertificateWidgetRdn _tmp32_;
				SeahorsePkcs11CertificateWidgetRdn _tmp33_;
				const gchar* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
#line 95 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp31_ = self->priv->issuer_row;
#line 95 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp32_ = rdn;
#line 95 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp33_ = rdn;
#line 95 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp34_ = _tmp33_.id;
#line 95 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp35_ = gcr_certificate_get_issuer_part (cert, _tmp34_);
#line 95 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp36_ = _tmp35_;
#line 95 "../pkcs11/pkcs11-certificate-widget.vala"
				seahorse_pkcs11_certificate_widget_fill_in_rdn (self, _tmp31_, &_tmp32_, _tmp36_);
#line 95 "../pkcs11/pkcs11-certificate-widget.vala"
				_g_free0 (_tmp36_);
#line 456 "pkcs11-certificate-widget.c"
			}
		}
	}
#line 98 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp37_ = expiry_date;
#line 98 "../pkcs11/pkcs11-certificate-widget.vala"
	if (_tmp37_ != NULL) {
#line 464 "pkcs11-certificate-widget.c"
		AdwActionRow* _tmp38_;
		GDateTime* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 99 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp38_ = self->priv->expires_row;
#line 99 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp39_ = expiry_date;
#line 99 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp40_ = g_date_time_format (_tmp39_, "%F");
#line 99 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp41_ = _tmp40_;
#line 99 "../pkcs11/pkcs11-certificate-widget.vala"
		seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp38_, _tmp41_, _ ("Unknown"));
#line 99 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_free0 (_tmp41_);
#line 481 "pkcs11-certificate-widget.c"
	} else {
		AdwActionRow* _tmp42_;
#line 101 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp42_ = self->priv->expires_row;
#line 101 "../pkcs11/pkcs11-certificate-widget.vala"
		seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp42_, _ ("No expiry date"), _ ("Unknown"));
#line 488 "pkcs11-certificate-widget.c"
	}
#line 102 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp43_ = gcr_certificate_get_issued_date (cert);
#line 102 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp44_ = _tmp43_;
#line 102 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 102 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_date_time_unref0 (_tmp44_);
#line 102 "../pkcs11/pkcs11-certificate-widget.vala"
	if (_tmp45_) {
#line 500 "pkcs11-certificate-widget.c"
		AdwActionRow* _tmp46_;
		GDateTime* _tmp47_;
		GDateTime* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
#line 103 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp46_ = self->priv->issued_date_row;
#line 103 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp47_ = gcr_certificate_get_issued_date (cert);
#line 103 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp48_ = _tmp47_;
#line 103 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp49_ = g_date_time_format (_tmp48_, "%F");
#line 103 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp50_ = _tmp49_;
#line 103 "../pkcs11/pkcs11-certificate-widget.vala"
		seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp46_, _tmp50_, _ ("Unknown"));
#line 103 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_free0 (_tmp50_);
#line 103 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_date_time_unref0 (_tmp48_);
#line 522 "pkcs11-certificate-widget.c"
	} else {
		AdwActionRow* _tmp51_;
#line 105 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp51_ = self->priv->issued_date_row;
#line 105 "../pkcs11/pkcs11-certificate-widget.vala"
		seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp51_, _ ("No issued date"), _ ("Unknown"));
#line 529 "pkcs11-certificate-widget.c"
	}
#line 107 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp52_ = self->priv->version_row;
#line 107 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp53_ = g_strdup_printf ("%lu", gcr_certificate_get_version (cert));
#line 107 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp54_ = _tmp53_;
#line 107 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp52_, _tmp54_, _ ("Unknown"));
#line 107 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp54_);
#line 108 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp55_ = self->priv->serial_nr_row;
#line 108 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp56_ = gcr_certificate_get_serial_number_hex (cert);
#line 108 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp57_ = _tmp56_;
#line 108 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp55_, _tmp57_, _ ("Unknown"));
#line 108 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp57_);
#line 111 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp59_ = gcr_certificate_get_der_data (cert, &_tmp58_);
#line 111 "../pkcs11/pkcs11-certificate-widget.vala"
	der_data = _tmp59_;
#line 111 "../pkcs11/pkcs11-certificate-widget.vala"
	der_data_length1 = _tmp58_;
#line 111 "../pkcs11/pkcs11-certificate-widget.vala"
	_der_data_size_ = der_data_length1;
#line 112 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp60_ = self->priv->sha256_fingerprint_row;
#line 112 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp61_ = der_data;
#line 112 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp61__length1 = der_data_length1;
#line 112 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp62_ = g_compute_checksum_for_data (G_CHECKSUM_SHA256, _tmp61_, (gint) _tmp61__length1);
#line 112 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp63_ = _tmp62_;
#line 112 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp60_, _tmp63_, _ ("Unknown"));
#line 112 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp63_);
#line 114 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp64_ = self->priv->md5_fingerprint_row;
#line 114 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp65_ = der_data;
#line 114 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp65__length1 = der_data_length1;
#line 114 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp66_ = g_compute_checksum_for_data (G_CHECKSUM_MD5, _tmp65_, (gint) _tmp65__length1);
#line 114 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp67_ = _tmp66_;
#line 114 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp64_, _tmp67_, _ ("Unknown"));
#line 114 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp67_);
#line 117 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp68_ = gcr_certificate_get_public_key_info (cert);
#line 117 "../pkcs11/pkcs11-certificate-widget.vala"
	public_key_info = _tmp68_;
#line 118 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp69_ = self->priv->public_key_algo_row;
#line 118 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp70_ = public_key_info;
#line 118 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp71_ = gcr_subject_public_key_info_get_algorithm_description (_tmp70_);
#line 118 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp69_, _tmp71_, _ ("Unknown"));
#line 119 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp72_ = self->priv->public_key_size_row;
#line 119 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp73_ = public_key_info;
#line 119 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp74_ = g_strdup_printf ("%u bits", gcr_subject_public_key_info_get_key_size (_tmp73_));
#line 119 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp75_ = _tmp74_;
#line 119 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp72_, _tmp75_, _ ("Unknown"));
#line 119 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp75_);
#line 120 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp76_ = self->priv->public_key_algo_params_row;
#line 120 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp77_ = public_key_info;
#line 120 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp78_ = gcr_subject_public_key_info_get_algorithm_parameters_raw (_tmp77_);
#line 120 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp79_ = seahorse_pkcs11_certificate_widget_bytes_to_hex (self, _tmp78_, NULL);
#line 120 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp80_ = _tmp79_;
#line 120 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_row_value (self, _tmp76_, _tmp80_, _ ("Unknown"));
#line 120 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp80_);
#line 121 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp81_ = self->priv->public_key_label;
#line 121 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp82_ = public_key_info;
#line 121 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp83_ = gcr_subject_public_key_info_get_key (_tmp82_);
#line 121 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp84_ = seahorse_pkcs11_certificate_widget_bytes_to_hex (self, _tmp83_, NULL);
#line 121 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp85_ = _tmp84_;
#line 121 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_label_value (self, _tmp81_, _tmp85_, _ ("Unknown"));
#line 121 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp85_);
#line 124 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp86_ = gcr_certificate_list_extensions (cert);
#line 124 "../pkcs11/pkcs11-certificate-widget.vala"
	extension_list = _tmp86_;
#line 643 "pkcs11-certificate-widget.c"
	{
		guint i = 0U;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
		i = (guint) 0;
#line 648 "pkcs11-certificate-widget.c"
		{
			gboolean _tmp87_ = FALSE;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
			_tmp87_ = TRUE;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
			while (TRUE) {
#line 655 "pkcs11-certificate-widget.c"
				GcrCertificateExtensionList* _tmp89_;
				guint _tmp90_;
				guint _tmp91_;
				GcrCertificateExtension* extension = NULL;
				GcrCertificateExtensionList* _tmp92_;
				GcrCertificateExtension* _tmp93_;
				AdwPreferencesGroup* prefs_group = NULL;
				AdwPreferencesGroup* _tmp94_;
				AdwPreferencesGroup* _tmp95_;
				GcrCertificateExtension* _tmp96_;
				const gchar* _tmp97_;
				GcrCertificateExtension* _tmp98_;
				AdwPreferencesGroup* _tmp101_;
				GcrCertificateExtension* _tmp102_;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
				if (!_tmp87_) {
#line 672 "pkcs11-certificate-widget.c"
					guint _tmp88_;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp88_ = i;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
					i = _tmp88_ + 1;
#line 678 "pkcs11-certificate-widget.c"
				}
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp87_ = FALSE;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp89_ = extension_list;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
				g_object_get (_tmp89_, "n-items", &_tmp90_, NULL);
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp91_ = _tmp90_;
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
				if (!(i < _tmp91_)) {
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
					break;
#line 692 "pkcs11-certificate-widget.c"
				}
#line 126 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp92_ = extension_list;
#line 126 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp93_ = gcr_certificate_extension_list_get_extension (_tmp92_, i);
#line 126 "../pkcs11/pkcs11-certificate-widget.vala"
				extension = _tmp93_;
#line 128 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp94_ = (AdwPreferencesGroup*) adw_preferences_group_new ();
#line 128 "../pkcs11/pkcs11-certificate-widget.vala"
				g_object_ref_sink (_tmp94_);
#line 128 "../pkcs11/pkcs11-certificate-widget.vala"
				prefs_group = _tmp94_;
#line 129 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp95_ = prefs_group;
#line 129 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp96_ = extension;
#line 129 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp97_ = gcr_certificate_extension_get_description (_tmp96_);
#line 129 "../pkcs11/pkcs11-certificate-widget.vala"
				adw_preferences_group_set_title (_tmp95_, _tmp97_);
#line 130 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp98_ = extension;
#line 130 "../pkcs11/pkcs11-certificate-widget.vala"
				if (gcr_certificate_extension_is_critical (_tmp98_)) {
#line 718 "pkcs11-certificate-widget.c"
					AdwPreferencesGroup* _tmp99_;
#line 131 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp99_ = prefs_group;
#line 131 "../pkcs11/pkcs11-certificate-widget.vala"
					adw_preferences_group_set_description (_tmp99_, _ ("Critical Extension"));
#line 724 "pkcs11-certificate-widget.c"
				} else {
					AdwPreferencesGroup* _tmp100_;
#line 133 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp100_ = prefs_group;
#line 133 "../pkcs11/pkcs11-certificate-widget.vala"
					adw_preferences_group_set_description (_tmp100_, _ ("Extension"));
#line 731 "pkcs11-certificate-widget.c"
				}
#line 134 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp101_ = prefs_group;
#line 134 "../pkcs11/pkcs11-certificate-widget.vala"
				gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp101_);
#line 136 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp102_ = extension;
#line 136 "../pkcs11/pkcs11-certificate-widget.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp102_, gcr_certificate_extension_basic_constraints_get_type ())) {
#line 741 "pkcs11-certificate-widget.c"
					AdwPreferencesGroup* _tmp103_;
					GcrCertificateExtension* _tmp104_;
#line 137 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp103_ = prefs_group;
#line 137 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp104_ = extension;
#line 137 "../pkcs11/pkcs11-certificate-widget.vala"
					seahorse_pkcs11_certificate_widget_add_basic_constraints (self, _tmp103_, G_TYPE_CHECK_INSTANCE_CAST (_tmp104_, gcr_certificate_extension_basic_constraints_get_type (), GcrCertificateExtensionBasicConstraints));
#line 750 "pkcs11-certificate-widget.c"
				} else {
					GcrCertificateExtension* _tmp105_;
#line 139 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp105_ = extension;
#line 139 "../pkcs11/pkcs11-certificate-widget.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp105_, gcr_certificate_extension_key_usage_get_type ())) {
#line 757 "pkcs11-certificate-widget.c"
						AdwPreferencesGroup* _tmp106_;
						GcrCertificateExtension* _tmp107_;
#line 140 "../pkcs11/pkcs11-certificate-widget.vala"
						_tmp106_ = prefs_group;
#line 140 "../pkcs11/pkcs11-certificate-widget.vala"
						_tmp107_ = extension;
#line 140 "../pkcs11/pkcs11-certificate-widget.vala"
						seahorse_pkcs11_certificate_widget_add_key_usage (self, _tmp106_, G_TYPE_CHECK_INSTANCE_CAST (_tmp107_, gcr_certificate_extension_key_usage_get_type (), GcrCertificateExtensionKeyUsage));
#line 766 "pkcs11-certificate-widget.c"
					} else {
						GcrCertificateExtension* _tmp108_;
#line 142 "../pkcs11/pkcs11-certificate-widget.vala"
						_tmp108_ = extension;
#line 142 "../pkcs11/pkcs11-certificate-widget.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp108_, gcr_certificate_extension_extended_key_usage_get_type ())) {
#line 773 "pkcs11-certificate-widget.c"
							AdwPreferencesGroup* _tmp109_;
							GcrCertificateExtension* _tmp110_;
#line 143 "../pkcs11/pkcs11-certificate-widget.vala"
							_tmp109_ = prefs_group;
#line 143 "../pkcs11/pkcs11-certificate-widget.vala"
							_tmp110_ = extension;
#line 143 "../pkcs11/pkcs11-certificate-widget.vala"
							seahorse_pkcs11_certificate_widget_add_ext_key_usage (self, _tmp109_, G_TYPE_CHECK_INSTANCE_CAST (_tmp110_, gcr_certificate_extension_extended_key_usage_get_type (), GcrCertificateExtensionExtendedKeyUsage));
#line 782 "pkcs11-certificate-widget.c"
						} else {
							GcrCertificateExtension* _tmp111_;
#line 145 "../pkcs11/pkcs11-certificate-widget.vala"
							_tmp111_ = extension;
#line 145 "../pkcs11/pkcs11-certificate-widget.vala"
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp111_, gcr_certificate_extension_subject_key_identifier_get_type ())) {
#line 789 "pkcs11-certificate-widget.c"
								AdwPreferencesGroup* _tmp112_;
								GcrCertificateExtension* _tmp113_;
#line 146 "../pkcs11/pkcs11-certificate-widget.vala"
								_tmp112_ = prefs_group;
#line 146 "../pkcs11/pkcs11-certificate-widget.vala"
								_tmp113_ = extension;
#line 146 "../pkcs11/pkcs11-certificate-widget.vala"
								seahorse_pkcs11_certificate_widget_add_ski (self, _tmp112_, G_TYPE_CHECK_INSTANCE_CAST (_tmp113_, gcr_certificate_extension_subject_key_identifier_get_type (), GcrCertificateExtensionSubjectKeyIdentifier));
#line 798 "pkcs11-certificate-widget.c"
							} else {
								GcrCertificateExtension* _tmp114_;
#line 147 "../pkcs11/pkcs11-certificate-widget.vala"
								_tmp114_ = extension;
#line 147 "../pkcs11/pkcs11-certificate-widget.vala"
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp114_, gcr_certificate_extension_subject_alt_name_get_type ())) {
#line 805 "pkcs11-certificate-widget.c"
									AdwPreferencesGroup* _tmp115_;
									GcrCertificateExtension* _tmp116_;
#line 148 "../pkcs11/pkcs11-certificate-widget.vala"
									_tmp115_ = prefs_group;
#line 148 "../pkcs11/pkcs11-certificate-widget.vala"
									_tmp116_ = extension;
#line 148 "../pkcs11/pkcs11-certificate-widget.vala"
									seahorse_pkcs11_certificate_widget_add_san (self, _tmp115_, G_TYPE_CHECK_INSTANCE_CAST (_tmp116_, gcr_certificate_extension_subject_alt_name_get_type (), GcrCertificateExtensionSubjectAltName));
#line 814 "pkcs11-certificate-widget.c"
								} else {
									AdwPreferencesGroup* _tmp117_;
									GcrCertificateExtension* _tmp118_;
#line 150 "../pkcs11/pkcs11-certificate-widget.vala"
									_tmp117_ = prefs_group;
#line 150 "../pkcs11/pkcs11-certificate-widget.vala"
									_tmp118_ = extension;
#line 150 "../pkcs11/pkcs11-certificate-widget.vala"
									seahorse_pkcs11_certificate_widget_add_generic_extension (self, _tmp117_, _tmp118_);
#line 824 "pkcs11-certificate-widget.c"
								}
							}
						}
					}
				}
#line 125 "../pkcs11/pkcs11-certificate-widget.vala"
				_g_object_unref0 (prefs_group);
#line 832 "pkcs11-certificate-widget.c"
			}
		}
	}
#line 77 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (extension_list);
#line 77 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_date_time_unref0 (expiry_date);
#line 77 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp4_);
#line 77 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp0_);
#line 844 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_add_basic_constraints (SeahorsePkcs11CertificateWidget* self,
                                                          AdwPreferencesGroup* group,
                                                          GcrCertificateExtensionBasicConstraints* ext)
{
	AdwActionRow* row = NULL;
	const gchar* _tmp0_ = NULL;
	AdwActionRow* _tmp1_;
	AdwActionRow* _tmp2_;
	gint path_len = 0;
	gchar* _tmp3_ = NULL;
	AdwActionRow* _tmp5_;
	AdwActionRow* _tmp6_;
#line 155 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 155 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (group != NULL);
#line 155 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (ext != NULL);
#line 160 "../pkcs11/pkcs11-certificate-widget.vala"
	if (gcr_certificate_extension_basic_constraints_is_ca (ext)) {
#line 160 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = _ ("Yes");
#line 870 "pkcs11-certificate-widget.c"
	} else {
#line 160 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = _ ("No");
#line 874 "pkcs11-certificate-widget.c"
	}
#line 159 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp1_ = seahorse_pkcs11_certificate_widget_create_property_row (self, _ ("Certificate Authority"), _tmp0_, _ ("Unknown"));
#line 159 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (row);
#line 159 "../pkcs11/pkcs11-certificate-widget.vala"
	row = _tmp1_;
#line 161 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = row;
#line 161 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_group_add (group, (GtkWidget*) _tmp2_);
#line 163 "../pkcs11/pkcs11-certificate-widget.vala"
	path_len = gcr_certificate_extension_basic_constraints_get_path_len_constraint (ext);
#line 165 "../pkcs11/pkcs11-certificate-widget.vala"
	if (path_len != -1) {
#line 890 "pkcs11-certificate-widget.c"
		gchar* _tmp4_;
#line 165 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp4_ = g_strdup_printf ("%i", path_len);
#line 165 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_free0 (_tmp3_);
#line 165 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp3_ = _tmp4_;
#line 898 "pkcs11-certificate-widget.c"
	} else {
#line 165 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_free0 (_tmp3_);
#line 165 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp3_ = NULL;
#line 904 "pkcs11-certificate-widget.c"
	}
#line 164 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp5_ = seahorse_pkcs11_certificate_widget_create_property_row (self, _ ("Max Path Length"), _tmp3_, _ ("Unset"));
#line 164 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (row);
#line 164 "../pkcs11/pkcs11-certificate-widget.vala"
	row = _tmp5_;
#line 167 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp6_ = row;
#line 167 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_group_add (group, (GtkWidget*) _tmp6_);
#line 155 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp3_);
#line 155 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (row);
#line 920 "pkcs11-certificate-widget.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 934 "pkcs11-certificate-widget.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 938 "pkcs11-certificate-widget.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 944 "pkcs11-certificate-widget.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 949 "pkcs11-certificate-widget.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 955 "pkcs11-certificate-widget.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 959 "pkcs11-certificate-widget.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 963 "pkcs11-certificate-widget.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 967 "pkcs11-certificate-widget.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 971 "pkcs11-certificate-widget.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 975 "pkcs11-certificate-widget.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 990 "pkcs11-certificate-widget.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 999 "pkcs11-certificate-widget.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1006 "pkcs11-certificate-widget.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1012 "pkcs11-certificate-widget.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1020 "pkcs11-certificate-widget.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1024 "pkcs11-certificate-widget.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1030 "pkcs11-certificate-widget.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1035 "pkcs11-certificate-widget.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1041 "pkcs11-certificate-widget.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1045 "pkcs11-certificate-widget.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1049 "pkcs11-certificate-widget.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 1055 "pkcs11-certificate-widget.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1061 "pkcs11-certificate-widget.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1073 "pkcs11-certificate-widget.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1077 "pkcs11-certificate-widget.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1081 "pkcs11-certificate-widget.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 1086 "pkcs11-certificate-widget.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 1094 "pkcs11-certificate-widget.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1112 "pkcs11-certificate-widget.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1118 "pkcs11-certificate-widget.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1122 "pkcs11-certificate-widget.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1130 "pkcs11-certificate-widget.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 1139 "pkcs11-certificate-widget.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1148 "pkcs11-certificate-widget.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1154 "pkcs11-certificate-widget.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 1162 "pkcs11-certificate-widget.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1174 "pkcs11-certificate-widget.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1180 "pkcs11-certificate-widget.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1184 "pkcs11-certificate-widget.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1192 "pkcs11-certificate-widget.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 1203 "pkcs11-certificate-widget.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 1212 "pkcs11-certificate-widget.c"
	}
}

static void
seahorse_pkcs11_certificate_widget_add_key_usage (SeahorsePkcs11CertificateWidget* self,
                                                  AdwPreferencesGroup* group,
                                                  GcrCertificateExtensionKeyUsage* ext)
{
	gchar* descriptions = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar* _tmp4_;
	AdwActionRow* row = NULL;
	AdwActionRow* _tmp5_;
#line 170 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 170 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (group != NULL);
#line 170 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (ext != NULL);
#line 172 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp1_ = _tmp0_ = gcr_certificate_extension_key_usage_get_descriptions (ext);
#line 172 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = _tmp1_;
#line 172 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2__length1 = _vala_array_length (_tmp0_);
#line 172 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp3_ = _vala_g_strjoinv (", ", _tmp2_, (gint) _vala_array_length (_tmp0_));
#line 172 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp4_ = _tmp3_;
#line 172 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 172 "../pkcs11/pkcs11-certificate-widget.vala"
	descriptions = _tmp4_;
#line 173 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp5_ = seahorse_pkcs11_certificate_widget_create_property_row (self, _ ("Purposes"), descriptions, _ ("Unknown"));
#line 173 "../pkcs11/pkcs11-certificate-widget.vala"
	row = _tmp5_;
#line 174 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_group_add (group, (GtkWidget*) row);
#line 170 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (row);
#line 170 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (descriptions);
#line 1260 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_add_ext_key_usage (SeahorsePkcs11CertificateWidget* self,
                                                      AdwPreferencesGroup* group,
                                                      GcrCertificateExtensionExtendedKeyUsage* ext)
{
	gchar* descriptions = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar* _tmp4_;
	AdwActionRow* row = NULL;
	AdwActionRow* _tmp5_;
#line 177 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 177 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (group != NULL);
#line 177 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (ext != NULL);
#line 179 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp1_ = _tmp0_ = gcr_certificate_extension_extended_key_usage_get_descriptions (ext);
#line 179 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = _tmp1_;
#line 179 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2__length1 = _vala_array_length (_tmp0_);
#line 179 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp3_ = _vala_g_strjoinv (", ", _tmp2_, (gint) _vala_array_length (_tmp0_));
#line 179 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp4_ = _tmp3_;
#line 179 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 179 "../pkcs11/pkcs11-certificate-widget.vala"
	descriptions = _tmp4_;
#line 180 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp5_ = seahorse_pkcs11_certificate_widget_create_property_row (self, _ ("Purposes"), descriptions, _ ("Unknown"));
#line 180 "../pkcs11/pkcs11-certificate-widget.vala"
	row = _tmp5_;
#line 181 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_group_add (group, (GtkWidget*) row);
#line 177 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (row);
#line 177 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (descriptions);
#line 1307 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_add_ski (SeahorsePkcs11CertificateWidget* self,
                                            AdwPreferencesGroup* group,
                                            GcrCertificateExtensionSubjectKeyIdentifier* ext)
{
	gchar* keyid = NULL;
	GBytes* _tmp0_;
	gchar* _tmp1_;
	AdwActionRow* row = NULL;
	AdwActionRow* _tmp2_;
#line 184 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 184 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (group != NULL);
#line 184 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (ext != NULL);
#line 186 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp0_ = gcr_certificate_extension_subject_key_identifier_get_key_id (ext);
#line 186 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp1_ = seahorse_pkcs11_certificate_widget_bytes_to_hex (self, _tmp0_, NULL);
#line 186 "../pkcs11/pkcs11-certificate-widget.vala"
	keyid = _tmp1_;
#line 187 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = seahorse_pkcs11_certificate_widget_create_property_row (self, _ ("Subject Key Identifier"), keyid, _ ("Unknown"));
#line 187 "../pkcs11/pkcs11-certificate-widget.vala"
	row = _tmp2_;
#line 188 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_add_css_class ((GtkWidget*) row, "monospace");
#line 189 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_group_add (group, (GtkWidget*) row);
#line 184 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (row);
#line 184 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (keyid);
#line 1344 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_add_san (SeahorsePkcs11CertificateWidget* self,
                                            AdwPreferencesGroup* group,
                                            GcrCertificateExtensionSubjectAltName* ext)
{
#line 192 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 192 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (group != NULL);
#line 192 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (ext != NULL);
#line 1358 "pkcs11-certificate-widget.c"
	{
		guint i = 0U;
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
		i = (guint) 0;
#line 1363 "pkcs11-certificate-widget.c"
		{
			gboolean _tmp0_ = FALSE;
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
			_tmp0_ = TRUE;
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
			while (TRUE) {
#line 1370 "pkcs11-certificate-widget.c"
				GcrGeneralName* name = NULL;
				GcrGeneralName* _tmp2_;
				AdwActionRow* row = NULL;
				GcrGeneralName* _tmp3_;
				const gchar* _tmp4_;
				GcrGeneralName* _tmp5_;
				const gchar* _tmp6_;
				AdwActionRow* _tmp7_;
				AdwActionRow* _tmp8_;
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
				if (!_tmp0_) {
#line 1382 "pkcs11-certificate-widget.c"
					guint _tmp1_;
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp1_ = i;
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
					i = _tmp1_ + 1;
#line 1388 "pkcs11-certificate-widget.c"
				}
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp0_ = FALSE;
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) ext))) {
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
					break;
#line 1396 "pkcs11-certificate-widget.c"
				}
#line 195 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp2_ = gcr_certificate_extension_subject_alt_name_get_name (ext, i);
#line 195 "../pkcs11/pkcs11-certificate-widget.vala"
				name = _tmp2_;
#line 197 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp3_ = name;
#line 197 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp4_ = gcr_general_name_get_description (_tmp3_);
#line 197 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp5_ = name;
#line 197 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp6_ = gcr_general_name_get_value (_tmp5_);
#line 197 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp7_ = seahorse_pkcs11_certificate_widget_create_property_row (self, _tmp4_, _tmp6_, _ ("Unknown"));
#line 197 "../pkcs11/pkcs11-certificate-widget.vala"
				row = _tmp7_;
#line 198 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp8_ = row;
#line 198 "../pkcs11/pkcs11-certificate-widget.vala"
				adw_preferences_group_add (group, (GtkWidget*) _tmp8_);
#line 194 "../pkcs11/pkcs11-certificate-widget.vala"
				_g_object_unref0 (row);
#line 1420 "pkcs11-certificate-widget.c"
			}
		}
	}
}

static void
seahorse_pkcs11_certificate_widget_add_generic_extension (SeahorsePkcs11CertificateWidget* self,
                                                          AdwPreferencesGroup* group,
                                                          GcrCertificateExtension* ext)
{
	gchar* value_str = NULL;
	GBytes* _tmp0_;
	GBytes* _tmp1_;
	gchar* _tmp2_;
	AdwActionRow* row = NULL;
	AdwActionRow* _tmp3_;
#line 202 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 202 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (group != NULL);
#line 202 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (ext != NULL);
#line 204 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp0_ = gcr_certificate_extension_get_value (ext);
#line 204 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp1_ = _tmp0_;
#line 204 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = seahorse_pkcs11_certificate_widget_bytes_to_hex (self, _tmp1_, NULL);
#line 204 "../pkcs11/pkcs11-certificate-widget.vala"
	value_str = _tmp2_;
#line 205 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp3_ = seahorse_pkcs11_certificate_widget_create_property_row (self, _ ("Raw value"), value_str, _ ("Unknown"));
#line 205 "../pkcs11/pkcs11-certificate-widget.vala"
	row = _tmp3_;
#line 206 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_group_add (group, (GtkWidget*) row);
#line 202 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (row);
#line 202 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (value_str);
#line 1461 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_fill_in_rdn (SeahorsePkcs11CertificateWidget* self,
                                                AdwExpanderRow* expander_row,
                                                SeahorsePkcs11CertificateWidgetRdn* rdn,
                                                const gchar* val)
{
	gboolean _tmp0_ = FALSE;
	AdwActionRow* row = NULL;
	AdwActionRow* _tmp1_;
	AdwActionRow* _tmp2_;
	AdwActionRow* _tmp3_;
	SeahorsePkcs11CertificateWidgetRdn _tmp4_;
	const gchar* _tmp5_;
	AdwActionRow* _tmp6_;
	AdwActionRow* _tmp7_;
	AdwActionRow* _tmp8_;
#line 209 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 209 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (expander_row != NULL);
#line 209 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (rdn != NULL);
#line 210 "../pkcs11/pkcs11-certificate-widget.vala"
	if (val == NULL) {
#line 210 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = TRUE;
#line 1490 "pkcs11-certificate-widget.c"
	} else {
#line 210 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = g_strcmp0 (val, "") == 0;
#line 1494 "pkcs11-certificate-widget.c"
	}
#line 210 "../pkcs11/pkcs11-certificate-widget.vala"
	if (_tmp0_) {
#line 211 "../pkcs11/pkcs11-certificate-widget.vala"
		return;
#line 1500 "pkcs11-certificate-widget.c"
	}
#line 213 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp1_ = (AdwActionRow*) adw_action_row_new ();
#line 213 "../pkcs11/pkcs11-certificate-widget.vala"
	g_object_ref_sink (_tmp1_);
#line 213 "../pkcs11/pkcs11-certificate-widget.vala"
	row = _tmp1_;
#line 214 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = row;
#line 214 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp2_, "property");
#line 215 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp3_ = row;
#line 215 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp4_ = *rdn;
#line 215 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp5_ = _tmp4_.display;
#line 215 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp3_, gettext (_tmp5_));
#line 216 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp6_ = row;
#line 216 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_action_row_set_subtitle (_tmp6_, val);
#line 217 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp7_ = row;
#line 217 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_action_row_set_subtitle_selectable (_tmp7_, TRUE);
#line 218 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp8_ = row;
#line 218 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_expander_row_add_row (expander_row, (GtkWidget*) _tmp8_);
#line 209 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (row);
#line 1534 "pkcs11-certificate-widget.c"
}

static gchar*
seahorse_pkcs11_certificate_widget_bytes_to_hex (SeahorsePkcs11CertificateWidget* self,
                                                 GBytes* bytes,
                                                 const gchar* sep2char)
{
	GString* _result_ = NULL;
	GString* _tmp0_;
	guint8* data = NULL;
	gsize _tmp1_ = 0;
	guint8* _tmp2_;
	gint data_length1;
	gint _data_size_;
	GString* _tmp12_;
	gchar* _tmp13_;
	gchar* result;
#line 221 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 221 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_val_if_fail (bytes != NULL, NULL);
#line 222 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp0_ = g_string_new ("");
#line 222 "../pkcs11/pkcs11-certificate-widget.vala"
	_result_ = _tmp0_;
#line 223 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = g_bytes_get_data (bytes, &_tmp1_);
#line 223 "../pkcs11/pkcs11-certificate-widget.vala"
	data = _tmp2_;
#line 223 "../pkcs11/pkcs11-certificate-widget.vala"
	data_length1 = _tmp1_;
#line 223 "../pkcs11/pkcs11-certificate-widget.vala"
	_data_size_ = data_length1;
#line 1568 "pkcs11-certificate-widget.c"
	{
		guint i = 0U;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
		i = (guint) 0;
#line 1573 "pkcs11-certificate-widget.c"
		{
			gboolean _tmp3_ = FALSE;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
			_tmp3_ = TRUE;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
			while (TRUE) {
#line 1580 "pkcs11-certificate-widget.c"
				guint8* _tmp5_;
				gint _tmp5__length1;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				GString* _tmp9_;
				guint8* _tmp10_;
				gint _tmp10__length1;
				guint8 _tmp11_;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
				if (!_tmp3_) {
#line 1591 "pkcs11-certificate-widget.c"
					guint _tmp4_;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp4_ = i;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
					i = _tmp4_ + 1;
#line 1597 "pkcs11-certificate-widget.c"
				}
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp3_ = FALSE;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp5_ = data;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp5__length1 = data_length1;
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
				if (!(i < ((guint) _tmp5__length1))) {
#line 224 "../pkcs11/pkcs11-certificate-widget.vala"
					break;
#line 1609 "pkcs11-certificate-widget.c"
				}
#line 225 "../pkcs11/pkcs11-certificate-widget.vala"
				if (sep2char != NULL) {
#line 225 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp7_ = i > ((guint) 0);
#line 1615 "pkcs11-certificate-widget.c"
				} else {
#line 225 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp7_ = FALSE;
#line 1619 "pkcs11-certificate-widget.c"
				}
#line 225 "../pkcs11/pkcs11-certificate-widget.vala"
				if (_tmp7_) {
#line 225 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp6_ = (i % 2) == ((guint) 0);
#line 1625 "pkcs11-certificate-widget.c"
				} else {
#line 225 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp6_ = FALSE;
#line 1629 "pkcs11-certificate-widget.c"
				}
#line 225 "../pkcs11/pkcs11-certificate-widget.vala"
				if (_tmp6_) {
#line 1633 "pkcs11-certificate-widget.c"
					GString* _tmp8_;
#line 226 "../pkcs11/pkcs11-certificate-widget.vala"
					_tmp8_ = _result_;
#line 226 "../pkcs11/pkcs11-certificate-widget.vala"
					g_string_append (_tmp8_, sep2char);
#line 1639 "pkcs11-certificate-widget.c"
				}
#line 227 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp9_ = _result_;
#line 227 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp10_ = data;
#line 227 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp10__length1 = data_length1;
#line 227 "../pkcs11/pkcs11-certificate-widget.vala"
				_tmp11_ = _tmp10_[i];
#line 227 "../pkcs11/pkcs11-certificate-widget.vala"
				g_string_append_printf (_tmp9_, "%x", (guint) _tmp11_);
#line 1651 "pkcs11-certificate-widget.c"
			}
		}
	}
#line 229 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp12_ = _result_;
#line 229 "../pkcs11/pkcs11-certificate-widget.vala"
	_result_ = NULL;
#line 229 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp13_ = g_string_free_and_steal (_tmp12_);
#line 229 "../pkcs11/pkcs11-certificate-widget.vala"
	result = _tmp13_;
#line 229 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_string_free0 (_result_);
#line 229 "../pkcs11/pkcs11-certificate-widget.vala"
	return result;
#line 1667 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_set_label_value (SeahorsePkcs11CertificateWidget* self,
                                                    GtkLabel* label,
                                                    const gchar* value,
                                                    const gchar* fallback)
{
	gboolean _tmp0_ = FALSE;
#line 232 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 232 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (label != NULL);
#line 232 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (fallback != NULL);
#line 235 "../pkcs11/pkcs11-certificate-widget.vala"
	if (value != NULL) {
#line 235 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = g_strcmp0 (value, "") != 0;
#line 1687 "pkcs11-certificate-widget.c"
	} else {
#line 235 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = FALSE;
#line 1691 "pkcs11-certificate-widget.c"
	}
#line 235 "../pkcs11/pkcs11-certificate-widget.vala"
	if (_tmp0_) {
#line 236 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_label_set_label (label, value);
#line 237 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_widget_remove_css_class ((GtkWidget*) label, "dim-label");
#line 238 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_label_set_selectable (label, TRUE);
#line 1701 "pkcs11-certificate-widget.c"
	} else {
#line 240 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_label_set_label (label, fallback);
#line 241 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_widget_add_css_class ((GtkWidget*) label, "dim-label");
#line 242 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_label_set_selectable (label, FALSE);
#line 1709 "pkcs11-certificate-widget.c"
	}
}

static AdwActionRow*
seahorse_pkcs11_certificate_widget_create_property_row (SeahorsePkcs11CertificateWidget* self,
                                                        const gchar* title,
                                                        const gchar* value,
                                                        const gchar* fallback)
{
	AdwActionRow* row = NULL;
	AdwActionRow* _tmp0_;
	AdwActionRow* result;
#line 246 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 246 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 246 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_val_if_fail (fallback != NULL, NULL);
#line 249 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp0_ = (AdwActionRow*) adw_action_row_new ();
#line 249 "../pkcs11/pkcs11-certificate-widget.vala"
	g_object_ref_sink (_tmp0_);
#line 249 "../pkcs11/pkcs11-certificate-widget.vala"
	row = _tmp0_;
#line 250 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_add_css_class ((GtkWidget*) row, "property");
#line 251 "../pkcs11/pkcs11-certificate-widget.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) row, title);
#line 252 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_set_row_value (self, row, value, fallback);
#line 253 "../pkcs11/pkcs11-certificate-widget.vala"
	result = row;
#line 253 "../pkcs11/pkcs11-certificate-widget.vala"
	return result;
#line 1744 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_set_row_value (SeahorsePkcs11CertificateWidget* self,
                                                  AdwActionRow* row,
                                                  const gchar* value,
                                                  const gchar* fallback)
{
	gboolean _tmp0_ = FALSE;
#line 256 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 256 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (row != NULL);
#line 256 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (fallback != NULL);
#line 259 "../pkcs11/pkcs11-certificate-widget.vala"
	if (value != NULL) {
#line 259 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = g_strcmp0 (value, "") != 0;
#line 1764 "pkcs11-certificate-widget.c"
	} else {
#line 259 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = FALSE;
#line 1768 "pkcs11-certificate-widget.c"
	}
#line 259 "../pkcs11/pkcs11-certificate-widget.vala"
	if (_tmp0_) {
#line 260 "../pkcs11/pkcs11-certificate-widget.vala"
		adw_action_row_set_subtitle (row, value);
#line 261 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_widget_remove_css_class ((GtkWidget*) row, "dim-label");
#line 262 "../pkcs11/pkcs11-certificate-widget.vala"
		adw_action_row_set_subtitle_selectable (row, TRUE);
#line 1778 "pkcs11-certificate-widget.c"
	} else {
#line 264 "../pkcs11/pkcs11-certificate-widget.vala"
		adw_action_row_set_subtitle (row, fallback);
#line 265 "../pkcs11/pkcs11-certificate-widget.vala"
		gtk_widget_add_css_class ((GtkWidget*) row, "dim-label");
#line 266 "../pkcs11/pkcs11-certificate-widget.vala"
		adw_action_row_set_subtitle_selectable (row, FALSE);
#line 1786 "pkcs11-certificate-widget.c"
	}
}

static void
seahorse_pkcs11_certificate_widget_action_copy_public_key (SeahorsePkcs11CertificateWidget* self,
                                                           const gchar* action_name,
                                                           GVariant* param)
{
	GcrSubjectPublicKeyInfo* spki = NULL;
	GcrCertificate* _tmp0_;
	GcrSubjectPublicKeyInfo* _tmp1_;
	GdkClipboard* _tmp2_;
	GBytes* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	AdwToast* _tmp6_;
	AdwToast* _tmp7_;
#line 270 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 270 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (action_name != NULL);
#line 271 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp0_ = self->priv->_certificate;
#line 271 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp1_ = gcr_certificate_get_public_key_info (_tmp0_);
#line 271 "../pkcs11/pkcs11-certificate-widget.vala"
	spki = _tmp1_;
#line 272 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp2_ = gtk_widget_get_clipboard ((GtkWidget*) self);
#line 272 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp3_ = gcr_subject_public_key_info_get_key (spki);
#line 272 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp4_ = seahorse_pkcs11_certificate_widget_bytes_to_hex (self, _tmp3_, NULL);
#line 272 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp5_ = _tmp4_;
#line 272 "../pkcs11/pkcs11-certificate-widget.vala"
	gdk_clipboard_set_text (_tmp2_, _tmp5_);
#line 272 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_free0 (_tmp5_);
#line 273 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp6_ = adw_toast_new (_ ("Copied public key to clipboard"));
#line 273 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp7_ = _tmp6_;
#line 273 "../pkcs11/pkcs11-certificate-widget.vala"
	g_signal_emit (self, seahorse_pkcs11_certificate_widget_signals[SEAHORSE_PKCS11_CERTIFICATE_WIDGET_NOTIFICATION_SIGNAL], 0, _tmp7_);
#line 273 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (_tmp7_);
#line 1834 "pkcs11-certificate-widget.c"
}

GcrCertificate*
seahorse_pkcs11_certificate_widget_get_certificate (SeahorsePkcs11CertificateWidget* self)
{
	GcrCertificate* result;
	GcrCertificate* _tmp0_;
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp0_ = self->priv->_certificate;
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	result = _tmp0_;
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	return result;
#line 1850 "pkcs11-certificate-widget.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	return self ? g_object_ref (self) : NULL;
#line 1858 "pkcs11-certificate-widget.c"
}

void
seahorse_pkcs11_certificate_widget_set_certificate (SeahorsePkcs11CertificateWidget* self,
                                                    GcrCertificate* value)
{
	GcrCertificate* old_value;
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	g_return_if_fail (self != NULL);
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	old_value = seahorse_pkcs11_certificate_widget_get_certificate (self);
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	if (old_value != value) {
#line 1872 "pkcs11-certificate-widget.c"
		GcrCertificate* _tmp0_;
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
		_g_object_unref0 (self->priv->_certificate);
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
		self->priv->_certificate = _tmp0_;
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_pkcs11_certificate_widget_properties[SEAHORSE_PKCS11_CERTIFICATE_WIDGET_CERTIFICATE_PROPERTY]);
#line 1882 "pkcs11-certificate-widget.c"
	}
}

static SeahorsePkcs11CertificateWidgetRdn*
seahorse_pkcs11_certificate_widget_rdn_dup (const SeahorsePkcs11CertificateWidgetRdn* self)
{
	SeahorsePkcs11CertificateWidgetRdn* dup;
#line 35 "../pkcs11/pkcs11-certificate-widget.vala"
	dup = g_new0 (SeahorsePkcs11CertificateWidgetRdn, 1);
#line 35 "../pkcs11/pkcs11-certificate-widget.vala"
	memcpy (dup, self, sizeof (SeahorsePkcs11CertificateWidgetRdn));
#line 35 "../pkcs11/pkcs11-certificate-widget.vala"
	return dup;
#line 1896 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_rdn_free (SeahorsePkcs11CertificateWidgetRdn* self)
{
#line 35 "../pkcs11/pkcs11-certificate-widget.vala"
	g_free (self);
#line 1904 "pkcs11-certificate-widget.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_pkcs11_certificate_widget_rdn_get_type_once (void)
{
	GType seahorse_pkcs11_certificate_widget_rdn_type_id;
	seahorse_pkcs11_certificate_widget_rdn_type_id = g_boxed_type_register_static ("SeahorsePkcs11CertificateWidgetRdn", (GBoxedCopyFunc) seahorse_pkcs11_certificate_widget_rdn_dup, (GBoxedFreeFunc) seahorse_pkcs11_certificate_widget_rdn_free);
	return seahorse_pkcs11_certificate_widget_rdn_type_id;
}

static GType
seahorse_pkcs11_certificate_widget_rdn_get_type (void)
{
	static gsize seahorse_pkcs11_certificate_widget_rdn_type_id__once = 0;
	if (g_once_init_enter (&seahorse_pkcs11_certificate_widget_rdn_type_id__once)) {
		GType seahorse_pkcs11_certificate_widget_rdn_type_id;
		seahorse_pkcs11_certificate_widget_rdn_type_id = seahorse_pkcs11_certificate_widget_rdn_get_type_once ();
		g_once_init_leave (&seahorse_pkcs11_certificate_widget_rdn_type_id__once, seahorse_pkcs11_certificate_widget_rdn_type_id);
	}
	return seahorse_pkcs11_certificate_widget_rdn_type_id__once;
}

static GObject *
seahorse_pkcs11_certificate_widget_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorsePkcs11CertificateWidget * self;
	GcrCertificate* _tmp0_;
#line 69 "../pkcs11/pkcs11-certificate-widget.vala"
	parent_class = G_OBJECT_CLASS (seahorse_pkcs11_certificate_widget_parent_class);
#line 69 "../pkcs11/pkcs11-certificate-widget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 69 "../pkcs11/pkcs11-certificate-widget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_CERTIFICATE_WIDGET, SeahorsePkcs11CertificateWidget);
#line 70 "../pkcs11/pkcs11-certificate-widget.vala"
	_tmp0_ = self->priv->_certificate;
#line 70 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_fill_in_certificate_details (self, _tmp0_);
#line 69 "../pkcs11/pkcs11-certificate-widget.vala"
	return obj;
#line 1948 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_class_init (SeahorsePkcs11CertificateWidgetClass * klass,
                                               gpointer klass_data)
{
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_parent_class = g_type_class_peek_parent (klass);
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	g_type_class_adjust_private_offset (klass, &SeahorsePkcs11CertificateWidget_private_offset);
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_pkcs11_certificate_widget_get_property;
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_pkcs11_certificate_widget_set_property;
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_pkcs11_certificate_widget_constructor;
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_pkcs11_certificate_widget_finalize;
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_CERTIFICATE_WIDGET_CERTIFICATE_PROPERTY, seahorse_pkcs11_certificate_widget_properties[SEAHORSE_PKCS11_CERTIFICATE_WIDGET_CERTIFICATE_PROPERTY] = g_param_spec_object ("certificate", "certificate", "certificate", gcr_certificate_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/pkcs11-certificate-widget.ui");
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	seahorse_pkcs11_certificate_widget_signals[SEAHORSE_PKCS11_CERTIFICATE_WIDGET_NOTIFICATION_SIGNAL] = g_signal_new ("notification", SEAHORSE_PKCS11_TYPE_CERTIFICATE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, adw_toast_get_type ());
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "name_label", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, name_label));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "issuer_short_label", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, issuer_short_label));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "expires_short_label", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, expires_short_label));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subject_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, subject_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "issuer_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, issuer_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "issued_date_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, issued_date_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "expires_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, expires_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "version_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, version_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "serial_nr_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, serial_nr_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sha256_fingerprint_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, sha256_fingerprint_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "md5_fingerprint_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, md5_fingerprint_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "public_key_algo_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, public_key_algo_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "public_key_size_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, public_key_size_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "public_key_algo_params_row", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, public_key_algo_params_row));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "public_key_label", FALSE, SeahorsePkcs11CertificateWidget_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11CertificateWidgetPrivate, public_key_label));
#line 66 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_class_install_action (GTK_WIDGET_CLASS (klass), "copy-public-key", NULL, (GtkWidgetActionActivateFunc) seahorse_pkcs11_certificate_widget_action_copy_public_key);
#line 2005 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_instance_init (SeahorsePkcs11CertificateWidget * self,
                                                  gpointer klass)
{
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	self->priv = seahorse_pkcs11_certificate_widget_get_instance_private (self);
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2016 "pkcs11-certificate-widget.c"
}

static void
seahorse_pkcs11_certificate_widget_finalize (GObject * obj)
{
	SeahorsePkcs11CertificateWidget * self;
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_CERTIFICATE_WIDGET, SeahorsePkcs11CertificateWidget);
#line 29 "../pkcs11/pkcs11-certificate-widget.vala"
	_g_object_unref0 (self->priv->_certificate);
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	G_OBJECT_CLASS (seahorse_pkcs11_certificate_widget_parent_class)->finalize (obj);
#line 2029 "pkcs11-certificate-widget.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_pkcs11_certificate_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePkcs11CertificateWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_pkcs11_certificate_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePkcs11CertificateWidget), 0, (GInstanceInitFunc) seahorse_pkcs11_certificate_widget_instance_init, NULL };
	GType seahorse_pkcs11_certificate_widget_type_id;
	seahorse_pkcs11_certificate_widget_type_id = g_type_register_static (gtk_box_get_type (), "SeahorsePkcs11CertificateWidget", &g_define_type_info, 0);
	SeahorsePkcs11CertificateWidget_private_offset = g_type_add_instance_private (seahorse_pkcs11_certificate_widget_type_id, sizeof (SeahorsePkcs11CertificateWidgetPrivate));
	return seahorse_pkcs11_certificate_widget_type_id;
}

GType
seahorse_pkcs11_certificate_widget_get_type (void)
{
	static gsize seahorse_pkcs11_certificate_widget_type_id__once = 0;
	if (g_once_init_enter (&seahorse_pkcs11_certificate_widget_type_id__once)) {
		GType seahorse_pkcs11_certificate_widget_type_id;
		seahorse_pkcs11_certificate_widget_type_id = seahorse_pkcs11_certificate_widget_get_type_once ();
		g_once_init_leave (&seahorse_pkcs11_certificate_widget_type_id__once, seahorse_pkcs11_certificate_widget_type_id);
	}
	return seahorse_pkcs11_certificate_widget_type_id__once;
}

static void
_vala_seahorse_pkcs11_certificate_widget_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	SeahorsePkcs11CertificateWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_TYPE_CERTIFICATE_WIDGET, SeahorsePkcs11CertificateWidget);
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	switch (property_id) {
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		case SEAHORSE_PKCS11_CERTIFICATE_WIDGET_CERTIFICATE_PROPERTY:
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		g_value_set_object (value, seahorse_pkcs11_certificate_widget_get_certificate (self));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		break;
#line 2070 "pkcs11-certificate-widget.c"
		default:
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		break;
#line 2076 "pkcs11-certificate-widget.c"
	}
}

static void
_vala_seahorse_pkcs11_certificate_widget_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	SeahorsePkcs11CertificateWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_TYPE_CERTIFICATE_WIDGET, SeahorsePkcs11CertificateWidget);
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
	switch (property_id) {
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		case SEAHORSE_PKCS11_CERTIFICATE_WIDGET_CERTIFICATE_PROPERTY:
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		seahorse_pkcs11_certificate_widget_set_certificate (self, g_value_get_object (value));
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		break;
#line 2096 "pkcs11-certificate-widget.c"
		default:
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../pkcs11/pkcs11-certificate-widget.vala"
		break;
#line 2102 "pkcs11-certificate-widget.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

