/* key-manager-filter.c generated by valac 0.56.18, the Vala compiler
 * generated from key-manager-filter.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2022 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "seahorse-common.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SEAHORSE_TYPE_KEY_MANAGER_FILTER (seahorse_key_manager_filter_get_type ())
#define SEAHORSE_KEY_MANAGER_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_KEY_MANAGER_FILTER, SeahorseKeyManagerFilter))
#define SEAHORSE_KEY_MANAGER_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_KEY_MANAGER_FILTER, SeahorseKeyManagerFilterClass))
#define SEAHORSE_IS_KEY_MANAGER_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_KEY_MANAGER_FILTER))
#define SEAHORSE_IS_KEY_MANAGER_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_KEY_MANAGER_FILTER))
#define SEAHORSE_KEY_MANAGER_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_KEY_MANAGER_FILTER, SeahorseKeyManagerFilterClass))

typedef struct _SeahorseKeyManagerFilter SeahorseKeyManagerFilter;
typedef struct _SeahorseKeyManagerFilterClass SeahorseKeyManagerFilterClass;
typedef struct _SeahorseKeyManagerFilterPrivate SeahorseKeyManagerFilterPrivate;
typedef enum  {
	SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_ANY,
	SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PERSONAL,
	SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_TRUSTED
} SeahorseKeyManagerFilterShowFilter;

#define SEAHORSE_KEY_MANAGER_FILTER_TYPE_SHOW_FILTER (seahorse_key_manager_filter_show_filter_get_type ())
enum  {
	SEAHORSE_KEY_MANAGER_FILTER_0_PROPERTY,
	SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PROPERTY,
	SEAHORSE_KEY_MANAGER_FILTER_FILTER_TEXT_PROPERTY,
	SEAHORSE_KEY_MANAGER_FILTER_NUM_PROPERTIES
};
static GParamSpec* seahorse_key_manager_filter_properties[SEAHORSE_KEY_MANAGER_FILTER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SeahorseKeyManagerFilter {
	GtkFilter parent_instance;
	SeahorseKeyManagerFilterPrivate * priv;
};

struct _SeahorseKeyManagerFilterClass {
	GtkFilterClass parent_class;
};

struct _SeahorseKeyManagerFilterPrivate {
	SeahorseKeyManagerFilterShowFilter _show_filter;
	gchar* _filter_text;
};

static gint SeahorseKeyManagerFilter_private_offset;
static gpointer seahorse_key_manager_filter_parent_class = NULL;

VALA_EXTERN GType seahorse_key_manager_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseKeyManagerFilter, g_object_unref)
VALA_EXTERN GType seahorse_key_manager_filter_show_filter_get_type (void) G_GNUC_CONST ;
VALA_EXTERN const gchar* seahorse_key_manager_filter_show_filter_to_string (SeahorseKeyManagerFilterShowFilter self);
VALA_EXTERN SeahorseKeyManagerFilterShowFilter seahorse_key_manager_filter_show_filter_from_string (const gchar* str);
static gboolean seahorse_key_manager_filter_real_match (GtkFilter* base,
                                                 GObject* item);
static gboolean seahorse_key_manager_filter_matches_showfilter (SeahorseKeyManagerFilter* self,
                                                         GObject* obj);
static gboolean seahorse_key_manager_filter_object_contains_filtered_text (SeahorseKeyManagerFilter* self,
                                                                    GObject* object,
                                                                    const gchar* text);
VALA_EXTERN SeahorseKeyManagerFilterShowFilter seahorse_key_manager_filter_get_show_filter (SeahorseKeyManagerFilter* self);
static GtkFilterMatch seahorse_key_manager_filter_real_get_strictness (GtkFilter* base);
VALA_EXTERN SeahorseKeyManagerFilter* seahorse_key_manager_filter_new (void);
VALA_EXTERN SeahorseKeyManagerFilter* seahorse_key_manager_filter_construct (GType object_type);
VALA_EXTERN void seahorse_key_manager_filter_set_show_filter (SeahorseKeyManagerFilter* self,
                                                  SeahorseKeyManagerFilterShowFilter value);
VALA_EXTERN const gchar* seahorse_key_manager_filter_get_filter_text (SeahorseKeyManagerFilter* self);
VALA_EXTERN void seahorse_key_manager_filter_set_filter_text (SeahorseKeyManagerFilter* self,
                                                  const gchar* value);
static void seahorse_key_manager_filter_finalize (GObject * obj);
static GType seahorse_key_manager_filter_get_type_once (void);
static void _vala_seahorse_key_manager_filter_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_seahorse_key_manager_filter_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
seahorse_key_manager_filter_get_instance_private (SeahorseKeyManagerFilter* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseKeyManagerFilter_private_offset);
}

const gchar*
seahorse_key_manager_filter_show_filter_to_string (SeahorseKeyManagerFilterShowFilter self)
{
	const gchar* result;
#line 29 "../src/key-manager-filter.vala"
	switch (self) {
#line 29 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_ANY:
#line 139 "key-manager-filter.c"
		{
#line 31 "../src/key-manager-filter.vala"
			result = "";
#line 31 "../src/key-manager-filter.vala"
			return result;
#line 145 "key-manager-filter.c"
		}
#line 29 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PERSONAL:
#line 149 "key-manager-filter.c"
		{
#line 33 "../src/key-manager-filter.vala"
			result = "personal";
#line 33 "../src/key-manager-filter.vala"
			return result;
#line 155 "key-manager-filter.c"
		}
#line 29 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_TRUSTED:
#line 159 "key-manager-filter.c"
		{
#line 35 "../src/key-manager-filter.vala"
			result = "trusted";
#line 35 "../src/key-manager-filter.vala"
			return result;
#line 165 "key-manager-filter.c"
		}
		default:
		{
#line 37 "../src/key-manager-filter.vala"
			g_assert_not_reached ();
#line 171 "key-manager-filter.c"
		}
	}
}

SeahorseKeyManagerFilterShowFilter
seahorse_key_manager_filter_show_filter_from_string (const gchar* str)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 42 "../src/key-manager-filter.vala"
	static GQuark _tmp1_label0 = 0;
#line 42 "../src/key-manager-filter.vala"
	static GQuark _tmp1_label1 = 0;
#line 42 "../src/key-manager-filter.vala"
	static GQuark _tmp1_label2 = 0;
#line 42 "../src/key-manager-filter.vala"
	static GQuark _tmp1_label3 = 0;
#line 42 "../src/key-manager-filter.vala"
	static GQuark _tmp1_label4 = 0;
#line 191 "key-manager-filter.c"
	SeahorseKeyManagerFilterShowFilter result;
#line 42 "../src/key-manager-filter.vala"
	_tmp0_ = str;
#line 42 "../src/key-manager-filter.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 42 "../src/key-manager-filter.vala"
	if (((_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (NULL)))) || (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (""))))) || (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("any"))))) {
#line 42 "../src/key-manager-filter.vala"
		switch (0) {
#line 201 "key-manager-filter.c"
			default:
			{
#line 46 "../src/key-manager-filter.vala"
				result = SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_ANY;
#line 46 "../src/key-manager-filter.vala"
				return result;
#line 208 "key-manager-filter.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("personal")))) {
#line 42 "../src/key-manager-filter.vala"
		switch (0) {
#line 214 "key-manager-filter.c"
			default:
			{
#line 48 "../src/key-manager-filter.vala"
				result = SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PERSONAL;
#line 48 "../src/key-manager-filter.vala"
				return result;
#line 221 "key-manager-filter.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("trusted")))) {
#line 42 "../src/key-manager-filter.vala"
		switch (0) {
#line 227 "key-manager-filter.c"
			default:
			{
#line 50 "../src/key-manager-filter.vala"
				result = SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_TRUSTED;
#line 50 "../src/key-manager-filter.vala"
				return result;
#line 234 "key-manager-filter.c"
			}
		}
	} else {
#line 42 "../src/key-manager-filter.vala"
		switch (0) {
#line 240 "key-manager-filter.c"
			default:
			{
#line 52 "../src/key-manager-filter.vala"
				g_critical ("key-manager-filter.vala:52: Got unknown ShowFilter string: %s", str);
#line 53 "../src/key-manager-filter.vala"
				g_assert_not_reached ();
#line 247 "key-manager-filter.c"
			}
		}
	}
}

 G_GNUC_NO_INLINE static GType
seahorse_key_manager_filter_show_filter_get_type_once (void)
{
	static const GEnumValue values[] = {{SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_ANY, "SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_ANY", "any"}, {SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PERSONAL, "SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PERSONAL", "personal"}, {SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_TRUSTED, "SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_TRUSTED", "trusted"}, {0, NULL, NULL}};
	GType seahorse_key_manager_filter_show_filter_type_id;
	seahorse_key_manager_filter_show_filter_type_id = g_enum_register_static ("SeahorseKeyManagerFilterShowFilter", values);
	return seahorse_key_manager_filter_show_filter_type_id;
}

GType
seahorse_key_manager_filter_show_filter_get_type (void)
{
	static gsize seahorse_key_manager_filter_show_filter_type_id__once = 0;
	if (g_once_init_enter (&seahorse_key_manager_filter_show_filter_type_id__once)) {
		GType seahorse_key_manager_filter_show_filter_type_id;
		seahorse_key_manager_filter_show_filter_type_id = seahorse_key_manager_filter_show_filter_get_type_once ();
		g_once_init_leave (&seahorse_key_manager_filter_show_filter_type_id__once, seahorse_key_manager_filter_show_filter_type_id);
	}
	return seahorse_key_manager_filter_show_filter_type_id__once;
}

static gboolean
seahorse_key_manager_filter_real_match (GtkFilter* base,
                                        GObject* item)
{
	SeahorseKeyManagerFilter * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 80 "../src/key-manager-filter.vala"
	self = (SeahorseKeyManagerFilter*) base;
#line 81 "../src/key-manager-filter.vala"
	if (seahorse_key_manager_filter_matches_showfilter (self, item)) {
#line 285 "key-manager-filter.c"
		const gchar* _tmp1_;
#line 82 "../src/key-manager-filter.vala"
		_tmp1_ = self->priv->_filter_text;
#line 82 "../src/key-manager-filter.vala"
		_tmp0_ = seahorse_key_manager_filter_object_contains_filtered_text (self, item, _tmp1_);
#line 291 "key-manager-filter.c"
	} else {
#line 81 "../src/key-manager-filter.vala"
		_tmp0_ = FALSE;
#line 295 "key-manager-filter.c"
	}
#line 81 "../src/key-manager-filter.vala"
	result = _tmp0_;
#line 81 "../src/key-manager-filter.vala"
	return result;
#line 301 "key-manager-filter.c"
}

static gboolean
seahorse_key_manager_filter_matches_showfilter (SeahorseKeyManagerFilter* self,
                                                GObject* obj)
{
	SeahorseFlags obj_flags = 0U;
	SeahorseFlags _tmp0_ = 0U;
	SeahorseKeyManagerFilterShowFilter _tmp1_;
	SeahorseKeyManagerFilterShowFilter _tmp2_;
	gboolean result;
#line 85 "../src/key-manager-filter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "../src/key-manager-filter.vala"
	obj_flags = SEAHORSE_FLAG_NONE;
#line 87 "../src/key-manager-filter.vala"
	g_object_get (obj, "object-flags", &_tmp0_, NULL, NULL);
#line 87 "../src/key-manager-filter.vala"
	obj_flags = _tmp0_;
#line 89 "../src/key-manager-filter.vala"
	_tmp1_ = seahorse_key_manager_filter_get_show_filter (self);
#line 89 "../src/key-manager-filter.vala"
	_tmp2_ = _tmp1_;
#line 89 "../src/key-manager-filter.vala"
	switch (_tmp2_) {
#line 89 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PERSONAL:
#line 329 "key-manager-filter.c"
		{
#line 91 "../src/key-manager-filter.vala"
			result = (obj_flags & SEAHORSE_FLAG_PERSONAL) == SEAHORSE_FLAG_PERSONAL;
#line 91 "../src/key-manager-filter.vala"
			return result;
#line 335 "key-manager-filter.c"
		}
#line 89 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_TRUSTED:
#line 339 "key-manager-filter.c"
		{
#line 93 "../src/key-manager-filter.vala"
			result = (obj_flags & SEAHORSE_FLAG_TRUSTED) == SEAHORSE_FLAG_TRUSTED;
#line 93 "../src/key-manager-filter.vala"
			return result;
#line 345 "key-manager-filter.c"
		}
#line 89 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_ANY:
#line 349 "key-manager-filter.c"
		{
#line 95 "../src/key-manager-filter.vala"
			result = TRUE;
#line 95 "../src/key-manager-filter.vala"
			return result;
#line 355 "key-manager-filter.c"
		}
		default:
#line 89 "../src/key-manager-filter.vala"
		break;
#line 360 "key-manager-filter.c"
	}
#line 98 "../src/key-manager-filter.vala"
	result = FALSE;
#line 98 "../src/key-manager-filter.vala"
	return result;
#line 366 "key-manager-filter.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 385 "key-manager-filter.c"
}

static gboolean
seahorse_key_manager_filter_object_contains_filtered_text (SeahorseKeyManagerFilter* self,
                                                           GObject* object,
                                                           const gchar* text)
{
	gboolean _tmp0_ = FALSE;
	gchar* name = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GObjectClass* _tmp7_;
	GParamSpec* _tmp8_;
	gboolean result;
#line 102 "../src/key-manager-filter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 104 "../src/key-manager-filter.vala"
	if (text == NULL) {
#line 104 "../src/key-manager-filter.vala"
		_tmp0_ = TRUE;
#line 407 "key-manager-filter.c"
	} else {
#line 104 "../src/key-manager-filter.vala"
		_tmp0_ = g_strcmp0 (text, "") == 0;
#line 411 "key-manager-filter.c"
	}
#line 104 "../src/key-manager-filter.vala"
	if (_tmp0_) {
#line 105 "../src/key-manager-filter.vala"
		result = TRUE;
#line 105 "../src/key-manager-filter.vala"
		return result;
#line 419 "key-manager-filter.c"
	}
#line 107 "../src/key-manager-filter.vala"
	name = NULL;
#line 108 "../src/key-manager-filter.vala"
	g_object_get (object, "label", &_tmp1_, NULL, NULL);
#line 108 "../src/key-manager-filter.vala"
	_g_free0 (name);
#line 108 "../src/key-manager-filter.vala"
	name = _tmp1_;
#line 109 "../src/key-manager-filter.vala"
	_tmp3_ = name;
#line 109 "../src/key-manager-filter.vala"
	if (_tmp3_ != NULL) {
#line 433 "key-manager-filter.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 109 "../src/key-manager-filter.vala"
		_tmp4_ = name;
#line 109 "../src/key-manager-filter.vala"
		_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 109 "../src/key-manager-filter.vala"
		_tmp6_ = _tmp5_;
#line 109 "../src/key-manager-filter.vala"
		_tmp2_ = string_contains (_tmp6_, text);
#line 109 "../src/key-manager-filter.vala"
		_g_free0 (_tmp6_);
#line 447 "key-manager-filter.c"
	} else {
#line 109 "../src/key-manager-filter.vala"
		_tmp2_ = FALSE;
#line 451 "key-manager-filter.c"
	}
#line 109 "../src/key-manager-filter.vala"
	if (_tmp2_) {
#line 110 "../src/key-manager-filter.vala"
		result = TRUE;
#line 110 "../src/key-manager-filter.vala"
		_g_free0 (name);
#line 110 "../src/key-manager-filter.vala"
		return result;
#line 461 "key-manager-filter.c"
	}
#line 112 "../src/key-manager-filter.vala"
	_tmp7_ = G_OBJECT_GET_CLASS (object);
#line 112 "../src/key-manager-filter.vala"
	_tmp8_ = g_object_class_find_property (_tmp7_, "description");
#line 112 "../src/key-manager-filter.vala"
	if (_tmp8_ != NULL) {
#line 469 "key-manager-filter.c"
		gchar* description = NULL;
		gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
#line 113 "../src/key-manager-filter.vala"
		description = NULL;
#line 114 "../src/key-manager-filter.vala"
		g_object_get (object, "description", &_tmp9_, NULL, NULL);
#line 114 "../src/key-manager-filter.vala"
		_g_free0 (description);
#line 114 "../src/key-manager-filter.vala"
		description = _tmp9_;
#line 115 "../src/key-manager-filter.vala"
		_tmp11_ = description;
#line 115 "../src/key-manager-filter.vala"
		if (_tmp11_ != NULL) {
#line 486 "key-manager-filter.c"
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 115 "../src/key-manager-filter.vala"
			_tmp12_ = description;
#line 115 "../src/key-manager-filter.vala"
			_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
#line 115 "../src/key-manager-filter.vala"
			_tmp14_ = _tmp13_;
#line 115 "../src/key-manager-filter.vala"
			_tmp10_ = string_contains (_tmp14_, text);
#line 115 "../src/key-manager-filter.vala"
			_g_free0 (_tmp14_);
#line 500 "key-manager-filter.c"
		} else {
#line 115 "../src/key-manager-filter.vala"
			_tmp10_ = FALSE;
#line 504 "key-manager-filter.c"
		}
#line 115 "../src/key-manager-filter.vala"
		if (_tmp10_) {
#line 116 "../src/key-manager-filter.vala"
			result = TRUE;
#line 116 "../src/key-manager-filter.vala"
			_g_free0 (description);
#line 116 "../src/key-manager-filter.vala"
			_g_free0 (name);
#line 116 "../src/key-manager-filter.vala"
			return result;
#line 516 "key-manager-filter.c"
		}
#line 112 "../src/key-manager-filter.vala"
		_g_free0 (description);
#line 520 "key-manager-filter.c"
	}
#line 119 "../src/key-manager-filter.vala"
	result = FALSE;
#line 119 "../src/key-manager-filter.vala"
	_g_free0 (name);
#line 119 "../src/key-manager-filter.vala"
	return result;
#line 528 "key-manager-filter.c"
}

static GtkFilterMatch
seahorse_key_manager_filter_real_get_strictness (GtkFilter* base)
{
	SeahorseKeyManagerFilter * self;
	GtkFilterMatch result;
#line 122 "../src/key-manager-filter.vala"
	self = (SeahorseKeyManagerFilter*) base;
#line 123 "../src/key-manager-filter.vala"
	result = GTK_FILTER_MATCH_SOME;
#line 123 "../src/key-manager-filter.vala"
	return result;
#line 542 "key-manager-filter.c"
}

SeahorseKeyManagerFilter*
seahorse_key_manager_filter_construct (GType object_type)
{
	SeahorseKeyManagerFilter * self = NULL;
#line 21 "../src/key-manager-filter.vala"
	self = (SeahorseKeyManagerFilter*) g_object_new (object_type, NULL);
#line 21 "../src/key-manager-filter.vala"
	return self;
#line 553 "key-manager-filter.c"
}

SeahorseKeyManagerFilter*
seahorse_key_manager_filter_new (void)
{
#line 21 "../src/key-manager-filter.vala"
	return seahorse_key_manager_filter_construct (SEAHORSE_TYPE_KEY_MANAGER_FILTER);
#line 561 "key-manager-filter.c"
}

SeahorseKeyManagerFilterShowFilter
seahorse_key_manager_filter_get_show_filter (SeahorseKeyManagerFilter* self)
{
	SeahorseKeyManagerFilterShowFilter result;
#line 59 "../src/key-manager-filter.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "../src/key-manager-filter.vala"
	result = self->priv->_show_filter;
#line 59 "../src/key-manager-filter.vala"
	return result;
#line 574 "key-manager-filter.c"
}

void
seahorse_key_manager_filter_set_show_filter (SeahorseKeyManagerFilter* self,
                                             SeahorseKeyManagerFilterShowFilter value)
{
#line 60 "../src/key-manager-filter.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/key-manager-filter.vala"
	if (value != self->priv->_show_filter) {
#line 62 "../src/key-manager-filter.vala"
		self->priv->_show_filter = value;
#line 63 "../src/key-manager-filter.vala"
		gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_DIFFERENT);
#line 589 "key-manager-filter.c"
	}
#line 60 "../src/key-manager-filter.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_key_manager_filter_properties[SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PROPERTY]);
#line 593 "key-manager-filter.c"
}

const gchar*
seahorse_key_manager_filter_get_filter_text (SeahorseKeyManagerFilter* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 70 "../src/key-manager-filter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/key-manager-filter.vala"
	_tmp0_ = self->priv->_filter_text;
#line 70 "../src/key-manager-filter.vala"
	result = _tmp0_;
#line 70 "../src/key-manager-filter.vala"
	return result;
#line 609 "key-manager-filter.c"
}

void
seahorse_key_manager_filter_set_filter_text (SeahorseKeyManagerFilter* self,
                                             const gchar* value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gchar* _tmp4_;
#line 71 "../src/key-manager-filter.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/key-manager-filter.vala"
	_tmp0_ = g_utf8_casefold (value, (gssize) -1);
#line 72 "../src/key-manager-filter.vala"
	_tmp1_ = _tmp0_;
#line 72 "../src/key-manager-filter.vala"
	_tmp2_ = self->priv->_filter_text;
#line 72 "../src/key-manager-filter.vala"
	_tmp3_ = g_strcmp0 (_tmp1_, _tmp2_) == 0;
#line 72 "../src/key-manager-filter.vala"
	_g_free0 (_tmp1_);
#line 72 "../src/key-manager-filter.vala"
	if (_tmp3_) {
#line 73 "../src/key-manager-filter.vala"
		return;
#line 637 "key-manager-filter.c"
	}
#line 74 "../src/key-manager-filter.vala"
	_tmp4_ = g_utf8_casefold (value, (gssize) -1);
#line 74 "../src/key-manager-filter.vala"
	_g_free0 (self->priv->_filter_text);
#line 74 "../src/key-manager-filter.vala"
	self->priv->_filter_text = _tmp4_;
#line 75 "../src/key-manager-filter.vala"
	gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_DIFFERENT);
#line 71 "../src/key-manager-filter.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_key_manager_filter_properties[SEAHORSE_KEY_MANAGER_FILTER_FILTER_TEXT_PROPERTY]);
#line 649 "key-manager-filter.c"
}

static void
seahorse_key_manager_filter_class_init (SeahorseKeyManagerFilterClass * klass,
                                        gpointer klass_data)
{
#line 21 "../src/key-manager-filter.vala"
	seahorse_key_manager_filter_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/key-manager-filter.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseKeyManagerFilter_private_offset);
#line 21 "../src/key-manager-filter.vala"
	((GtkFilterClass *) klass)->match = (gboolean (*) (GtkFilter*, GObject*)) seahorse_key_manager_filter_real_match;
#line 21 "../src/key-manager-filter.vala"
	((GtkFilterClass *) klass)->get_strictness = (GtkFilterMatch (*) (GtkFilter*)) seahorse_key_manager_filter_real_get_strictness;
#line 21 "../src/key-manager-filter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_key_manager_filter_get_property;
#line 21 "../src/key-manager-filter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_key_manager_filter_set_property;
#line 21 "../src/key-manager-filter.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_key_manager_filter_finalize;
#line 21 "../src/key-manager-filter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PROPERTY, seahorse_key_manager_filter_properties[SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PROPERTY] = g_param_spec_enum ("show-filter", "show-filter", "show-filter", SEAHORSE_KEY_MANAGER_FILTER_TYPE_SHOW_FILTER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/key-manager-filter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_KEY_MANAGER_FILTER_FILTER_TEXT_PROPERTY, seahorse_key_manager_filter_properties[SEAHORSE_KEY_MANAGER_FILTER_FILTER_TEXT_PROPERTY] = g_param_spec_string ("filter-text", "filter-text", "filter-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 674 "key-manager-filter.c"
}

static void
seahorse_key_manager_filter_instance_init (SeahorseKeyManagerFilter * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
#line 21 "../src/key-manager-filter.vala"
	self->priv = seahorse_key_manager_filter_get_instance_private (self);
#line 67 "../src/key-manager-filter.vala"
	self->priv->_show_filter = SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_ANY;
#line 78 "../src/key-manager-filter.vala"
	_tmp0_ = g_strdup ("");
#line 78 "../src/key-manager-filter.vala"
	self->priv->_filter_text = _tmp0_;
#line 690 "key-manager-filter.c"
}

static void
seahorse_key_manager_filter_finalize (GObject * obj)
{
	SeahorseKeyManagerFilter * self;
#line 21 "../src/key-manager-filter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_KEY_MANAGER_FILTER, SeahorseKeyManagerFilter);
#line 78 "../src/key-manager-filter.vala"
	_g_free0 (self->priv->_filter_text);
#line 21 "../src/key-manager-filter.vala"
	G_OBJECT_CLASS (seahorse_key_manager_filter_parent_class)->finalize (obj);
#line 703 "key-manager-filter.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_key_manager_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseKeyManagerFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_key_manager_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseKeyManagerFilter), 0, (GInstanceInitFunc) seahorse_key_manager_filter_instance_init, NULL };
	GType seahorse_key_manager_filter_type_id;
	seahorse_key_manager_filter_type_id = g_type_register_static (gtk_filter_get_type (), "SeahorseKeyManagerFilter", &g_define_type_info, 0);
	SeahorseKeyManagerFilter_private_offset = g_type_add_instance_private (seahorse_key_manager_filter_type_id, sizeof (SeahorseKeyManagerFilterPrivate));
	return seahorse_key_manager_filter_type_id;
}

GType
seahorse_key_manager_filter_get_type (void)
{
	static gsize seahorse_key_manager_filter_type_id__once = 0;
	if (g_once_init_enter (&seahorse_key_manager_filter_type_id__once)) {
		GType seahorse_key_manager_filter_type_id;
		seahorse_key_manager_filter_type_id = seahorse_key_manager_filter_get_type_once ();
		g_once_init_leave (&seahorse_key_manager_filter_type_id__once, seahorse_key_manager_filter_type_id);
	}
	return seahorse_key_manager_filter_type_id__once;
}

static void
_vala_seahorse_key_manager_filter_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	SeahorseKeyManagerFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_KEY_MANAGER_FILTER, SeahorseKeyManagerFilter);
#line 21 "../src/key-manager-filter.vala"
	switch (property_id) {
#line 21 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PROPERTY:
#line 21 "../src/key-manager-filter.vala"
		g_value_set_enum (value, seahorse_key_manager_filter_get_show_filter (self));
#line 21 "../src/key-manager-filter.vala"
		break;
#line 21 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_FILTER_TEXT_PROPERTY:
#line 21 "../src/key-manager-filter.vala"
		g_value_set_string (value, seahorse_key_manager_filter_get_filter_text (self));
#line 21 "../src/key-manager-filter.vala"
		break;
#line 750 "key-manager-filter.c"
		default:
#line 21 "../src/key-manager-filter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/key-manager-filter.vala"
		break;
#line 756 "key-manager-filter.c"
	}
}

static void
_vala_seahorse_key_manager_filter_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	SeahorseKeyManagerFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_KEY_MANAGER_FILTER, SeahorseKeyManagerFilter);
#line 21 "../src/key-manager-filter.vala"
	switch (property_id) {
#line 21 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_SHOW_FILTER_PROPERTY:
#line 21 "../src/key-manager-filter.vala"
		seahorse_key_manager_filter_set_show_filter (self, g_value_get_enum (value));
#line 21 "../src/key-manager-filter.vala"
		break;
#line 21 "../src/key-manager-filter.vala"
		case SEAHORSE_KEY_MANAGER_FILTER_FILTER_TEXT_PROPERTY:
#line 21 "../src/key-manager-filter.vala"
		seahorse_key_manager_filter_set_filter_text (self, g_value_get_string (value));
#line 21 "../src/key-manager-filter.vala"
		break;
#line 782 "key-manager-filter.c"
		default:
#line 21 "../src/key-manager-filter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/key-manager-filter.vala"
		break;
#line 788 "key-manager-filter.c"
	}
}

