/* prefs-dialog.c generated by valac 0.56.18, the Vala compiler
 * generated from prefs-dialog.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004-2005 Stefan Walter
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "seahorse-common.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SEAHORSE_TYPE_PREFS_DIALOG (seahorse_prefs_dialog_get_type ())
#define SEAHORSE_PREFS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_PREFS_DIALOG, SeahorsePrefsDialog))
#define SEAHORSE_PREFS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_PREFS_DIALOG, SeahorsePrefsDialogClass))
#define SEAHORSE_IS_PREFS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_PREFS_DIALOG))
#define SEAHORSE_IS_PREFS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_PREFS_DIALOG))
#define SEAHORSE_PREFS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_PREFS_DIALOG, SeahorsePrefsDialogClass))

typedef struct _SeahorsePrefsDialog SeahorsePrefsDialog;
typedef struct _SeahorsePrefsDialogClass SeahorsePrefsDialogClass;
typedef struct _SeahorsePrefsDialogPrivate SeahorsePrefsDialogPrivate;
enum  {
	SEAHORSE_PREFS_DIALOG_0_PROPERTY,
	SEAHORSE_PREFS_DIALOG_NUM_PROPERTIES
};
static GParamSpec* seahorse_prefs_dialog_properties[SEAHORSE_PREFS_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SeahorsePrefsDialog {
	AdwPreferencesDialog parent_instance;
	SeahorsePrefsDialogPrivate * priv;
};

struct _SeahorsePrefsDialogClass {
	AdwPreferencesDialogClass parent_class;
};

static gpointer seahorse_prefs_dialog_parent_class = NULL;

VALA_EXTERN GType seahorse_prefs_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorsePrefsDialog, g_object_unref)
VALA_EXTERN SeahorsePrefsDialog* seahorse_prefs_dialog_new (void);
VALA_EXTERN SeahorsePrefsDialog* seahorse_prefs_dialog_construct (GType object_type);
VALA_EXTERN gboolean seahorse_prefs_dialog_available (void);
static GType seahorse_prefs_dialog_get_type_once (void);

/** Create a new preferences Dialog */
SeahorsePrefsDialog*
seahorse_prefs_dialog_construct (GType object_type)
{
	SeahorsePrefsDialog * self = NULL;
	SeahorsePrefsKeyservers* _tmp0_;
	SeahorsePrefsKeyservers* _tmp1_;
#line 25 "../src/prefs-dialog.vala"
	self = (SeahorsePrefsDialog*) g_object_new (object_type, "title", _ ("Preferences"), "search-enabled", FALSE, NULL);
#line 31 "../src/prefs-dialog.vala"
	_tmp0_ = seahorse_prefs_keyservers_new ();
#line 31 "../src/prefs-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 31 "../src/prefs-dialog.vala"
	_tmp1_ = _tmp0_;
#line 31 "../src/prefs-dialog.vala"
	adw_preferences_dialog_add ((AdwPreferencesDialog*) self, (AdwPreferencesPage*) _tmp1_);
#line 31 "../src/prefs-dialog.vala"
	_g_object_unref0 (_tmp1_);
#line 24 "../src/prefs-dialog.vala"
	return self;
#line 105 "prefs-dialog.c"
}

SeahorsePrefsDialog*
seahorse_prefs_dialog_new (void)
{
#line 24 "../src/prefs-dialog.vala"
	return seahorse_prefs_dialog_construct (SEAHORSE_TYPE_PREFS_DIALOG);
#line 113 "prefs-dialog.c"
}

/** Returns whether there are any preferences to show */
gboolean
seahorse_prefs_dialog_available (void)
{
	gboolean result;
#line 38 "../src/prefs-dialog.vala"
	result = TRUE;
#line 38 "../src/prefs-dialog.vala"
	return result;
#line 125 "prefs-dialog.c"
}

static void
seahorse_prefs_dialog_class_init (SeahorsePrefsDialogClass * klass,
                                  gpointer klass_data)
{
#line 21 "../src/prefs-dialog.vala"
	seahorse_prefs_dialog_parent_class = g_type_class_peek_parent (klass);
#line 134 "prefs-dialog.c"
}

static void
seahorse_prefs_dialog_instance_init (SeahorsePrefsDialog * self,
                                     gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
seahorse_prefs_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePrefsDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_prefs_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePrefsDialog), 0, (GInstanceInitFunc) seahorse_prefs_dialog_instance_init, NULL };
	GType seahorse_prefs_dialog_type_id;
	seahorse_prefs_dialog_type_id = g_type_register_static (adw_preferences_dialog_get_type (), "SeahorsePrefsDialog", &g_define_type_info, 0);
	return seahorse_prefs_dialog_type_id;
}

GType
seahorse_prefs_dialog_get_type (void)
{
	static gsize seahorse_prefs_dialog_type_id__once = 0;
	if (g_once_init_enter (&seahorse_prefs_dialog_type_id__once)) {
		GType seahorse_prefs_dialog_type_id;
		seahorse_prefs_dialog_type_id = seahorse_prefs_dialog_get_type_once ();
		g_once_init_leave (&seahorse_prefs_dialog_type_id__once, seahorse_prefs_dialog_type_id);
	}
	return seahorse_prefs_dialog_type_id__once;
}

