/* key-delete-operation.c generated by valac 0.56.18, the Vala compiler
 * generated from key-delete-operation.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Author: Stef Walter <stefw@collabora.co.uk>
 */

#include "seahorse-ssh.h"
#include "seahorse-common.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_SSH_KEY_DELETE_OPERATION_0_PROPERTY,
	SEAHORSE_SSH_KEY_DELETE_OPERATION_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_key_delete_operation_properties[SEAHORSE_SSH_KEY_DELETE_OPERATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _SeahorseSshKeyDeleteOperationExecuteData SeahorseSshKeyDeleteOperationExecuteData;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SeahorseSshKeyDeleteOperationExecuteData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshKeyDeleteOperation* self;
	GCancellable* cancellable;
	gboolean result;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GPtrArray* _tmp3_;
	GPtrArray* item_collection;
	guint item_index;
	SeahorseDeletable* item;
	SeahorseSshKey* key;
	SeahorseDeletable* _tmp4_;
	SeahorseSshKey* _tmp5_;
	SeahorseSshKey* _tmp6_;
	GError* _inner_error0_;
};

static gpointer seahorse_ssh_key_delete_operation_parent_class = NULL;

static void seahorse_ssh_key_delete_operation_real_execute_data_free (gpointer _data);
static void seahorse_ssh_key_delete_operation_real_execute (SeahorseDeleteOperation* base,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static gboolean seahorse_ssh_key_delete_operation_real_execute_co (SeahorseSshKeyDeleteOperationExecuteData* _data_);
static GType seahorse_ssh_key_delete_operation_get_type_once (void);

SeahorseSshKeyDeleteOperation*
seahorse_ssh_key_delete_operation_construct (GType object_type,
                                             SeahorseSshKey* key)
{
	SeahorseSshKeyDeleteOperation * self = NULL;
#line 26 "../ssh/key-delete-operation.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 26 "../ssh/key-delete-operation.vala"
	self = (SeahorseSshKeyDeleteOperation*) seahorse_delete_operation_construct (object_type);
#line 27 "../ssh/key-delete-operation.vala"
	seahorse_ssh_key_delete_operation_add_item (self, key);
#line 26 "../ssh/key-delete-operation.vala"
	return self;
#line 100 "key-delete-operation.c"
}

SeahorseSshKeyDeleteOperation*
seahorse_ssh_key_delete_operation_new (SeahorseSshKey* key)
{
#line 26 "../ssh/key-delete-operation.vala"
	return seahorse_ssh_key_delete_operation_construct (SEAHORSE_SSH_TYPE_KEY_DELETE_OPERATION, key);
#line 108 "key-delete-operation.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../ssh/key-delete-operation.vala"
	return self ? g_object_ref (self) : NULL;
#line 116 "key-delete-operation.c"
}

void
seahorse_ssh_key_delete_operation_add_item (SeahorseSshKeyDeleteOperation* self,
                                            SeahorseSshKey* key)
{
	GPtrArray* _tmp0_;
	SeahorseDeletable* _tmp1_;
#line 30 "../ssh/key-delete-operation.vala"
	g_return_if_fail (self != NULL);
#line 30 "../ssh/key-delete-operation.vala"
	g_return_if_fail (key != NULL);
#line 31 "../ssh/key-delete-operation.vala"
	if (seahorse_delete_operation_contains ((SeahorseDeleteOperation*) self, (SeahorseDeletable*) key)) {
#line 32 "../ssh/key-delete-operation.vala"
		return;
#line 133 "key-delete-operation.c"
	}
#line 33 "../ssh/key-delete-operation.vala"
	_tmp0_ = ((SeahorseDeleteOperation*) self)->items;
#line 33 "../ssh/key-delete-operation.vala"
	_tmp1_ = _g_object_ref0 ((SeahorseDeletable*) key);
#line 33 "../ssh/key-delete-operation.vala"
	g_ptr_array_add (_tmp0_, _tmp1_);
#line 141 "key-delete-operation.c"
}

static void
seahorse_ssh_key_delete_operation_real_execute_data_free (gpointer _data)
{
	SeahorseSshKeyDeleteOperationExecuteData* _data_;
	_data_ = _data;
#line 24 "../ssh/key-delete-operation.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../ssh/key-delete-operation.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../ssh/key-delete-operation.vala"
	g_slice_free (SeahorseSshKeyDeleteOperationExecuteData, _data_);
#line 155 "key-delete-operation.c"
}

static void
seahorse_ssh_key_delete_operation_real_execute (SeahorseDeleteOperation* base,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	SeahorseSshKeyDeleteOperation * self;
	SeahorseSshKeyDeleteOperationExecuteData* _data_;
	SeahorseSshKeyDeleteOperation* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../ssh/key-delete-operation.vala"
	self = (SeahorseSshKeyDeleteOperation*) base;
#line 24 "../ssh/key-delete-operation.vala"
	_data_ = g_slice_new0 (SeahorseSshKeyDeleteOperationExecuteData);
#line 24 "../ssh/key-delete-operation.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../ssh/key-delete-operation.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_key_delete_operation_real_execute_data_free);
#line 24 "../ssh/key-delete-operation.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../ssh/key-delete-operation.vala"
	_data_->self = _tmp0_;
#line 24 "../ssh/key-delete-operation.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../ssh/key-delete-operation.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../ssh/key-delete-operation.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../ssh/key-delete-operation.vala"
	seahorse_ssh_key_delete_operation_real_execute_co (_data_);
#line 188 "key-delete-operation.c"
}

static gboolean
seahorse_ssh_key_delete_operation_execute_finish (SeahorseDeleteOperation* base,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	gboolean result;
	SeahorseSshKeyDeleteOperationExecuteData* _data_;
#line 24 "../ssh/key-delete-operation.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../ssh/key-delete-operation.vala"
	if (NULL == _data_) {
#line 202 "key-delete-operation.c"
		gboolean _tmp0_ = FALSE;
#line 24 "../ssh/key-delete-operation.vala"
		return _tmp0_;
#line 206 "key-delete-operation.c"
	}
#line 24 "../ssh/key-delete-operation.vala"
	result = _data_->result;
#line 24 "../ssh/key-delete-operation.vala"
	return result;
#line 212 "key-delete-operation.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5954 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5955 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5955 "glib-2.0.vapi"
	return result;
#line 225 "key-delete-operation.c"
}

static gboolean
seahorse_ssh_key_delete_operation_real_execute_co (SeahorseSshKeyDeleteOperationExecuteData* _data_)
{
#line 36 "../ssh/key-delete-operation.vala"
	switch (_data_->_state_) {
#line 36 "../ssh/key-delete-operation.vala"
		case 0:
#line 235 "key-delete-operation.c"
		goto _state_0;
		default:
#line 36 "../ssh/key-delete-operation.vala"
		g_assert_not_reached ();
#line 240 "key-delete-operation.c"
	}
	_state_0:
#line 37 "../ssh/key-delete-operation.vala"
	_data_->_tmp0_ = ((SeahorseDeleteOperation*) _data_->self)->items;
#line 37 "../ssh/key-delete-operation.vala"
	_data_->_tmp1_ = vala_g_ptr_array_get_length (_data_->_tmp0_);
#line 37 "../ssh/key-delete-operation.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 37 "../ssh/key-delete-operation.vala"
	g_debug ("key-delete-operation.vala:37: Deleting %u SSH keys", (guint) _data_->_tmp2_);
#line 38 "../ssh/key-delete-operation.vala"
	_data_->_tmp3_ = ((SeahorseDeleteOperation*) _data_->self)->items;
#line 253 "key-delete-operation.c"
	{
#line 38 "../ssh/key-delete-operation.vala"
		_data_->item_collection = _data_->_tmp3_;
#line 38 "../ssh/key-delete-operation.vala"
		for (_data_->item_index = 0; _data_->item_index < _data_->item_collection->len; _data_->item_index = _data_->item_index + 1) {
#line 38 "../ssh/key-delete-operation.vala"
			_data_->item = (SeahorseDeletable*) g_ptr_array_index (_data_->item_collection, _data_->item_index);
#line 261 "key-delete-operation.c"
			{
#line 39 "../ssh/key-delete-operation.vala"
				_data_->_tmp4_ = _data_->item;
#line 39 "../ssh/key-delete-operation.vala"
				_data_->_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey));
#line 39 "../ssh/key-delete-operation.vala"
				_data_->key = _data_->_tmp5_;
#line 40 "../ssh/key-delete-operation.vala"
				_data_->_tmp6_ = _data_->key;
#line 40 "../ssh/key-delete-operation.vala"
				seahorse_ssh_key_delete_operation_delete_key (_data_->self, _data_->_tmp6_, &_data_->_inner_error0_);
#line 40 "../ssh/key-delete-operation.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 40 "../ssh/key-delete-operation.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 40 "../ssh/key-delete-operation.vala"
					_g_object_unref0 (_data_->key);
#line 40 "../ssh/key-delete-operation.vala"
					g_object_unref (_data_->_async_result);
#line 40 "../ssh/key-delete-operation.vala"
					return FALSE;
#line 283 "key-delete-operation.c"
				}
#line 38 "../ssh/key-delete-operation.vala"
				_g_object_unref0 (_data_->key);
#line 287 "key-delete-operation.c"
			}
		}
	}
#line 42 "../ssh/key-delete-operation.vala"
	_data_->result = TRUE;
#line 42 "../ssh/key-delete-operation.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 42 "../ssh/key-delete-operation.vala"
	if (_data_->_state_ != 0) {
#line 42 "../ssh/key-delete-operation.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 42 "../ssh/key-delete-operation.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 301 "key-delete-operation.c"
		}
	}
#line 42 "../ssh/key-delete-operation.vala"
	g_object_unref (_data_->_async_result);
#line 42 "../ssh/key-delete-operation.vala"
	return FALSE;
#line 308 "key-delete-operation.c"
}

/**
     * Deletes a given key.
     *
     * @param key The key that should be deleted.
     */
void
seahorse_ssh_key_delete_operation_delete_key (SeahorseSshKeyDeleteOperation* self,
                                              SeahorseSshKey* key,
                                              GError** error)
{
	SeahorseSshKeyData* keydata = NULL;
	SeahorseSshKeyData* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
	SeahorseSshKeyData* _tmp3_;
	SeahorseSshKeyData* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SeahorseSshSource* source = NULL;
	SeahorsePlace* _tmp41_;
	SeahorsePlace* _tmp42_;
	SeahorseSshSource* _tmp43_;
	SeahorseSshSource* _tmp44_;
	GError* _inner_error0_ = NULL;
#line 50 "../ssh/key-delete-operation.vala"
	g_return_if_fail (self != NULL);
#line 50 "../ssh/key-delete-operation.vala"
	g_return_if_fail (key != NULL);
#line 51 "../ssh/key-delete-operation.vala"
	_tmp0_ = seahorse_ssh_key_get_key_data (key);
#line 51 "../ssh/key-delete-operation.vala"
	_tmp1_ = _tmp0_;
#line 51 "../ssh/key-delete-operation.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 51 "../ssh/key-delete-operation.vala"
	keydata = _tmp2_;
#line 52 "../ssh/key-delete-operation.vala"
	_tmp3_ = keydata;
#line 52 "../ssh/key-delete-operation.vala"
	if (_tmp3_ == NULL) {
#line 351 "key-delete-operation.c"
		GError* _tmp4_;
#line 53 "../ssh/key-delete-operation.vala"
		_tmp4_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't delete key with empty KeyData.");
#line 53 "../ssh/key-delete-operation.vala"
		_inner_error0_ = _tmp4_;
#line 53 "../ssh/key-delete-operation.vala"
		g_propagate_error (error, _inner_error0_);
#line 53 "../ssh/key-delete-operation.vala"
		_g_object_unref0 (keydata);
#line 53 "../ssh/key-delete-operation.vala"
		return;
#line 363 "key-delete-operation.c"
	}
#line 55 "../ssh/key-delete-operation.vala"
	_tmp5_ = keydata;
#line 55 "../ssh/key-delete-operation.vala"
	_tmp6_ = seahorse_ssh_key_data_get_partial (_tmp5_);
#line 55 "../ssh/key-delete-operation.vala"
	_tmp7_ = _tmp6_;
#line 55 "../ssh/key-delete-operation.vala"
	if (_tmp7_) {
#line 373 "key-delete-operation.c"
		SeahorseSshKeyData* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 56 "../ssh/key-delete-operation.vala"
		_tmp8_ = keydata;
#line 56 "../ssh/key-delete-operation.vala"
		_tmp9_ = seahorse_ssh_key_data_get_pubfile (_tmp8_);
#line 56 "../ssh/key-delete-operation.vala"
		_tmp10_ = _tmp9_;
#line 56 "../ssh/key-delete-operation.vala"
		if (_tmp10_ != NULL) {
#line 385 "key-delete-operation.c"
			SeahorseSshKeyData* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			SeahorseSshKeyData* _tmp14_;
#line 57 "../ssh/key-delete-operation.vala"
			_tmp11_ = keydata;
#line 57 "../ssh/key-delete-operation.vala"
			_tmp12_ = seahorse_ssh_key_data_get_pubfile (_tmp11_);
#line 57 "../ssh/key-delete-operation.vala"
			_tmp13_ = _tmp12_;
#line 57 "../ssh/key-delete-operation.vala"
			_tmp14_ = keydata;
#line 57 "../ssh/key-delete-operation.vala"
			seahorse_ssh_key_data_filter_file (_tmp13_, NULL, _tmp14_, &_inner_error0_);
#line 57 "../ssh/key-delete-operation.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 57 "../ssh/key-delete-operation.vala"
				g_propagate_error (error, _inner_error0_);
#line 57 "../ssh/key-delete-operation.vala"
				_g_object_unref0 (keydata);
#line 57 "../ssh/key-delete-operation.vala"
				return;
#line 408 "key-delete-operation.c"
			}
		}
	} else {
		SeahorseSshKeyData* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		SeahorseSshKeyData* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
#line 60 "../ssh/key-delete-operation.vala"
		_tmp15_ = keydata;
#line 60 "../ssh/key-delete-operation.vala"
		_tmp16_ = seahorse_ssh_key_data_get_pubfile (_tmp15_);
#line 60 "../ssh/key-delete-operation.vala"
		_tmp17_ = _tmp16_;
#line 60 "../ssh/key-delete-operation.vala"
		if (_tmp17_ != NULL) {
#line 426 "key-delete-operation.c"
			SeahorseSshKeyData* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
#line 61 "../ssh/key-delete-operation.vala"
			_tmp18_ = keydata;
#line 61 "../ssh/key-delete-operation.vala"
			_tmp19_ = seahorse_ssh_key_data_get_pubfile (_tmp18_);
#line 61 "../ssh/key-delete-operation.vala"
			_tmp20_ = _tmp19_;
#line 61 "../ssh/key-delete-operation.vala"
			if (g_unlink (_tmp20_) == -1) {
#line 438 "key-delete-operation.c"
				SeahorseSshKeyData* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				GError* _tmp26_;
				GError* _tmp27_;
#line 62 "../ssh/key-delete-operation.vala"
				_tmp21_ = keydata;
#line 62 "../ssh/key-delete-operation.vala"
				_tmp22_ = seahorse_ssh_key_data_get_pubfile (_tmp21_);
#line 62 "../ssh/key-delete-operation.vala"
				_tmp23_ = _tmp22_;
#line 62 "../ssh/key-delete-operation.vala"
				_tmp24_ = g_strdup_printf ("Couldn't delete public key file '%s'", _tmp23_);
#line 62 "../ssh/key-delete-operation.vala"
				_tmp25_ = _tmp24_;
#line 62 "../ssh/key-delete-operation.vala"
				_tmp26_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _tmp25_);
#line 62 "../ssh/key-delete-operation.vala"
				_tmp27_ = _tmp26_;
#line 62 "../ssh/key-delete-operation.vala"
				_g_free0 (_tmp25_);
#line 62 "../ssh/key-delete-operation.vala"
				_inner_error0_ = _tmp27_;
#line 62 "../ssh/key-delete-operation.vala"
				g_propagate_error (error, _inner_error0_);
#line 62 "../ssh/key-delete-operation.vala"
				_g_object_unref0 (keydata);
#line 62 "../ssh/key-delete-operation.vala"
				return;
#line 470 "key-delete-operation.c"
			}
		}
#line 65 "../ssh/key-delete-operation.vala"
		_tmp28_ = keydata;
#line 65 "../ssh/key-delete-operation.vala"
		_tmp29_ = seahorse_ssh_key_data_get_privfile (_tmp28_);
#line 65 "../ssh/key-delete-operation.vala"
		_tmp30_ = _tmp29_;
#line 65 "../ssh/key-delete-operation.vala"
		if (_tmp30_ != NULL) {
#line 481 "key-delete-operation.c"
			SeahorseSshKeyData* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
#line 66 "../ssh/key-delete-operation.vala"
			_tmp31_ = keydata;
#line 66 "../ssh/key-delete-operation.vala"
			_tmp32_ = seahorse_ssh_key_data_get_privfile (_tmp31_);
#line 66 "../ssh/key-delete-operation.vala"
			_tmp33_ = _tmp32_;
#line 66 "../ssh/key-delete-operation.vala"
			if (g_unlink (_tmp33_) == -1) {
#line 493 "key-delete-operation.c"
				SeahorseSshKeyData* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				GError* _tmp39_;
				GError* _tmp40_;
#line 67 "../ssh/key-delete-operation.vala"
				_tmp34_ = keydata;
#line 67 "../ssh/key-delete-operation.vala"
				_tmp35_ = seahorse_ssh_key_data_get_privfile (_tmp34_);
#line 67 "../ssh/key-delete-operation.vala"
				_tmp36_ = _tmp35_;
#line 67 "../ssh/key-delete-operation.vala"
				_tmp37_ = g_strdup_printf ("Couldn't delete private key file '%s'", _tmp36_);
#line 67 "../ssh/key-delete-operation.vala"
				_tmp38_ = _tmp37_;
#line 67 "../ssh/key-delete-operation.vala"
				_tmp39_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _tmp38_);
#line 67 "../ssh/key-delete-operation.vala"
				_tmp40_ = _tmp39_;
#line 67 "../ssh/key-delete-operation.vala"
				_g_free0 (_tmp38_);
#line 67 "../ssh/key-delete-operation.vala"
				_inner_error0_ = _tmp40_;
#line 67 "../ssh/key-delete-operation.vala"
				g_propagate_error (error, _inner_error0_);
#line 67 "../ssh/key-delete-operation.vala"
				_g_object_unref0 (keydata);
#line 67 "../ssh/key-delete-operation.vala"
				return;
#line 525 "key-delete-operation.c"
			}
		}
	}
#line 72 "../ssh/key-delete-operation.vala"
	_tmp41_ = seahorse_object_get_place ((SeahorseObject*) key);
#line 72 "../ssh/key-delete-operation.vala"
	_tmp42_ = _tmp41_;
#line 72 "../ssh/key-delete-operation.vala"
	_tmp43_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource));
#line 72 "../ssh/key-delete-operation.vala"
	source = _tmp43_;
#line 73 "../ssh/key-delete-operation.vala"
	_tmp44_ = source;
#line 73 "../ssh/key-delete-operation.vala"
	seahorse_ssh_source_remove_object (_tmp44_, key);
#line 50 "../ssh/key-delete-operation.vala"
	_g_object_unref0 (source);
#line 50 "../ssh/key-delete-operation.vala"
	_g_object_unref0 (keydata);
#line 545 "key-delete-operation.c"
}

static void
seahorse_ssh_key_delete_operation_class_init (SeahorseSshKeyDeleteOperationClass * klass,
                                              gpointer klass_data)
{
#line 24 "../ssh/key-delete-operation.vala"
	seahorse_ssh_key_delete_operation_parent_class = g_type_class_peek_parent (klass);
#line 24 "../ssh/key-delete-operation.vala"
	((SeahorseDeleteOperationClass *) klass)->execute = (void (*) (SeahorseDeleteOperation*, GCancellable*, GAsyncReadyCallback, gpointer)) seahorse_ssh_key_delete_operation_real_execute;
#line 24 "../ssh/key-delete-operation.vala"
	((SeahorseDeleteOperationClass *) klass)->execute_finish = (gboolean (*) (SeahorseDeleteOperation*, GAsyncResult*, GError**)) seahorse_ssh_key_delete_operation_execute_finish;
#line 558 "key-delete-operation.c"
}

static void
seahorse_ssh_key_delete_operation_instance_init (SeahorseSshKeyDeleteOperation * self,
                                                 gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
seahorse_ssh_key_delete_operation_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshKeyDeleteOperationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_key_delete_operation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshKeyDeleteOperation), 0, (GInstanceInitFunc) seahorse_ssh_key_delete_operation_instance_init, NULL };
	GType seahorse_ssh_key_delete_operation_type_id;
	seahorse_ssh_key_delete_operation_type_id = g_type_register_static (SEAHORSE_TYPE_DELETE_OPERATION, "SeahorseSshKeyDeleteOperation", &g_define_type_info, 0);
	return seahorse_ssh_key_delete_operation_type_id;
}

GType
seahorse_ssh_key_delete_operation_get_type (void)
{
	static gsize seahorse_ssh_key_delete_operation_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_key_delete_operation_type_id__once)) {
		GType seahorse_ssh_key_delete_operation_type_id;
		seahorse_ssh_key_delete_operation_type_id = seahorse_ssh_key_delete_operation_get_type_once ();
		g_once_init_leave (&seahorse_ssh_key_delete_operation_type_id__once, seahorse_ssh_key_delete_operation_type_id);
	}
	return seahorse_ssh_key_delete_operation_type_id__once;
}

