/* key-panel.c generated by valac 0.56.18, the Vala compiler
 * generated from key-panel.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-ssh.h"
#include <glib.h>
#include <adwaita.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "seahorse-common.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_SSH_KEY_PANEL_0_PROPERTY,
	SEAHORSE_SSH_KEY_PANEL_KEY_PROPERTY,
	SEAHORSE_SSH_KEY_PANEL_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_key_panel_properties[SEAHORSE_SSH_KEY_PANEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef struct _SeahorseSshKeyPanelExportData SeahorseSshKeyPanelExportData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SeahorseSshKeyPanelPrivate {
	SeahorseSshKey* _key;
	gboolean updating_ui;
	AdwEntryRow* comment_row;
	AdwActionRow* algo_row;
	AdwActionRow* key_length_row;
	AdwActionRow* location_row;
	AdwActionRow* fingerprint_row;
	GtkLabel* pubkey_label;
	AdwSwitchRow* trust_check;
};

struct _Block1Data {
	int _ref_count_;
	SeahorseSshKeyPanel* self;
	GtkWindow* toplevel;
	SeahorseSshRenameOperation* op;
	AdwEntryRow* entry;
};

struct _Block2Data {
	int _ref_count_;
	SeahorseSshKeyPanel* self;
	SeahorseSshSource* source;
	GtkWindow* toplevel;
};

struct _Block3Data {
	int _ref_count_;
	SeahorseSshKeyPanel* self;
	SeahorseSshChangePassphraseOperation* op;
};

struct _Block4Data {
	int _ref_count_;
	SeahorseSshKeyPanel* self;
	GtkWindow* toplevel;
	SeahorseDeleteOperation* delete_op;
};

struct _SeahorseSshKeyPanelExportData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshKeyPanel* self;
	gboolean secret;
	SeahorseSshKey* _tmp0_;
	GtkWindow* toplevel;
	GtkRoot* _tmp1_;
	SeahorseSshKeyExportOperation* export_op;
	SeahorseSshKey* _tmp2_;
	SeahorseSshKeyExportOperation* _tmp3_;
	gboolean prompted;
	SeahorseSshKeyExportOperation* _tmp4_;
	GtkWindow* _tmp5_;
	SeahorseSshKeyExportOperation* _tmp6_;
	GError* e;
	GtkWindow* _tmp7_;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_;
};

static gint SeahorseSshKeyPanel_private_offset;
static gpointer seahorse_ssh_key_panel_parent_class = NULL;

static void seahorse_ssh_key_panel_action_copy_public_key (SeahorseSshKeyPanel* self,
                                                    GSimpleAction* action,
                                                    GVariant* param);
static void _seahorse_ssh_key_panel_action_copy_public_key_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void seahorse_ssh_key_panel_action_generate_qr_code (SeahorseSshKeyPanel* self,
                                                     GSimpleAction* action,
                                                     GVariant* param);
static void _seahorse_ssh_key_panel_action_generate_qr_code_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void seahorse_ssh_key_panel_action_change_passphrase (SeahorseSshKeyPanel* self,
                                                      GSimpleAction* action,
                                                      GVariant* param);
static void _seahorse_ssh_key_panel_action_change_passphrase_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void seahorse_ssh_key_panel_action_export_secret_key (SeahorseSshKeyPanel* self,
                                                      GSimpleAction* action,
                                                      GVariant* param);
static void _seahorse_ssh_key_panel_action_export_secret_key_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void seahorse_ssh_key_panel_action_upload_key (SeahorseSshKeyPanel* self,
                                               GSimpleAction* action,
                                               GVariant* param);
static void _seahorse_ssh_key_panel_action_upload_key_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void seahorse_ssh_key_panel_action_delete_key (SeahorseSshKeyPanel* self,
                                               GSimpleAction* action,
                                               GVariant* param);
static void _seahorse_ssh_key_panel_action_delete_key_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void seahorse_ssh_key_panel_real_dispose (GObject* base);
static void seahorse_ssh_key_panel_update_ui (SeahorseSshKeyPanel* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda12_ (Block1Data* _data1_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _seahorse_ssh_key_panel_on_ssh_comment_apply_adw_entry_row_apply (AdwEntryRow* _sender,
                                                                       gpointer self);
static void seahorse_ssh_key_panel_on_ssh_trust_changed (SeahorseSshKeyPanel* self,
                                                  GObject* button,
                                                  GParamSpec* p);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda14_ (Block2Data* _data2_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda14__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _seahorse_ssh_key_panel_on_ssh_trust_changed_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda5_ (Block3Data* _data3_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda5__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void __lambda9_ (SeahorseSshKeyPanel* self);
static void ___lambda9__seahorse_ssh_upload_remote_dialog_key_uploaded (SeahorseSshUploadRemoteDialog* _sender,
                                                                 gpointer self);
static void __lambda10_ (SeahorseSshKeyPanel* self,
                  const gchar* message);
static void ___lambda10__seahorse_ssh_upload_remote_dialog_error (SeahorseSshUploadRemoteDialog* _sender,
                                                           const gchar* message,
                                                           gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda11_ (Block4Data* _data4_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda11__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void seahorse_ssh_key_panel_export (SeahorseSshKeyPanel* self,
                                    gboolean secret,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static void seahorse_ssh_key_panel_export_finish (SeahorseSshKeyPanel* self,
                                           GAsyncResult* _res_);
static void __lambda6_ (SeahorseSshKeyPanel* self,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda6__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void seahorse_ssh_key_panel_export_data_free (gpointer _data);
static gboolean seahorse_ssh_key_panel_export_co (SeahorseSshKeyPanelExportData* _data_);
static void seahorse_ssh_key_panel_export_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static GObject * seahorse_ssh_key_panel_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _seahorse_ssh_key_panel___lambda15_ (SeahorseSshKeyPanel* self,
                                          GObject* obj,
                                          GParamSpec* pspec);
static void __seahorse_ssh_key_panel___lambda15__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void seahorse_ssh_key_panel_finalize (GObject * obj);
static GType seahorse_ssh_key_panel_get_type_once (void);
static void _vala_seahorse_ssh_key_panel_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_seahorse_ssh_key_panel_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static const GActionEntry SEAHORSE_SSH_KEY_PANEL_ACTIONS[6] = {{"copy-public-key", _seahorse_ssh_key_panel_action_copy_public_key_gsimple_action_activate_callback}, {"generate-qr-code", _seahorse_ssh_key_panel_action_generate_qr_code_gsimple_action_activate_callback}, {"change-passphrase", _seahorse_ssh_key_panel_action_change_passphrase_gsimple_action_activate_callback}, {"export-secret-key", _seahorse_ssh_key_panel_action_export_secret_key_gsimple_action_activate_callback}, {"remote-upload", _seahorse_ssh_key_panel_action_upload_key_gsimple_action_activate_callback}, {"delete-key", _seahorse_ssh_key_panel_action_delete_key_gsimple_action_activate_callback}};

static inline gpointer
seahorse_ssh_key_panel_get_instance_private (SeahorseSshKeyPanel* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseSshKeyPanel_private_offset);
}

static void
_seahorse_ssh_key_panel_action_copy_public_key_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 41 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_action_copy_public_key ((SeahorseSshKeyPanel*) self, action, parameter);
#line 271 "key-panel.c"
}

static void
_seahorse_ssh_key_panel_action_generate_qr_code_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 41 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_action_generate_qr_code ((SeahorseSshKeyPanel*) self, action, parameter);
#line 281 "key-panel.c"
}

static void
_seahorse_ssh_key_panel_action_change_passphrase_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 41 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_action_change_passphrase ((SeahorseSshKeyPanel*) self, action, parameter);
#line 291 "key-panel.c"
}

static void
_seahorse_ssh_key_panel_action_export_secret_key_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 41 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_action_export_secret_key ((SeahorseSshKeyPanel*) self, action, parameter);
#line 301 "key-panel.c"
}

static void
_seahorse_ssh_key_panel_action_upload_key_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 41 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_action_upload_key ((SeahorseSshKeyPanel*) self, action, parameter);
#line 311 "key-panel.c"
}

static void
_seahorse_ssh_key_panel_action_delete_key_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 41 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_action_delete_key ((SeahorseSshKeyPanel*) self, action, parameter);
#line 321 "key-panel.c"
}

SeahorseSshKeyPanel*
seahorse_ssh_key_panel_construct (GType object_type,
                                  SeahorseSshKey* key)
{
	SeahorseSshKeyPanel * self = NULL;
#line 67 "../ssh/key-panel.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 68 "../ssh/key-panel.vala"
	self = (SeahorseSshKeyPanel*) g_object_new (object_type, "key", key, NULL);
#line 67 "../ssh/key-panel.vala"
	return self;
#line 335 "key-panel.c"
}

SeahorseSshKeyPanel*
seahorse_ssh_key_panel_new (SeahorseSshKey* key)
{
#line 67 "../ssh/key-panel.vala"
	return seahorse_ssh_key_panel_construct (SEAHORSE_SSH_TYPE_KEY_PANEL, key);
#line 343 "key-panel.c"
}

static void
seahorse_ssh_key_panel_real_dispose (GObject* base)
{
	SeahorseSshKeyPanel * self;
	GtkWidget* child = NULL;
#line 71 "../ssh/key-panel.vala"
	self = (SeahorseSshKeyPanel*) base;
#line 72 "../ssh/key-panel.vala"
	child = NULL;
#line 73 "../ssh/key-panel.vala"
	while (TRUE) {
#line 357 "key-panel.c"
		GtkWidget* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
#line 73 "../ssh/key-panel.vala"
		_tmp0_ = gtk_widget_get_first_child ((GtkWidget*) self);
#line 73 "../ssh/key-panel.vala"
		child = _tmp0_;
#line 73 "../ssh/key-panel.vala"
		_tmp1_ = child;
#line 73 "../ssh/key-panel.vala"
		if (!(_tmp1_ != NULL)) {
#line 73 "../ssh/key-panel.vala"
			break;
#line 371 "key-panel.c"
		}
#line 74 "../ssh/key-panel.vala"
		_tmp2_ = child;
#line 74 "../ssh/key-panel.vala"
		gtk_widget_unparent (_tmp2_);
#line 377 "key-panel.c"
	}
#line 75 "../ssh/key-panel.vala"
	G_OBJECT_CLASS (seahorse_ssh_key_panel_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, SEAHORSE_TYPE_PANEL, SeahorsePanel));
#line 381 "key-panel.c"
}

static void
seahorse_ssh_key_panel_update_ui (SeahorseSshKeyPanel* self)
{
	AdwEntryRow* _tmp0_;
	SeahorseSshKey* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	AdwSwitchRow* _tmp4_;
	SeahorseSshKey* _tmp5_;
	SeahorseValidity _tmp6_;
	SeahorseValidity _tmp7_;
	AdwActionRow* _tmp8_;
	SeahorseSshKey* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_ = NULL;
	SeahorseSshKey* _tmp15_;
	gchar* _tmp16_;
	AdwActionRow* _tmp18_;
	AdwActionRow* _tmp19_;
	SeahorseSshKey* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	AdwActionRow* _tmp23_;
	SeahorseSshKey* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	GtkLabel* _tmp27_;
	SeahorseSshKey* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
#line 78 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 79 "../ssh/key-panel.vala"
	self->priv->updating_ui = TRUE;
#line 82 "../ssh/key-panel.vala"
	_tmp0_ = self->priv->comment_row;
#line 82 "../ssh/key-panel.vala"
	_tmp1_ = self->priv->_key;
#line 82 "../ssh/key-panel.vala"
	_tmp2_ = seahorse_object_get_label ((SeahorseObject*) _tmp1_);
#line 82 "../ssh/key-panel.vala"
	_tmp3_ = _tmp2_;
#line 82 "../ssh/key-panel.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp0_, _tmp3_);
#line 85 "../ssh/key-panel.vala"
	_tmp4_ = self->priv->trust_check;
#line 85 "../ssh/key-panel.vala"
	_tmp5_ = self->priv->_key;
#line 85 "../ssh/key-panel.vala"
	_tmp6_ = seahorse_ssh_key_get_trust (_tmp5_);
#line 85 "../ssh/key-panel.vala"
	_tmp7_ = _tmp6_;
#line 85 "../ssh/key-panel.vala"
	adw_switch_row_set_active (_tmp4_, _tmp7_ >= SEAHORSE_VALIDITY_FULL);
#line 87 "../ssh/key-panel.vala"
	_tmp8_ = self->priv->fingerprint_row;
#line 87 "../ssh/key-panel.vala"
	_tmp9_ = self->priv->_key;
#line 87 "../ssh/key-panel.vala"
	_tmp10_ = seahorse_ssh_key_get_fingerprint (_tmp9_);
#line 87 "../ssh/key-panel.vala"
	_tmp11_ = _tmp10_;
#line 87 "../ssh/key-panel.vala"
	_tmp12_ = g_strdup_printf ("<span font=\"monospace\">%s</span>", _tmp11_);
#line 87 "../ssh/key-panel.vala"
	_tmp13_ = _tmp12_;
#line 87 "../ssh/key-panel.vala"
	adw_action_row_set_subtitle (_tmp8_, _tmp13_);
#line 87 "../ssh/key-panel.vala"
	_g_free0 (_tmp13_);
#line 88 "../ssh/key-panel.vala"
	_tmp15_ = self->priv->_key;
#line 88 "../ssh/key-panel.vala"
	_tmp16_ = seahorse_ssh_algorithm_to_string (seahorse_ssh_key_get_algo (_tmp15_));
#line 88 "../ssh/key-panel.vala"
	_tmp14_ = _tmp16_;
#line 88 "../ssh/key-panel.vala"
	if (_tmp14_ == NULL) {
#line 465 "key-panel.c"
		gchar* _tmp17_;
#line 88 "../ssh/key-panel.vala"
		_tmp17_ = g_strdup (_ ("Unknown type"));
#line 88 "../ssh/key-panel.vala"
		_g_free0 (_tmp14_);
#line 88 "../ssh/key-panel.vala"
		_tmp14_ = _tmp17_;
#line 473 "key-panel.c"
	}
#line 88 "../ssh/key-panel.vala"
	_tmp18_ = self->priv->algo_row;
#line 88 "../ssh/key-panel.vala"
	adw_action_row_set_subtitle (_tmp18_, _tmp14_);
#line 89 "../ssh/key-panel.vala"
	_tmp19_ = self->priv->location_row;
#line 89 "../ssh/key-panel.vala"
	_tmp20_ = self->priv->_key;
#line 89 "../ssh/key-panel.vala"
	_tmp21_ = seahorse_ssh_key_get_location (_tmp20_);
#line 89 "../ssh/key-panel.vala"
	_tmp22_ = _tmp21_;
#line 89 "../ssh/key-panel.vala"
	adw_action_row_set_subtitle (_tmp19_, _tmp22_);
#line 89 "../ssh/key-panel.vala"
	_g_free0 (_tmp22_);
#line 90 "../ssh/key-panel.vala"
	_tmp23_ = self->priv->key_length_row;
#line 90 "../ssh/key-panel.vala"
	_tmp24_ = self->priv->_key;
#line 90 "../ssh/key-panel.vala"
	_tmp25_ = g_strdup_printf ("%u", seahorse_ssh_key_get_strength (_tmp24_));
#line 90 "../ssh/key-panel.vala"
	_tmp26_ = _tmp25_;
#line 90 "../ssh/key-panel.vala"
	adw_action_row_set_subtitle (_tmp23_, _tmp26_);
#line 90 "../ssh/key-panel.vala"
	_g_free0 (_tmp26_);
#line 91 "../ssh/key-panel.vala"
	_tmp27_ = self->priv->pubkey_label;
#line 91 "../ssh/key-panel.vala"
	_tmp28_ = self->priv->_key;
#line 91 "../ssh/key-panel.vala"
	_tmp29_ = seahorse_ssh_key_get_pubkey (_tmp28_);
#line 91 "../ssh/key-panel.vala"
	_tmp30_ = _tmp29_;
#line 91 "../ssh/key-panel.vala"
	gtk_label_set_label (_tmp27_, _tmp30_);
#line 93 "../ssh/key-panel.vala"
	self->priv->updating_ui = FALSE;
#line 78 "../ssh/key-panel.vala"
	_g_free0 (_tmp14_);
#line 517 "key-panel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 97 "../ssh/key-panel.vala"
	return self ? g_object_ref (self) : NULL;
#line 525 "key-panel.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 97 "../ssh/key-panel.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 97 "../ssh/key-panel.vala"
	return _data1_;
#line 535 "key-panel.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 97 "../ssh/key-panel.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 545 "key-panel.c"
		SeahorseSshKeyPanel* self;
#line 97 "../ssh/key-panel.vala"
		self = _data1_->self;
#line 97 "../ssh/key-panel.vala"
		_g_object_unref0 (_data1_->op);
#line 97 "../ssh/key-panel.vala"
		_g_object_unref0 (_data1_->entry);
#line 97 "../ssh/key-panel.vala"
		_g_object_unref0 (self);
#line 97 "../ssh/key-panel.vala"
		g_slice_free (Block1Data, _data1_);
#line 557 "key-panel.c"
	}
}

static void
__lambda12_ (Block1Data* _data1_,
             GObject* obj,
             GAsyncResult* res)
{
	SeahorseSshKeyPanel* self;
	GError* _inner_error0_ = NULL;
#line 107 "../ssh/key-panel.vala"
	self = _data1_->self;
#line 107 "../ssh/key-panel.vala"
	g_return_if_fail (res != NULL);
#line 572 "key-panel.c"
	{
		SeahorseSshRenameOperation* _tmp0_;
#line 109 "../ssh/key-panel.vala"
		_tmp0_ = _data1_->op;
#line 109 "../ssh/key-panel.vala"
		seahorse_ssh_rename_operation_rename_finish (_tmp0_, res, &_inner_error0_);
#line 109 "../ssh/key-panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 581 "key-panel.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GtkWindow* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		SeahorseSshKey* _tmp5_;
		SeahorseSshKeyData* _tmp6_;
		SeahorseSshKeyData* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 108 "../ssh/key-panel.vala"
		e = _inner_error0_;
#line 108 "../ssh/key-panel.vala"
		_inner_error0_ = NULL;
#line 111 "../ssh/key-panel.vala"
		_tmp1_ = _data1_->toplevel;
#line 111 "../ssh/key-panel.vala"
		_tmp2_ = e;
#line 111 "../ssh/key-panel.vala"
		_tmp3_ = _tmp2_->message;
#line 111 "../ssh/key-panel.vala"
		seahorse_util_show_error ((GtkWidget*) _tmp1_, _ ("Couldn’t rename key."), _tmp3_);
#line 112 "../ssh/key-panel.vala"
		_tmp5_ = self->priv->_key;
#line 112 "../ssh/key-panel.vala"
		_tmp6_ = seahorse_ssh_key_get_key_data (_tmp5_);
#line 112 "../ssh/key-panel.vala"
		_tmp7_ = _tmp6_;
#line 112 "../ssh/key-panel.vala"
		_tmp8_ = seahorse_ssh_key_data_get_comment (_tmp7_);
#line 112 "../ssh/key-panel.vala"
		_tmp9_ = _tmp8_;
#line 112 "../ssh/key-panel.vala"
		_tmp4_ = _tmp9_;
#line 112 "../ssh/key-panel.vala"
		if (_tmp4_ == NULL) {
#line 112 "../ssh/key-panel.vala"
			_tmp4_ = "";
#line 626 "key-panel.c"
		}
#line 112 "../ssh/key-panel.vala"
		gtk_editable_set_text ((GtkEditable*) _data1_->entry, _tmp4_);
#line 108 "../ssh/key-panel.vala"
		_g_error_free0 (e);
#line 632 "key-panel.c"
	}
	__finally0:
#line 108 "../ssh/key-panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../ssh/key-panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../ssh/key-panel.vala"
		g_clear_error (&_inner_error0_);
#line 108 "../ssh/key-panel.vala"
		return;
#line 643 "key-panel.c"
	}
#line 115 "../ssh/key-panel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _data1_->entry, TRUE);
#line 647 "key-panel.c"
}

static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 107 "../ssh/key-panel.vala"
	__lambda12_ (self, source_object, res);
#line 107 "../ssh/key-panel.vala"
	block1_data_unref (self);
#line 659 "key-panel.c"
}

void
seahorse_ssh_key_panel_on_ssh_comment_apply (SeahorseSshKeyPanel* self,
                                             AdwEntryRow* entry)
{
	Block1Data* _data1_;
	AdwEntryRow* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SeahorseSshKey* _tmp2_;
	SeahorseSshKeyData* _tmp3_;
	SeahorseSshKeyData* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkRoot* _tmp14_;
	SeahorseSshRenameOperation* _tmp15_;
	SeahorseSshRenameOperation* _tmp16_;
	SeahorseSshKey* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GtkWindow* _tmp20_;
#line 97 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 97 "../ssh/key-panel.vala"
	g_return_if_fail (entry != NULL);
#line 97 "../ssh/key-panel.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 97 "../ssh/key-panel.vala"
	_data1_->_ref_count_ = 1;
#line 97 "../ssh/key-panel.vala"
	_data1_->self = g_object_ref (self);
#line 97 "../ssh/key-panel.vala"
	_tmp0_ = _g_object_ref0 (entry);
#line 97 "../ssh/key-panel.vala"
	_g_object_unref0 (_data1_->entry);
#line 97 "../ssh/key-panel.vala"
	_data1_->entry = _tmp0_;
#line 99 "../ssh/key-panel.vala"
	_tmp2_ = self->priv->_key;
#line 99 "../ssh/key-panel.vala"
	_tmp3_ = seahorse_ssh_key_get_key_data (_tmp2_);
#line 99 "../ssh/key-panel.vala"
	_tmp4_ = _tmp3_;
#line 99 "../ssh/key-panel.vala"
	_tmp5_ = seahorse_ssh_key_data_get_comment (_tmp4_);
#line 99 "../ssh/key-panel.vala"
	_tmp6_ = _tmp5_;
#line 99 "../ssh/key-panel.vala"
	if (_tmp6_ != NULL) {
#line 709 "key-panel.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		SeahorseSshKey* _tmp9_;
		SeahorseSshKeyData* _tmp10_;
		SeahorseSshKeyData* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 99 "../ssh/key-panel.vala"
		_tmp7_ = gtk_editable_get_text ((GtkEditable*) _data1_->entry);
#line 99 "../ssh/key-panel.vala"
		_tmp8_ = _tmp7_;
#line 99 "../ssh/key-panel.vala"
		_tmp9_ = self->priv->_key;
#line 99 "../ssh/key-panel.vala"
		_tmp10_ = seahorse_ssh_key_get_key_data (_tmp9_);
#line 99 "../ssh/key-panel.vala"
		_tmp11_ = _tmp10_;
#line 99 "../ssh/key-panel.vala"
		_tmp12_ = seahorse_ssh_key_data_get_comment (_tmp11_);
#line 99 "../ssh/key-panel.vala"
		_tmp13_ = _tmp12_;
#line 99 "../ssh/key-panel.vala"
		_tmp1_ = g_strcmp0 (_tmp8_, _tmp13_) == 0;
#line 733 "key-panel.c"
	} else {
#line 99 "../ssh/key-panel.vala"
		_tmp1_ = FALSE;
#line 737 "key-panel.c"
	}
#line 99 "../ssh/key-panel.vala"
	if (_tmp1_) {
#line 100 "../ssh/key-panel.vala"
		block1_data_unref (_data1_);
#line 100 "../ssh/key-panel.vala"
		_data1_ = NULL;
#line 100 "../ssh/key-panel.vala"
		return;
#line 747 "key-panel.c"
	}
#line 102 "../ssh/key-panel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _data1_->entry, FALSE);
#line 104 "../ssh/key-panel.vala"
	_tmp14_ = gtk_widget_get_root ((GtkWidget*) self);
#line 104 "../ssh/key-panel.vala"
	_data1_->toplevel = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp14_) : NULL;
#line 106 "../ssh/key-panel.vala"
	_tmp15_ = seahorse_ssh_rename_operation_new ();
#line 106 "../ssh/key-panel.vala"
	_data1_->op = _tmp15_;
#line 107 "../ssh/key-panel.vala"
	_tmp16_ = _data1_->op;
#line 107 "../ssh/key-panel.vala"
	_tmp17_ = self->priv->_key;
#line 107 "../ssh/key-panel.vala"
	_tmp18_ = gtk_editable_get_text ((GtkEditable*) _data1_->entry);
#line 107 "../ssh/key-panel.vala"
	_tmp19_ = _tmp18_;
#line 107 "../ssh/key-panel.vala"
	_tmp20_ = _data1_->toplevel;
#line 107 "../ssh/key-panel.vala"
	seahorse_ssh_rename_operation_rename_async (_tmp16_, _tmp17_, _tmp19_, _tmp20_, ___lambda12__gasync_ready_callback, block1_data_ref (_data1_));
#line 97 "../ssh/key-panel.vala"
	block1_data_unref (_data1_);
#line 97 "../ssh/key-panel.vala"
	_data1_ = NULL;
#line 775 "key-panel.c"
}

static void
_seahorse_ssh_key_panel_on_ssh_comment_apply_adw_entry_row_apply (AdwEntryRow* _sender,
                                                                  gpointer self)
{
#line 23 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_on_ssh_comment_apply ((SeahorseSshKeyPanel*) self, _sender);
#line 784 "key-panel.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 120 "../ssh/key-panel.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 120 "../ssh/key-panel.vala"
	return _data2_;
#line 794 "key-panel.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 120 "../ssh/key-panel.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 804 "key-panel.c"
		SeahorseSshKeyPanel* self;
#line 120 "../ssh/key-panel.vala"
		self = _data2_->self;
#line 120 "../ssh/key-panel.vala"
		_g_object_unref0 (_data2_->source);
#line 120 "../ssh/key-panel.vala"
		_g_object_unref0 (self);
#line 120 "../ssh/key-panel.vala"
		g_slice_free (Block2Data, _data2_);
#line 814 "key-panel.c"
	}
}

static void
__lambda14_ (Block2Data* _data2_,
             GObject* obj,
             GAsyncResult* res)
{
	SeahorseSshKeyPanel* self;
	AdwSwitchRow* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 129 "../ssh/key-panel.vala"
	self = _data2_->self;
#line 129 "../ssh/key-panel.vala"
	g_return_if_fail (res != NULL);
#line 830 "key-panel.c"
	{
		SeahorseSshSource* _tmp0_;
#line 131 "../ssh/key-panel.vala"
		_tmp0_ = _data2_->source;
#line 131 "../ssh/key-panel.vala"
		seahorse_ssh_source_authorize_finish (_tmp0_, res, &_inner_error0_);
#line 131 "../ssh/key-panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 839 "key-panel.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GtkWindow* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 130 "../ssh/key-panel.vala"
		e = _inner_error0_;
#line 130 "../ssh/key-panel.vala"
		_inner_error0_ = NULL;
#line 133 "../ssh/key-panel.vala"
		_tmp1_ = _data2_->toplevel;
#line 133 "../ssh/key-panel.vala"
		_tmp2_ = e;
#line 133 "../ssh/key-panel.vala"
		_tmp3_ = _tmp2_->message;
#line 133 "../ssh/key-panel.vala"
		seahorse_util_show_error ((GtkWidget*) _tmp1_, _ ("Couldn’t change authorization for key."), _tmp3_);
#line 130 "../ssh/key-panel.vala"
		_g_error_free0 (e);
#line 864 "key-panel.c"
	}
	__finally0:
#line 130 "../ssh/key-panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../ssh/key-panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "../ssh/key-panel.vala"
		g_clear_error (&_inner_error0_);
#line 130 "../ssh/key-panel.vala"
		return;
#line 875 "key-panel.c"
	}
#line 136 "../ssh/key-panel.vala"
	_tmp4_ = self->priv->trust_check;
#line 136 "../ssh/key-panel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 881 "key-panel.c"
}

static void
___lambda14__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 129 "../ssh/key-panel.vala"
	__lambda14_ (self, source_object, res);
#line 129 "../ssh/key-panel.vala"
	block2_data_unref (self);
#line 893 "key-panel.c"
}

static void
seahorse_ssh_key_panel_on_ssh_trust_changed (SeahorseSshKeyPanel* self,
                                             GObject* button,
                                             GParamSpec* p)
{
	Block2Data* _data2_;
	AdwSwitchRow* _tmp0_;
	SeahorseSshKey* _tmp1_;
	SeahorsePlace* _tmp2_;
	SeahorsePlace* _tmp3_;
	SeahorseSshSource* _tmp4_;
	GtkRoot* _tmp5_;
	SeahorseSshSource* _tmp6_;
	SeahorseSshKey* _tmp7_;
	AdwSwitchRow* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 120 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 120 "../ssh/key-panel.vala"
	g_return_if_fail (button != NULL);
#line 120 "../ssh/key-panel.vala"
	g_return_if_fail (p != NULL);
#line 120 "../ssh/key-panel.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 120 "../ssh/key-panel.vala"
	_data2_->_ref_count_ = 1;
#line 120 "../ssh/key-panel.vala"
	_data2_->self = g_object_ref (self);
#line 121 "../ssh/key-panel.vala"
	if (self->priv->updating_ui) {
#line 122 "../ssh/key-panel.vala"
		block2_data_unref (_data2_);
#line 122 "../ssh/key-panel.vala"
		_data2_ = NULL;
#line 122 "../ssh/key-panel.vala"
		return;
#line 933 "key-panel.c"
	}
#line 124 "../ssh/key-panel.vala"
	_tmp0_ = self->priv->trust_check;
#line 124 "../ssh/key-panel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 126 "../ssh/key-panel.vala"
	_tmp1_ = self->priv->_key;
#line 126 "../ssh/key-panel.vala"
	_tmp2_ = seahorse_object_get_place ((SeahorseObject*) _tmp1_);
#line 126 "../ssh/key-panel.vala"
	_tmp3_ = _tmp2_;
#line 126 "../ssh/key-panel.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource));
#line 126 "../ssh/key-panel.vala"
	_data2_->source = _tmp4_;
#line 128 "../ssh/key-panel.vala"
	_tmp5_ = gtk_widget_get_root ((GtkWidget*) self);
#line 128 "../ssh/key-panel.vala"
	_data2_->toplevel = G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp5_) : NULL;
#line 129 "../ssh/key-panel.vala"
	_tmp6_ = _data2_->source;
#line 129 "../ssh/key-panel.vala"
	_tmp7_ = self->priv->_key;
#line 129 "../ssh/key-panel.vala"
	_tmp8_ = self->priv->trust_check;
#line 129 "../ssh/key-panel.vala"
	_tmp9_ = adw_switch_row_get_active (_tmp8_);
#line 129 "../ssh/key-panel.vala"
	_tmp10_ = _tmp9_;
#line 129 "../ssh/key-panel.vala"
	seahorse_ssh_source_authorize_async (_tmp6_, _tmp7_, _tmp10_, ___lambda14__gasync_ready_callback, block2_data_ref (_data2_));
#line 120 "../ssh/key-panel.vala"
	block2_data_unref (_data2_);
#line 120 "../ssh/key-panel.vala"
	_data2_ = NULL;
#line 969 "key-panel.c"
}

static void
_seahorse_ssh_key_panel_on_ssh_trust_changed_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 23 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_on_ssh_trust_changed ((SeahorseSshKeyPanel*) self, _sender, pspec);
#line 979 "key-panel.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 140 "../ssh/key-panel.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 140 "../ssh/key-panel.vala"
	return _data3_;
#line 989 "key-panel.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 140 "../ssh/key-panel.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 999 "key-panel.c"
		SeahorseSshKeyPanel* self;
#line 140 "../ssh/key-panel.vala"
		self = _data3_->self;
#line 140 "../ssh/key-panel.vala"
		_g_object_unref0 (_data3_->op);
#line 140 "../ssh/key-panel.vala"
		_g_object_unref0 (self);
#line 140 "../ssh/key-panel.vala"
		g_slice_free (Block3Data, _data3_);
#line 1009 "key-panel.c"
	}
}

static void
__lambda5_ (Block3Data* _data3_,
            GObject* obj,
            GAsyncResult* res)
{
	SeahorseSshKeyPanel* self;
	GError* _inner_error0_ = NULL;
#line 142 "../ssh/key-panel.vala"
	self = _data3_->self;
#line 142 "../ssh/key-panel.vala"
	g_return_if_fail (res != NULL);
#line 1024 "key-panel.c"
	{
#line 144 "../ssh/key-panel.vala"
		seahorse_ssh_change_passphrase_operation_change_passphrase_finish (_data3_->op, res, &_inner_error0_);
#line 144 "../ssh/key-panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1030 "key-panel.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 143 "../ssh/key-panel.vala"
		e = _inner_error0_;
#line 143 "../ssh/key-panel.vala"
		_inner_error0_ = NULL;
#line 146 "../ssh/key-panel.vala"
		_tmp0_ = e;
#line 146 "../ssh/key-panel.vala"
		_tmp1_ = _tmp0_->message;
#line 146 "../ssh/key-panel.vala"
		seahorse_util_show_error ((GtkWidget*) self, _ ("Couldn’t change passphrase for key."), _tmp1_);
#line 143 "../ssh/key-panel.vala"
		_g_error_free0 (e);
#line 1052 "key-panel.c"
	}
	__finally0:
#line 143 "../ssh/key-panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 143 "../ssh/key-panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../ssh/key-panel.vala"
		g_clear_error (&_inner_error0_);
#line 143 "../ssh/key-panel.vala"
		return;
#line 1063 "key-panel.c"
	}
}

static void
___lambda5__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 142 "../ssh/key-panel.vala"
	__lambda5_ (self, source_object, res);
#line 142 "../ssh/key-panel.vala"
	block3_data_unref (self);
#line 1076 "key-panel.c"
}

static void
seahorse_ssh_key_panel_action_change_passphrase (SeahorseSshKeyPanel* self,
                                                 GSimpleAction* action,
                                                 GVariant* param)
{
	Block3Data* _data3_;
	SeahorseSshChangePassphraseOperation* _tmp0_;
	SeahorseSshKey* _tmp1_;
#line 140 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 140 "../ssh/key-panel.vala"
	g_return_if_fail (action != NULL);
#line 140 "../ssh/key-panel.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 140 "../ssh/key-panel.vala"
	_data3_->_ref_count_ = 1;
#line 140 "../ssh/key-panel.vala"
	_data3_->self = g_object_ref (self);
#line 141 "../ssh/key-panel.vala"
	_tmp0_ = seahorse_ssh_change_passphrase_operation_new ();
#line 141 "../ssh/key-panel.vala"
	_data3_->op = _tmp0_;
#line 142 "../ssh/key-panel.vala"
	_tmp1_ = self->priv->_key;
#line 142 "../ssh/key-panel.vala"
	seahorse_ssh_change_passphrase_operation_change_passphrase_async (_data3_->op, _tmp1_, NULL, ___lambda5__gasync_ready_callback, block3_data_ref (_data3_));
#line 140 "../ssh/key-panel.vala"
	block3_data_unref (_data3_);
#line 140 "../ssh/key-panel.vala"
	_data3_ = NULL;
#line 1109 "key-panel.c"
}

static void
__lambda9_ (SeahorseSshKeyPanel* self)
{
#line 154 "../ssh/key-panel.vala"
	seahorse_panel_simple_notification ((SeahorsePanel*) self, _ ("Remote Access successfully configured"));
#line 1117 "key-panel.c"
}

static void
___lambda9__seahorse_ssh_upload_remote_dialog_key_uploaded (SeahorseSshUploadRemoteDialog* _sender,
                                                            gpointer self)
{
#line 153 "../ssh/key-panel.vala"
	__lambda9_ ((SeahorseSshKeyPanel*) self);
#line 1126 "key-panel.c"
}

static void
__lambda10_ (SeahorseSshKeyPanel* self,
             const gchar* message)
{
#line 156 "../ssh/key-panel.vala"
	g_return_if_fail (message != NULL);
#line 157 "../ssh/key-panel.vala"
	seahorse_panel_simple_notification ((SeahorsePanel*) self, _ ("Error setting up remote access"));
#line 158 "../ssh/key-panel.vala"
	g_warning ("key-panel.vala:158: %s", message);
#line 1139 "key-panel.c"
}

static void
___lambda10__seahorse_ssh_upload_remote_dialog_error (SeahorseSshUploadRemoteDialog* _sender,
                                                      const gchar* message,
                                                      gpointer self)
{
#line 156 "../ssh/key-panel.vala"
	__lambda10_ ((SeahorseSshKeyPanel*) self, message);
#line 1149 "key-panel.c"
}

static void
seahorse_ssh_key_panel_action_upload_key (SeahorseSshKeyPanel* self,
                                          GSimpleAction* action,
                                          GVariant* param)
{
	SeahorseSshUploadRemoteDialog* dialog = NULL;
	SeahorseSshKey* _tmp0_;
	SeahorseSshUploadRemoteDialog* _tmp1_;
	GtkRoot* _tmp2_;
#line 151 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 151 "../ssh/key-panel.vala"
	g_return_if_fail (action != NULL);
#line 152 "../ssh/key-panel.vala"
	_tmp0_ = self->priv->_key;
#line 152 "../ssh/key-panel.vala"
	_tmp1_ = seahorse_ssh_upload_remote_dialog_new (_tmp0_);
#line 152 "../ssh/key-panel.vala"
	g_object_ref_sink (_tmp1_);
#line 152 "../ssh/key-panel.vala"
	dialog = _tmp1_;
#line 153 "../ssh/key-panel.vala"
	g_signal_connect_object (dialog, "key-uploaded", (GCallback) ___lambda9__seahorse_ssh_upload_remote_dialog_key_uploaded, self, 0);
#line 156 "../ssh/key-panel.vala"
	g_signal_connect_object (dialog, "error", (GCallback) ___lambda10__seahorse_ssh_upload_remote_dialog_error, self, 0);
#line 160 "../ssh/key-panel.vala"
	_tmp2_ = gtk_widget_get_root ((GtkWidget*) self);
#line 160 "../ssh/key-panel.vala"
	adw_dialog_present ((AdwDialog*) dialog, (GtkWidget*) (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp2_) : NULL));
#line 151 "../ssh/key-panel.vala"
	_g_object_unref0 (dialog);
#line 1183 "key-panel.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 163 "../ssh/key-panel.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 163 "../ssh/key-panel.vala"
	return _data4_;
#line 1193 "key-panel.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 163 "../ssh/key-panel.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1203 "key-panel.c"
		SeahorseSshKeyPanel* self;
#line 163 "../ssh/key-panel.vala"
		self = _data4_->self;
#line 163 "../ssh/key-panel.vala"
		_g_object_unref0 (_data4_->delete_op);
#line 163 "../ssh/key-panel.vala"
		_g_object_unref0 (self);
#line 163 "../ssh/key-panel.vala"
		g_slice_free (Block4Data, _data4_);
#line 1213 "key-panel.c"
	}
}

static void
__lambda11_ (Block4Data* _data4_,
             GObject* obj,
             GAsyncResult* res)
{
	SeahorseSshKeyPanel* self;
	GError* _inner_error0_ = NULL;
#line 167 "../ssh/key-panel.vala"
	self = _data4_->self;
#line 167 "../ssh/key-panel.vala"
	g_return_if_fail (res != NULL);
#line 1228 "key-panel.c"
	{
#line 169 "../ssh/key-panel.vala"
		seahorse_delete_operation_execute_interactively_finish (_data4_->delete_op, res, &_inner_error0_);
#line 169 "../ssh/key-panel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../ssh/key-panel.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1236 "key-panel.c"
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_io_error_cancelled:
	{
#line 168 "../ssh/key-panel.vala"
		g_clear_error (&_inner_error0_);
#line 171 "../ssh/key-panel.vala"
		g_debug ("key-panel.vala:171: Deletion of key cancelled by user");
#line 1249 "key-panel.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 168 "../ssh/key-panel.vala"
		e = _inner_error0_;
#line 168 "../ssh/key-panel.vala"
		_inner_error0_ = NULL;
#line 173 "../ssh/key-panel.vala"
		_tmp0_ = e;
#line 173 "../ssh/key-panel.vala"
		_tmp1_ = _tmp0_->message;
#line 173 "../ssh/key-panel.vala"
		seahorse_util_show_error ((GtkWidget*) _data4_->toplevel, _ ("Couldn’t delete key"), _tmp1_);
#line 168 "../ssh/key-panel.vala"
		_g_error_free0 (e);
#line 1269 "key-panel.c"
	}
	__finally0:
#line 168 "../ssh/key-panel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 168 "../ssh/key-panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "../ssh/key-panel.vala"
		g_clear_error (&_inner_error0_);
#line 168 "../ssh/key-panel.vala"
		return;
#line 1280 "key-panel.c"
	}
}

static void
___lambda11__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 167 "../ssh/key-panel.vala"
	__lambda11_ (self, source_object, res);
#line 167 "../ssh/key-panel.vala"
	block4_data_unref (self);
#line 1293 "key-panel.c"
}

static void
seahorse_ssh_key_panel_action_delete_key (SeahorseSshKeyPanel* self,
                                          GSimpleAction* action,
                                          GVariant* param)
{
	Block4Data* _data4_;
	GtkRoot* _tmp0_;
	SeahorseSshKey* _tmp1_;
	SeahorseDeleteOperation* _tmp2_;
#line 163 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 163 "../ssh/key-panel.vala"
	g_return_if_fail (action != NULL);
#line 163 "../ssh/key-panel.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 163 "../ssh/key-panel.vala"
	_data4_->_ref_count_ = 1;
#line 163 "../ssh/key-panel.vala"
	_data4_->self = g_object_ref (self);
#line 164 "../ssh/key-panel.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 164 "../ssh/key-panel.vala"
	_data4_->toplevel = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL;
#line 166 "../ssh/key-panel.vala"
	_tmp1_ = self->priv->_key;
#line 166 "../ssh/key-panel.vala"
	_tmp2_ = seahorse_deletable_create_delete_operation ((SeahorseDeletable*) _tmp1_);
#line 166 "../ssh/key-panel.vala"
	_data4_->delete_op = _tmp2_;
#line 167 "../ssh/key-panel.vala"
	seahorse_delete_operation_execute_interactively (_data4_->delete_op, _data4_->toplevel, NULL, ___lambda11__gasync_ready_callback, block4_data_ref (_data4_));
#line 163 "../ssh/key-panel.vala"
	block4_data_unref (_data4_);
#line 163 "../ssh/key-panel.vala"
	_data4_ = NULL;
#line 1331 "key-panel.c"
}

static void
__lambda6_ (SeahorseSshKeyPanel* self,
            GObject* obj,
            GAsyncResult* res)
{
#line 179 "../ssh/key-panel.vala"
	g_return_if_fail (res != NULL);
#line 180 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_export_finish (self, res);
#line 1343 "key-panel.c"
}

static void
___lambda6__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 179 "../ssh/key-panel.vala"
	__lambda6_ ((SeahorseSshKeyPanel*) self, source_object, res);
#line 179 "../ssh/key-panel.vala"
	g_object_unref (self);
#line 1355 "key-panel.c"
}

static void
seahorse_ssh_key_panel_action_export_secret_key (SeahorseSshKeyPanel* self,
                                                 GSimpleAction* action,
                                                 GVariant* param)
{
#line 178 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 178 "../ssh/key-panel.vala"
	g_return_if_fail (action != NULL);
#line 179 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_export (self, TRUE, ___lambda6__gasync_ready_callback, g_object_ref (self));
#line 1369 "key-panel.c"
}

static void
seahorse_ssh_key_panel_export_data_free (gpointer _data)
{
	SeahorseSshKeyPanelExportData* _data_;
	_data_ = _data;
#line 23 "../ssh/key-panel.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../ssh/key-panel.vala"
	g_slice_free (SeahorseSshKeyPanelExportData, _data_);
#line 1381 "key-panel.c"
}

static void
seahorse_ssh_key_panel_export (SeahorseSshKeyPanel* self,
                               gboolean secret,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	SeahorseSshKeyPanelExportData* _data_;
	SeahorseSshKeyPanel* _tmp0_;
#line 23 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 23 "../ssh/key-panel.vala"
	_data_ = g_slice_new0 (SeahorseSshKeyPanelExportData);
#line 23 "../ssh/key-panel.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../ssh/key-panel.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_key_panel_export_data_free);
#line 23 "../ssh/key-panel.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../ssh/key-panel.vala"
	_data_->self = _tmp0_;
#line 23 "../ssh/key-panel.vala"
	_data_->secret = secret;
#line 23 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_export_co (_data_);
#line 1408 "key-panel.c"
}

static void
seahorse_ssh_key_panel_export_finish (SeahorseSshKeyPanel* self,
                                      GAsyncResult* _res_)
{
	SeahorseSshKeyPanelExportData* _data_;
#line 23 "../ssh/key-panel.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1418 "key-panel.c"
}

static void
seahorse_ssh_key_panel_export_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	SeahorseSshKeyPanelExportData* _data_;
#line 191 "../ssh/key-panel.vala"
	_data_ = _user_data_;
#line 191 "../ssh/key-panel.vala"
	_data_->_source_object_ = source_object;
#line 191 "../ssh/key-panel.vala"
	_data_->_res_ = _res_;
#line 191 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_export_co (_data_);
#line 1435 "key-panel.c"
}

static gboolean
seahorse_ssh_key_panel_export_co (SeahorseSshKeyPanelExportData* _data_)
{
#line 184 "../ssh/key-panel.vala"
	switch (_data_->_state_) {
#line 184 "../ssh/key-panel.vala"
		case 0:
#line 1445 "key-panel.c"
		goto _state_0;
#line 184 "../ssh/key-panel.vala"
		case 1:
#line 1449 "key-panel.c"
		goto _state_1;
#line 184 "../ssh/key-panel.vala"
		case 2:
#line 1453 "key-panel.c"
		goto _state_2;
		default:
#line 184 "../ssh/key-panel.vala"
		g_assert_not_reached ();
#line 1458 "key-panel.c"
	}
	_state_0:
#line 184 "../ssh/key-panel.vala"
	_data_->_tmp0_ = _data_->self->priv->_key;
#line 184 "../ssh/key-panel.vala"
	_vala_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp0_, SEAHORSE_TYPE_EXPORTABLE), "this.key is Exportable", FALSE);
#line 187 "../ssh/key-panel.vala"
	_data_->_tmp1_ = gtk_widget_get_root ((GtkWidget*) _data_->self);
#line 187 "../ssh/key-panel.vala"
	_data_->toplevel = G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp1_, gtk_window_get_type ()) ? ((GtkWindow*) _data_->_tmp1_) : NULL;
#line 189 "../ssh/key-panel.vala"
	_data_->_tmp2_ = _data_->self->priv->_key;
#line 189 "../ssh/key-panel.vala"
	_data_->_tmp3_ = seahorse_ssh_key_export_operation_new (_data_->_tmp2_, _data_->secret);
#line 189 "../ssh/key-panel.vala"
	_data_->export_op = _data_->_tmp3_;
#line 1475 "key-panel.c"
	{
#line 191 "../ssh/key-panel.vala"
		_data_->_tmp4_ = _data_->export_op;
#line 191 "../ssh/key-panel.vala"
		_data_->_tmp5_ = _data_->toplevel;
#line 191 "../ssh/key-panel.vala"
		_data_->_state_ = 1;
#line 191 "../ssh/key-panel.vala"
		seahorse_export_operation_prompt_for_file ((SeahorseExportOperation*) _data_->_tmp4_, _data_->_tmp5_, NULL, seahorse_ssh_key_panel_export_ready, _data_);
#line 191 "../ssh/key-panel.vala"
		return FALSE;
#line 1487 "key-panel.c"
		_state_1:
#line 191 "../ssh/key-panel.vala"
		_data_->prompted = seahorse_export_operation_prompt_for_file_finish ((SeahorseExportOperation*) _data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 191 "../ssh/key-panel.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 191 "../ssh/key-panel.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1495 "key-panel.c"
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
#line 192 "../ssh/key-panel.vala"
		if (!_data_->prompted) {
#line 193 "../ssh/key-panel.vala"
			g_debug ("key-panel.vala:193: no file picked by user");
#line 194 "../ssh/key-panel.vala"
			_g_object_unref0 (_data_->export_op);
#line 194 "../ssh/key-panel.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 194 "../ssh/key-panel.vala"
			if (_data_->_state_ != 0) {
#line 194 "../ssh/key-panel.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 194 "../ssh/key-panel.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1514 "key-panel.c"
				}
			}
#line 194 "../ssh/key-panel.vala"
			g_object_unref (_data_->_async_result);
#line 194 "../ssh/key-panel.vala"
			return FALSE;
#line 1521 "key-panel.c"
		}
#line 197 "../ssh/key-panel.vala"
		_data_->_tmp6_ = _data_->export_op;
#line 197 "../ssh/key-panel.vala"
		_data_->_state_ = 2;
#line 197 "../ssh/key-panel.vala"
		seahorse_export_operation_execute ((SeahorseExportOperation*) _data_->_tmp6_, NULL, seahorse_ssh_key_panel_export_ready, _data_);
#line 197 "../ssh/key-panel.vala"
		return FALSE;
#line 1531 "key-panel.c"
		_state_2:
#line 197 "../ssh/key-panel.vala"
		seahorse_export_operation_execute_finish ((SeahorseExportOperation*) _data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 197 "../ssh/key-panel.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 197 "../ssh/key-panel.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1539 "key-panel.c"
				goto __catch0_g_io_error_cancelled;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_io_error_cancelled:
	{
#line 190 "../ssh/key-panel.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 199 "../ssh/key-panel.vala"
		g_debug ("key-panel.vala:199: Exporting of key cancelled by user");
#line 1552 "key-panel.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 190 "../ssh/key-panel.vala"
		_data_->e = _data_->_inner_error0_;
#line 190 "../ssh/key-panel.vala"
		_data_->_inner_error0_ = NULL;
#line 201 "../ssh/key-panel.vala"
		_data_->_tmp7_ = _data_->toplevel;
#line 201 "../ssh/key-panel.vala"
		_data_->_tmp8_ = _data_->e;
#line 201 "../ssh/key-panel.vala"
		_data_->_tmp9_ = _data_->_tmp8_->message;
#line 201 "../ssh/key-panel.vala"
		seahorse_util_show_error ((GtkWidget*) _data_->_tmp7_, _ ("Couldn’t export key"), _data_->_tmp9_);
#line 190 "../ssh/key-panel.vala"
		_g_error_free0 (_data_->e);
#line 1571 "key-panel.c"
	}
	__finally0:
#line 190 "../ssh/key-panel.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 190 "../ssh/key-panel.vala"
		_g_object_unref0 (_data_->export_op);
#line 190 "../ssh/key-panel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 190 "../ssh/key-panel.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 190 "../ssh/key-panel.vala"
		g_object_unref (_data_->_async_result);
#line 190 "../ssh/key-panel.vala"
		return FALSE;
#line 1586 "key-panel.c"
	}
#line 184 "../ssh/key-panel.vala"
	_g_object_unref0 (_data_->export_op);
#line 184 "../ssh/key-panel.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 184 "../ssh/key-panel.vala"
	if (_data_->_state_ != 0) {
#line 184 "../ssh/key-panel.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 184 "../ssh/key-panel.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1598 "key-panel.c"
		}
	}
#line 184 "../ssh/key-panel.vala"
	g_object_unref (_data_->_async_result);
#line 184 "../ssh/key-panel.vala"
	return FALSE;
#line 1605 "key-panel.c"
}

static void
seahorse_ssh_key_panel_action_copy_public_key (SeahorseSshKeyPanel* self,
                                               GSimpleAction* action,
                                               GVariant* param)
{
	GdkClipboard* _tmp0_;
	SeahorseSshKey* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 205 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 205 "../ssh/key-panel.vala"
	g_return_if_fail (action != NULL);
#line 206 "../ssh/key-panel.vala"
	_tmp0_ = gtk_widget_get_clipboard ((GtkWidget*) self);
#line 206 "../ssh/key-panel.vala"
	_tmp1_ = self->priv->_key;
#line 206 "../ssh/key-panel.vala"
	_tmp2_ = seahorse_ssh_key_get_pubkey (_tmp1_);
#line 206 "../ssh/key-panel.vala"
	_tmp3_ = _tmp2_;
#line 206 "../ssh/key-panel.vala"
	gdk_clipboard_set_text (_tmp0_, _tmp3_);
#line 207 "../ssh/key-panel.vala"
	seahorse_panel_simple_notification ((SeahorsePanel*) self, _ ("Copied public key to clipboard"));
#line 1633 "key-panel.c"
}

static void
seahorse_ssh_key_panel_action_generate_qr_code (SeahorseSshKeyPanel* self,
                                                GSimpleAction* action,
                                                GVariant* param)
{
	SeahorseQrCodeDialog* qr_code_dialog = NULL;
	SeahorseSshKey* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	SeahorseQrCodeDialog* _tmp3_;
	SeahorseSshKey* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkRoot* _tmp7_;
#line 210 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 210 "../ssh/key-panel.vala"
	g_return_if_fail (action != NULL);
#line 211 "../ssh/key-panel.vala"
	_tmp0_ = self->priv->_key;
#line 211 "../ssh/key-panel.vala"
	_tmp1_ = seahorse_ssh_key_get_pubkey (_tmp0_);
#line 211 "../ssh/key-panel.vala"
	_tmp2_ = _tmp1_;
#line 211 "../ssh/key-panel.vala"
	_tmp3_ = seahorse_qr_code_dialog_new (_tmp2_);
#line 211 "../ssh/key-panel.vala"
	g_object_ref_sink (_tmp3_);
#line 211 "../ssh/key-panel.vala"
	qr_code_dialog = _tmp3_;
#line 212 "../ssh/key-panel.vala"
	_tmp4_ = self->priv->_key;
#line 212 "../ssh/key-panel.vala"
	_tmp5_ = seahorse_object_get_label ((SeahorseObject*) _tmp4_);
#line 212 "../ssh/key-panel.vala"
	_tmp6_ = _tmp5_;
#line 212 "../ssh/key-panel.vala"
	adw_dialog_set_title ((AdwDialog*) qr_code_dialog, _tmp6_);
#line 213 "../ssh/key-panel.vala"
	_tmp7_ = gtk_widget_get_root ((GtkWidget*) self);
#line 213 "../ssh/key-panel.vala"
	adw_dialog_present ((AdwDialog*) qr_code_dialog, (GtkWidget*) (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp7_) : NULL));
#line 210 "../ssh/key-panel.vala"
	_g_object_unref0 (qr_code_dialog);
#line 1680 "key-panel.c"
}

SeahorseSshKey*
seahorse_ssh_key_panel_get_key (SeahorseSshKeyPanel* self)
{
	SeahorseSshKey* result;
	SeahorseSshKey* _tmp0_;
#line 25 "../ssh/key-panel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../ssh/key-panel.vala"
	_tmp0_ = self->priv->_key;
#line 25 "../ssh/key-panel.vala"
	result = _tmp0_;
#line 25 "../ssh/key-panel.vala"
	return result;
#line 1696 "key-panel.c"
}

void
seahorse_ssh_key_panel_set_key (SeahorseSshKeyPanel* self,
                                SeahorseSshKey* value)
{
	SeahorseSshKey* old_value;
#line 25 "../ssh/key-panel.vala"
	g_return_if_fail (self != NULL);
#line 25 "../ssh/key-panel.vala"
	old_value = seahorse_ssh_key_panel_get_key (self);
#line 25 "../ssh/key-panel.vala"
	if (old_value != value) {
#line 1710 "key-panel.c"
		SeahorseSshKey* _tmp0_;
#line 25 "../ssh/key-panel.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../ssh/key-panel.vala"
		_g_object_unref0 (self->priv->_key);
#line 25 "../ssh/key-panel.vala"
		self->priv->_key = _tmp0_;
#line 25 "../ssh/key-panel.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_key_panel_properties[SEAHORSE_SSH_KEY_PANEL_KEY_PROPERTY]);
#line 1720 "key-panel.c"
	}
}

static void
_seahorse_ssh_key_panel___lambda15_ (SeahorseSshKeyPanel* self,
                                     GObject* obj,
                                     GParamSpec* pspec)
{
#line 64 "../ssh/key-panel.vala"
	g_return_if_fail (obj != NULL);
#line 64 "../ssh/key-panel.vala"
	g_return_if_fail (pspec != NULL);
#line 64 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_update_ui (self);
#line 1735 "key-panel.c"
}

static void
__seahorse_ssh_key_panel___lambda15__g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 64 "../ssh/key-panel.vala"
	_seahorse_ssh_key_panel___lambda15_ ((SeahorseSshKeyPanel*) self, _sender, pspec);
#line 1745 "key-panel.c"
}

static GObject *
seahorse_ssh_key_panel_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseSshKeyPanel * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	SeahorseSshKey* _tmp4_;
	SeahorseUsage _tmp5_;
	SeahorseUsage _tmp6_;
	SeahorseSshKey* _tmp17_;
#line 50 "../ssh/key-panel.vala"
	parent_class = G_OBJECT_CLASS (seahorse_ssh_key_panel_parent_class);
#line 50 "../ssh/key-panel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "../ssh/key-panel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_KEY_PANEL, SeahorseSshKeyPanel);
#line 51 "../ssh/key-panel.vala"
	_tmp0_ = seahorse_panel_get_actions ((SeahorsePanel*) self);
#line 51 "../ssh/key-panel.vala"
	_tmp1_ = _tmp0_;
#line 51 "../ssh/key-panel.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp1_, SEAHORSE_SSH_KEY_PANEL_ACTIONS, (gint) G_N_ELEMENTS (SEAHORSE_SSH_KEY_PANEL_ACTIONS), self);
#line 52 "../ssh/key-panel.vala"
	_tmp2_ = seahorse_panel_get_actions ((SeahorsePanel*) self);
#line 52 "../ssh/key-panel.vala"
	_tmp3_ = _tmp2_;
#line 52 "../ssh/key-panel.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "panel", (GActionGroup*) _tmp3_);
#line 54 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_update_ui (self);
#line 57 "../ssh/key-panel.vala"
	_tmp4_ = self->priv->_key;
#line 57 "../ssh/key-panel.vala"
	_tmp5_ = seahorse_object_get_usage ((SeahorseObject*) _tmp4_);
#line 57 "../ssh/key-panel.vala"
	_tmp6_ = _tmp5_;
#line 57 "../ssh/key-panel.vala"
	if (_tmp6_ != SEAHORSE_USAGE_PRIVATE_KEY) {
#line 1792 "key-panel.c"
		GSimpleAction* action = NULL;
		GSimpleActionGroup* _tmp7_;
		GSimpleActionGroup* _tmp8_;
		GAction* _tmp9_;
		GSimpleAction* _tmp10_;
		GSimpleAction* _tmp11_;
		GSimpleActionGroup* _tmp12_;
		GSimpleActionGroup* _tmp13_;
		GAction* _tmp14_;
		GSimpleAction* _tmp15_;
		GSimpleAction* _tmp16_;
#line 58 "../ssh/key-panel.vala"
		_tmp7_ = seahorse_panel_get_actions ((SeahorsePanel*) self);
#line 58 "../ssh/key-panel.vala"
		_tmp8_ = _tmp7_;
#line 58 "../ssh/key-panel.vala"
		_tmp9_ = g_action_map_lookup_action ((GActionMap*) _tmp8_, "change-passphrase");
#line 58 "../ssh/key-panel.vala"
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, g_simple_action_get_type (), GSimpleAction));
#line 58 "../ssh/key-panel.vala"
		action = _tmp10_;
#line 59 "../ssh/key-panel.vala"
		_tmp11_ = action;
#line 59 "../ssh/key-panel.vala"
		g_simple_action_set_enabled (_tmp11_, FALSE);
#line 60 "../ssh/key-panel.vala"
		_tmp12_ = seahorse_panel_get_actions ((SeahorsePanel*) self);
#line 60 "../ssh/key-panel.vala"
		_tmp13_ = _tmp12_;
#line 60 "../ssh/key-panel.vala"
		_tmp14_ = g_action_map_lookup_action ((GActionMap*) _tmp13_, "export-secret-key");
#line 60 "../ssh/key-panel.vala"
		_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, g_simple_action_get_type (), GSimpleAction));
#line 60 "../ssh/key-panel.vala"
		_g_object_unref0 (action);
#line 60 "../ssh/key-panel.vala"
		action = _tmp15_;
#line 61 "../ssh/key-panel.vala"
		_tmp16_ = action;
#line 61 "../ssh/key-panel.vala"
		g_simple_action_set_enabled (_tmp16_, FALSE);
#line 57 "../ssh/key-panel.vala"
		_g_object_unref0 (action);
#line 1836 "key-panel.c"
	}
#line 64 "../ssh/key-panel.vala"
	_tmp17_ = self->priv->_key;
#line 64 "../ssh/key-panel.vala"
	g_signal_connect_object ((GObject*) _tmp17_, "notify", (GCallback) __seahorse_ssh_key_panel___lambda15__g_object_notify, self, 0);
#line 50 "../ssh/key-panel.vala"
	return obj;
#line 1844 "key-panel.c"
}

static void
seahorse_ssh_key_panel_class_init (SeahorseSshKeyPanelClass * klass,
                                   gpointer klass_data)
{
#line 23 "../ssh/key-panel.vala"
	seahorse_ssh_key_panel_parent_class = g_type_class_peek_parent (klass);
#line 23 "../ssh/key-panel.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseSshKeyPanel_private_offset);
#line 23 "../ssh/key-panel.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) seahorse_ssh_key_panel_real_dispose;
#line 23 "../ssh/key-panel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_key_panel_get_property;
#line 23 "../ssh/key-panel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_key_panel_set_property;
#line 23 "../ssh/key-panel.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_ssh_key_panel_constructor;
#line 23 "../ssh/key-panel.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_key_panel_finalize;
#line 23 "../ssh/key-panel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_KEY_PANEL_KEY_PROPERTY, seahorse_ssh_key_panel_properties[SEAHORSE_SSH_KEY_PANEL_KEY_PROPERTY] = g_param_spec_object ("key", "key", "key", SEAHORSE_SSH_TYPE_KEY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/ssh-key-panel.ui");
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "comment_row", FALSE, SeahorseSshKeyPanel_private_offset + G_STRUCT_OFFSET (SeahorseSshKeyPanelPrivate, comment_row));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "algo_row", FALSE, SeahorseSshKeyPanel_private_offset + G_STRUCT_OFFSET (SeahorseSshKeyPanelPrivate, algo_row));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_length_row", FALSE, SeahorseSshKeyPanel_private_offset + G_STRUCT_OFFSET (SeahorseSshKeyPanelPrivate, key_length_row));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "location_row", FALSE, SeahorseSshKeyPanel_private_offset + G_STRUCT_OFFSET (SeahorseSshKeyPanelPrivate, location_row));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fingerprint_row", FALSE, SeahorseSshKeyPanel_private_offset + G_STRUCT_OFFSET (SeahorseSshKeyPanelPrivate, fingerprint_row));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pubkey_label", FALSE, SeahorseSshKeyPanel_private_offset + G_STRUCT_OFFSET (SeahorseSshKeyPanelPrivate, pubkey_label));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "trust_check", FALSE, SeahorseSshKeyPanel_private_offset + G_STRUCT_OFFSET (SeahorseSshKeyPanelPrivate, trust_check));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_ssh_comment_apply", G_CALLBACK(_seahorse_ssh_key_panel_on_ssh_comment_apply_adw_entry_row_apply));
#line 23 "../ssh/key-panel.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_ssh_trust_changed", G_CALLBACK(_seahorse_ssh_key_panel_on_ssh_trust_changed_g_object_notify));
#line 1887 "key-panel.c"
}

static void
seahorse_ssh_key_panel_instance_init (SeahorseSshKeyPanel * self,
                                      gpointer klass)
{
#line 23 "../ssh/key-panel.vala"
	self->priv = seahorse_ssh_key_panel_get_instance_private (self);
#line 28 "../ssh/key-panel.vala"
	self->priv->updating_ui = FALSE;
#line 23 "../ssh/key-panel.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1900 "key-panel.c"
}

static void
seahorse_ssh_key_panel_finalize (GObject * obj)
{
	SeahorseSshKeyPanel * self;
#line 23 "../ssh/key-panel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_KEY_PANEL, SeahorseSshKeyPanel);
#line 25 "../ssh/key-panel.vala"
	_g_object_unref0 (self->priv->_key);
#line 23 "../ssh/key-panel.vala"
	G_OBJECT_CLASS (seahorse_ssh_key_panel_parent_class)->finalize (obj);
#line 1913 "key-panel.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_ssh_key_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshKeyPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_key_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshKeyPanel), 0, (GInstanceInitFunc) seahorse_ssh_key_panel_instance_init, NULL };
	GType seahorse_ssh_key_panel_type_id;
	seahorse_ssh_key_panel_type_id = g_type_register_static (SEAHORSE_TYPE_PANEL, "SeahorseSshKeyPanel", &g_define_type_info, 0);
	SeahorseSshKeyPanel_private_offset = g_type_add_instance_private (seahorse_ssh_key_panel_type_id, sizeof (SeahorseSshKeyPanelPrivate));
	return seahorse_ssh_key_panel_type_id;
}

GType
seahorse_ssh_key_panel_get_type (void)
{
	static gsize seahorse_ssh_key_panel_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_key_panel_type_id__once)) {
		GType seahorse_ssh_key_panel_type_id;
		seahorse_ssh_key_panel_type_id = seahorse_ssh_key_panel_get_type_once ();
		g_once_init_leave (&seahorse_ssh_key_panel_type_id__once, seahorse_ssh_key_panel_type_id);
	}
	return seahorse_ssh_key_panel_type_id__once;
}

static void
_vala_seahorse_ssh_key_panel_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	SeahorseSshKeyPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_KEY_PANEL, SeahorseSshKeyPanel);
#line 23 "../ssh/key-panel.vala"
	switch (property_id) {
#line 23 "../ssh/key-panel.vala"
		case SEAHORSE_SSH_KEY_PANEL_KEY_PROPERTY:
#line 23 "../ssh/key-panel.vala"
		g_value_set_object (value, seahorse_ssh_key_panel_get_key (self));
#line 23 "../ssh/key-panel.vala"
		break;
#line 1954 "key-panel.c"
		default:
#line 23 "../ssh/key-panel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../ssh/key-panel.vala"
		break;
#line 1960 "key-panel.c"
	}
}

static void
_vala_seahorse_ssh_key_panel_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	SeahorseSshKeyPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_KEY_PANEL, SeahorseSshKeyPanel);
#line 23 "../ssh/key-panel.vala"
	switch (property_id) {
#line 23 "../ssh/key-panel.vala"
		case SEAHORSE_SSH_KEY_PANEL_KEY_PROPERTY:
#line 23 "../ssh/key-panel.vala"
		seahorse_ssh_key_panel_set_key (self, g_value_get_object (value));
#line 23 "../ssh/key-panel.vala"
		break;
#line 1980 "key-panel.c"
		default:
#line 23 "../ssh/key-panel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../ssh/key-panel.vala"
		break;
#line 1986 "key-panel.c"
	}
}

